/*
 * This file belongs to the XQuark distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquark.org.
 */

package org.xquark.extractor;

import java.util.Map;
import java.util.Properties;

import org.xquark.extractor.metadata.MetaDataManager;
import org.xquark.xquery.metadata.MetaDataImpl;
/**
 * Configuration for an extractor data source.
 */
public class Configuration {
    private static final String RCSRevision = "$Revision: 1.3 $";
    private static final String RCSName     = "$Name:  $";
    
	/** The configuration's datasource address */
	XMLDBCUri uri;
    /** Properties loaded from configuration file or default (e.g. Case*/
    Properties properties;
	/** Holds relational metadata filtered by selection and creates @link Configuration#metaDataForParser */
	MetaDataManager metaDataManager;
    /** Holds XQuery and XDBC metadata (schema and paths) */
    MetaDataImpl metaDataForParser;
    /** The filter applied on database objects */
    Selection selection;
    
    /** XQuery views (stored XQuery queries) */
    Map viewDefinitions;

    Configuration() {}
}
