/*
 * This file belongs to the XQuark distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquark.org.
 */

package org.xquark.extractor.algebra;

import java.util.Collections;
import java.util.List;
import java.util.Set;

import org.xquark.extractor.common.Trace;

public abstract class BinaryAlgebra extends BinaryOperator implements Relation
{
    private static final String RCSRevision = "$Revision: 1.3 $";
    private static final String RCSName     = "$Name:  $";

    List _keys;

    Set _providedTableInstance = Collections.singleton(this);
    /**
    @param leftOperand
    @param rightOperand
    @roseuid 3B2787B800B5
     */
    public BinaryAlgebra(Expression leftOperand, Expression rightOperand)
    {
        super (leftOperand,rightOperand);
    }

    public Set providedTableInstances() {
        return _providedTableInstance;
    };

	public AttributeExpression findNonNullAttribute() {
		AttributeExpression ret = ((Relation)_leftOperand).findNonNullAttribute();
		if (ret == null)
			ret = ((Relation)_rightOperand).findNonNullAttribute();	// QUESTION: is it necessary. Relation should not be identical ?
		return ret;
	}

    /**
    @return java.util.List
    @roseuid 3B27976E0207
     */
    public List getItems()
    {
     return null;
    }

//    /**
//    @return java.util.List
//    @roseuid 3B27976E0261
//     */
//    public List provideKeys()
//    {
//     return null;
//    }

    public List getKeys()
    {
        return _keys;
    }
    /**
    @param name
    @return List
    @roseuid 3BD1356202B3
     */
    public List nameTest(String name)
    {
        // this default implementation is for Union,Difference,Intersect and Merge.
        // OuterJoin should override this function.
        Trace.enter( this , "NameTest");

        List retVal = ((Relation)getLeftOperand()).nameTest(name);

        Trace.exit( this , "NameTest");
        return retVal;
    }


    public boolean replaceChild(Expression oldChild, Expression newChild)
    {
         Trace.enter(this, "replaceChild(Expression oldChild, Expression newChild)");
        /* implementation for Merge, Union, Intersect and Difference, but not for OuterJoin */
        boolean retVal = false;
        if (getLeftOperand() == oldChild) {
            setLeftOperand(newChild);
            retVal = true;
        }
        else if (getRightOperand()== oldChild) {
            setRightOperand(newChild);
            retVal = true;
        }

        Trace.exit(this, "replaceChild(Expression oldChild, Expression newChild)");
        return retVal;
    }

}
