/*
 * This file belongs to the XQuark distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquark.org.
 */

package org.xquark.extractor.algebra;

import java.util.List;

import org.xquark.extractor.common.SqlWrapperException;
import org.xquark.extractor.sql.SqlExpression;
// TODO: not used ?
public final class OuterJoinPredicate extends Expression
{

    private static final String RCSRevision = "$Revision: 1.3 $";
    private static final String RCSName     = "$Name:  $";

    protected RenameRelation _outerTable;
    protected Expression _predicate;

    /**
    @roseuid 3BD17CA900A8
     */
    public OuterJoinPredicate()
    {

    }

    /**
    @param predicate
    @param outerTable
    @roseuid 3BD17C1F02BC
     */
    public OuterJoinPredicate(Expression predicate, RenameRelation outerTable)
    {
        setPredicate (predicate);
        setOuterTable (outerTable);
    }

    /**
    Access method for the _outerTable property.

    @return   the current value of the _outerTable property
     */
    public RenameRelation getOuterTable()
    {
        return _outerTable;
    }

    public List getOperands()
    {
        return null;
    }

    /**
    Sets the value of the _outerTable property.

    @param aOuterTable the new value of the _outerTable property
     */
    public void setOuterTable(RenameRelation aOuterTable)
    {
        _outerTable = aOuterTable;
    }

    /**
    Access method for the _predicate property.

    @return   the current value of the _predicate property
     */
    public Expression getPredicate()
    {
        return _predicate;
    }

    /**
    Sets the value of the _predicate property.

    @param aPredicate the new value of the _predicate property
     */
    public void setPredicate(Expression aPredicate)
    {
        _predicate = aPredicate;
    }

    public SqlExpression accept (GenSqlVisitor visitor) throws SqlWrapperException
    {
        return visitor.visit(this);
    }

    /**
    @param visitor
    @roseuid 3BD17E0D02E4
     */
    public void accept (AlgebraVisitor visitor) throws SqlWrapperException
    {
        visitor.visit(this);
    }

	/**
	 * @see Expression#deepEquals(Object)
	 */
	public boolean deepEquals(Object o)
	{
		if (o instanceof OuterJoinPredicate)
		{
			OuterJoinPredicate cast = (OuterJoinPredicate)o;
			return	 _outerTable.deepEquals(cast.getOuterTable())
						&& _predicate.deepEquals(cast.getPredicate());
		}
		return false;
	}
}
