/*
 * This file belongs to the XQuark distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquark.org.
 */

package org.xquark.extractor.algebra;

import java.util.List;

import org.xquark.extractor.common.SqlWrapperException;
import org.xquark.extractor.sql.SqlExpression;

/**
 *
 * A Temporary table used for intermediate result storage. This object may be
 * created with or without table specification. If missing table specification
 * will be deduced from operand relation. 
 * 
 * NOTE: Not used up to now : the problem is fixed during generation.
 */

// TODO: Reset temp table counter at every query (No drop needed 4 MySQL but a least a truncate)
// TODO: Remove ?
public final class TempTable extends UnaryAlgebra
{

    private static final String RCSRevision = "$Revision: 1.3 $";
    private static final String RCSName     = "$Name:  $";

	protected org.xquark.extractor.metadata.Table _table;


	public TempTable(org.xquark.extractor.metadata.Table mTable) {
		_table = mTable;
	}
	
	public TempTable(String name) {
		// TODO: build a metadata object from the operand: not necessary for DBMS
		// supporting CREATE TABLE AS... But not so easy to realize: should add a
		// method to Relation interface to retrieve item list
		this(new org.xquark.extractor.metadata.Table(name));
	}

	public SqlExpression accept (GenSqlVisitor visitor) throws SqlWrapperException
	{
		return visitor.visit(this);
	}

	public void accept (AlgebraVisitor visitor) throws SqlWrapperException
	{
		visitor.visit(this);
	}

	public String getName()
	{
		return _table.getName();
	}

	public List getKeys() {
		return _keys;
	}
}
