/*
 * This file belongs to the XQuark distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquark.org.
 */

package org.xquark.extractor.algebra;

import java.util.List;

import org.xquark.extractor.common.SqlWrapperException;
import org.xquark.extractor.sql.SqlExpression;

public final class UnOpAggregate extends UnOpProject
{

    private static final String RCSRevision = "$Revision: 1.4 $";
    private static final String RCSName     = "$Name:  $";


    public UnOpAggregate() {
        super();
    }
    /**
    @param operand
    @param item
    @roseuid 3B2787E80154
     */
    public UnOpAggregate(Expression operand, Expression item)  {
        super(  operand , item  );
    }

    /**
    @param operand
    @param itemList
    @param distinct
    @roseuid 3B2787E70370
     */
    public UnOpAggregate(Expression operand, List itemList, boolean distinct)  {
        super (  operand, itemList, distinct  );
    }

    public SqlExpression accept (GenSqlVisitor visitor) throws SqlWrapperException
    {
        return visitor.visit(this);
    }

	public boolean equals(Object obj) {
		/** @todo  */
		if (null == obj) {
			return false;
		}

		if (obj instanceof UnOpAggregate ) {
			return true;
		}
		else {
			return false;
		}
	}

	public int hashCode() {
		String name = getOrginalXExpr().toSimpleString();
		return name.hashCode();
	}

    public void accept (AlgebraVisitor visitor) throws SqlWrapperException
    {
        visitor.visit(this);
    }

    void distinctAggregation() {
        List itemList = getItemList();
        Expression item = null;
        for (int i = 0; i < itemList.size(); i++) {
            item = (Expression)itemList.get(i);
            item.accept( new DefaultSimpleVisitor() {
                    public void visit(FunAggregate arg)
                    { arg.setDistinct(true);  }
                    }
                );
        }
    }
}
