/*
 * This file belongs to the XQuark distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquark.org.
 */

package org.xquark.extractor.algebra;

import java.util.List;
import java.util.Set;

import org.xquark.extractor.common.Trace;

public abstract class UnaryAlgebra extends UnaryOperator implements Relation
{

    private static final String RCSRevision = "$Revision: 1.3 $";
    private static final String RCSName     = "$Name:  $";


	protected List _keys = null;

    public UnaryAlgebra()
    {
    }
    /**
    @param operand
    @roseuid 3BD175FA0320
     */
    public UnaryAlgebra(Expression operand)
    {
        super (operand);
    }

//    synchronized Object clone(Map clonedExprs) throws CloneNotSupportedException
//    {
//        Trace.enter(this, "clone(Map clonedExprs)");
//        clonedExpr.put(this, retVal);Trace.exit(this, "clone(Map clonedExprs)");return retVal;
//        return  super.clone();
//    }

    public List getParameterList()	// TODO: check use
    {
        return null;
    }

    public Set providedTableInstances(){
        /* default implemetion for group, sort, restrict .
        * aggregate project should overide this implementation */
        return visibleTableInstances();
    }

    public Set visibleTableInstances() {
        return ((Relation)getOperand()).providedTableInstances();
    }
    
	public AttributeExpression findNonNullAttribute() {
		return ((Relation)getOperand()).findNonNullAttribute();
	}

    public Mapper getMapper()
    {
        Trace.enter(this, "getMapper()");
        Mapper retVal = null;
        if (null == _mapper) {
            retVal = getOperand().getMapper();
        }
        else {
            retVal = _mapper;
        }

        Trace.exit(this, "getMapper()");
        return retVal;

    }

//    /**
//    @return java.util.List
//    @roseuid 3B2793B40291
//     */
//    public List provideKeys()
//    {
//     return null;
//    }
    abstract public List getKeys();

	public void setKeys(List keys) {
		_keys = keys;
	}


    public List nameTest(String name)
    {
        // this default implementation is for UnOpRestrict,UnOpSort,UnOpGroup,RenameRelation.
        // UnOpProject, UnOpAggregate should override this function.
        Trace.enter( this , "NameTest");
        Relation  oprnd = (Relation)getOperand();
        List retVal = oprnd.nameTest(name);
        Trace.exit( this , "NameTest");
        return retVal;
    }
}
