/*
 * This file belongs to the XQuark distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquark.org.
 */

package org.xquark.extractor.algebra;

import org.xquark.extractor.common.SqlWrapperException;
import org.xquark.extractor.common.Trace;

/* yu can copy this class when u create new visitor*/
public abstract class VisitorTemplate extends DefaultAlgebraVisitor {
    private static final String RCSRevision = "$Revision: 1.3 $";
    private static final String RCSName     = "$Name:  $";


    public void visit(Expression arg) throws SqlWrapperException {
        Trace.enter(this,"visit(Expression arg)",arg.pprint());
        Trace.exit(this,"visit(Expression arg)",arg.pprint());
    }

    public void visit(Attribute arg) throws SqlWrapperException {
        Trace.enter(this,"visit(Attribute arg)",arg.pprint());
        Trace.exit(this,"visit(Attribute arg)",arg.pprint());
    }

    public void visit(AttributeExpression arg) throws SqlWrapperException {
        Trace.enter(this,"visit(AttributeExpression arg)",arg.pprint());
        Trace.exit(this,"visit(AttributeExpression arg)",arg.pprint());
    }

    public void visit(BinaryOperator arg) throws SqlWrapperException {
        Trace.enter(this,"visit(BinaryOperator arg)",arg.pprint());
        Trace.exit(this,"visit(BinaryOperator arg)",arg.pprint());
    }

    public void visit(BinaryAtomicOp arg) throws SqlWrapperException {
        Trace.enter(this,"visit(BinaryAtomicOp arg)",arg.pprint());
        Trace.exit(this,"visit(BinaryAtomicOp arg)",arg.pprint());
    }

    public void visit(BinaryAlgebra arg) throws SqlWrapperException {
        Trace.enter(this,"visit(BinaryAlgebra arg)",arg.pprint());
        Trace.exit(this,"visit(BinaryAlgebra arg)",arg.pprint());
    }

    public void visit(BinOpArithmetic arg) throws SqlWrapperException {
        Trace.enter(this,"visit(BinOpArithmetic arg)",arg.pprint());
        Trace.exit(this,"visit(BinOpArithmetic arg)",arg.pprint());
    }

    public void visit(BinOpBoolean arg) throws SqlWrapperException {
        Trace.enter(this,"visit(BinOpBoolean arg)",arg.pprint());
        Trace.exit(this,"visit(BinOpBoolean arg)",arg.pprint());
    }

    public void visit(BinOpCompare arg) throws SqlWrapperException {
        Trace.enter(this,"visit(BinOpCompare arg)",arg.pprint());
        Trace.exit(this,"visit(BinOpCompare arg)",arg.pprint());
    }

    public void visit(BinOpCompareAny arg) throws SqlWrapperException {
        Trace.enter(this,"visit(BinOpCompareAny arg)",arg.pprint());
        Trace.exit(this,"visit(BinOpCompareAny arg)",arg.pprint());
    }

    public void visit(BinOpDifference arg) throws SqlWrapperException {
        Trace.enter(this,"visit(BinOpDifference arg)",arg.pprint());
        Trace.exit(this,"visit(BinOpDifference arg)",arg.pprint());
    }

    public void visit(BinOpIntersect arg) throws SqlWrapperException {
        Trace.enter(this,"visit(BinOpIntersect arg)",arg.pprint());
        Trace.exit(this,"visit(BinOpIntersect arg)",arg.pprint());
    }

    public void visit(BinOpMerge arg) throws SqlWrapperException {
        Trace.enter(this,"visit(BinOpMerge arg)",arg.pprint());
        Trace.exit(this,"visit(BinOpMerge arg)",arg.pprint());
    }

    public void visit(BinOpOuterJoin arg) throws SqlWrapperException {
        Trace.enter(this,"visit(BinOpOuterJoin arg)",arg.pprint());
        Trace.exit(this,"visit(BinOpOuterJoin arg)",arg.pprint());
    }

    public void visit(BinOpUnion arg) throws SqlWrapperException {
        Trace.enter(this,"visit(BinOpUnion arg)",arg.pprint());
        Trace.exit(this,"visit(BinOpUnion arg)",arg.pprint());
    }

    public void visit(FunAggregate arg) throws SqlWrapperException {
        Trace.enter(this,"visit(FunAggregate arg)",arg.pprint());
        Trace.exit(this,"visit(FunAggregate arg)",arg.pprint());
    }

    public void visit(IfThenElse arg) throws SqlWrapperException {
        Trace.enter(this,"visit(IfThenElse arg)",arg.pprint());
        Trace.exit(this,"visit(IfThenElse arg)",arg.pprint());
    }

    public void visit(Join arg) throws SqlWrapperException {
        Trace.enter(this,"visit(Join arg)",arg.pprint());
        Trace.exit(this,"visit(Join arg)",arg.pprint());
    }

    public void visit(Literal arg) throws SqlWrapperException {
        Trace.enter(this,"visit(Literal arg)",arg.pprint());
        Trace.exit(this,"visit(Literal arg)",arg.pprint());
    }

    public void visit(LitBoolean arg) throws SqlWrapperException {
        Trace.enter(this,"visit(LitBoolean arg)",arg.pprint());
        Trace.exit(this,"visit(LitBoolean arg)",arg.pprint());
    }

    public void visit(LitDate arg) throws SqlWrapperException {
        Trace.enter(this,"visit(LitDate arg)",arg.pprint());
        Trace.exit(this,"visit(LitDate arg)",arg.pprint());
    }

    public void visit(LitDouble arg) throws SqlWrapperException {
        Trace.enter(this,"visit(LitDouble arg)",arg.pprint());
        Trace.exit(this,"visit(LitDouble arg)",arg.pprint());
    }

    public void visit(LitFloat arg) throws SqlWrapperException {
        Trace.enter(this,"visit(LitFloat arg)",arg.pprint());
        Trace.exit(this,"visit(LitFloat arg)",arg.pprint());
    }

    public void visit(LitInteger arg) throws SqlWrapperException {
        Trace.enter(this,"visit(LitInteger arg)",arg.pprint());
        Trace.exit(this,"visit(LitInteger arg)",arg.pprint());
    }

    public void visit(LitString arg) throws SqlWrapperException {
        Trace.enter(this,"visit(LitString arg)",arg.pprint());
        Trace.exit(this,"visit(LitString arg)",arg.pprint());
    }

    public void visit(RenameItem arg) throws SqlWrapperException {
        Trace.enter(this,"visit(RenameItem arg)",arg.pprint());
        Trace.exit(this,"visit(RenameItem arg)",arg.pprint());
    }

    public void visit(RenameRelation arg) throws SqlWrapperException {
        Trace.enter(this,"visit(RenameRelation arg)",arg.pprint());
        Trace.exit(this,"visit(RenameRelation arg)",arg.pprint());
    }

    public void visit(SortSpecification arg) throws SqlWrapperException {
        Trace.enter(this,"visit(SortSpecification arg)",arg.pprint());
        Trace.exit(this,"visit(SortSpecification arg)",arg.pprint());
    }

    public void visit(Table arg) throws SqlWrapperException {
        Trace.enter(this,"visit(Table arg)",arg.pprint());
        Trace.exit(this,"visit(Table arg)",arg.pprint());
    }

    public void visit(UnaryOperator arg) throws SqlWrapperException {
        Trace.enter(this,"visit(UnaryOperator arg)",arg.pprint());
        Trace.exit(this,"visit(UnaryOperator arg)",arg.pprint());
    }

    public void visit(UnaryAlgebra arg) throws SqlWrapperException {
        Trace.enter(this,"visit(UnaryAlgebra arg)",arg.pprint());
        Trace.exit(this,"visit(UnaryAlgebra arg)",arg.pprint());
    }

    public void visit(UnaryAtomicOp arg) throws SqlWrapperException {
        Trace.enter(this,"visit(UnaryAtomicOp arg)",arg.pprint());
        Trace.exit(this,"visit(UnaryAtomicOp arg)",arg.pprint());
    }

    public void visit(UnOpAggregate arg) throws SqlWrapperException {
        Trace.enter(this,"visit(UnaryAtomicOp arg)",arg.pprint());
        Trace.exit(this,"visit(UnaryAtomicOp arg)",arg.pprint());
    }

    public void visit(UnOpExists arg) throws SqlWrapperException {
        Trace.enter(this,"visit(UnOpExists arg)",arg.pprint());
        Trace.exit(this,"visit(UnOpExists arg)",arg.pprint());
    }

    public void visit(UnOpGroup arg) throws SqlWrapperException {
        Trace.enter(this,"visit(UnOpGroup arg)",arg.pprint());
        Trace.exit(this,"visit(UnOpGroup arg)",arg.pprint());
    }

    public void visit(UnOpMinus arg) throws SqlWrapperException {
        Trace.enter(this,"visit(UnOpMinus arg)",arg.pprint());
        Trace.exit(this,"visit(UnOpMinus arg)",arg.pprint());
    }

    public void visit(UnOpNot arg) throws SqlWrapperException {
        Trace.enter(this,"visit(UnOpNot arg)",arg.pprint());
        Trace.exit(this,"visit(UnOpNot arg)",arg.pprint());
    }

    public void visit(UnOpProject arg) throws SqlWrapperException {
        Trace.enter(this,"visit(UnOpProject arg)",arg.pprint());
        Trace.exit(this,"visit(UnOpProject arg)",arg.pprint());
    }

    public void visit(UnOpRestrict arg) throws SqlWrapperException {
        Trace.enter(this,"visit(UnOpRestrict arg)",arg.pprint());
        Trace.exit(this,"visit(UnOpRestrict arg)",arg.pprint());
    }

    public void visit(UnOpSort arg) throws SqlWrapperException {
        Trace.enter(this,"visit(UnOpSort arg)",arg.pprint());
        Trace.exit(this,"visit(UnOpSort arg)",arg.pprint());
    }

}
