/*
 * This file belongs to the XQuark distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquark.org.
 */

package org.xquark.extractor.metadata;


public class Attribute extends NamedNode
{

	private static final String RCSRevision = "$Revision: 1.3 $";
	private static final String RCSName     = "$Name:  $";


	private boolean _nullable;
	private DataType _type;

   /**
   @param name
   @roseuid 3B278EE3000C
    */
   public Attribute(String name) {
        super (name);
        _alias = name;
   }

   public Attribute(String name, String alias)
   {
        super (name);
        setAlias(alias);
   }

   /**
   Determines if the _nullable property is true.

   @return   <code>true<code> if the _nullable property is true
    */
   public boolean getNullable()
   {
      return _nullable;
   }

   /**
   Sets the value of the _nullable property.

   @param aNullable the new value of the _nullable property
    */
   public void setNullable(boolean aNullable)
   {
      _nullable = aNullable;
   }

   /**
   @return org.xquark.extractor.metadata.DbPrimitiveType
   @roseuid 3B279390034C
    */
   public DataType getType()
   {
        return _type;
   }

   /**
   @param type
   @roseuid 3B2794C301EF
    */
   public void setType(DataType type)
   {
        _type = type;
   }


    public String getFullName() {
        StringBuffer retVal = new StringBuffer();
        String name = null;

        name = getFather().getFather().getFather().getName();
        if (null != name) {
            retVal.append(name);
            retVal.append('.');
        }

        name = getFather().getFather().getName();
        if (null != name) {
            retVal.append(name);
            retVal.append('.');
        }

        name = getFather().getName();
        if (null != name) {
            retVal.append(name);
            retVal.append('.');
        }

        retVal.append(_name);
        return retVal.toString();
    }


    public String pprint()
    {
        StringBuffer    retVal = new StringBuffer();

        String newLine = System.getProperty("line.separator");
        retVal.append(_name);
		retVal.append(" : ");
		retVal.append(_type.pprint());

        return retVal.toString();
    }
}
