/*
 * This file belongs to the XQuark distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquark.org.
 */

package org.xquark.extractor.metadata;

import org.xquark.extractor.common.Trace;


    /**
    private String [] type_names ={"CHAR","VARCHAR", "LONGVARCHAR",
    "NUMERIC","DECIMAL","BIT","TINYINT","SMALLINT","INTEGER","BIGINT","REAL",
    "FLOAT","DOUBLE",
    "BINARY","VARBINARY","LONGVARBINARY",
    "DATE","TIME","TIMESTAMP"};
    @return java.lang.Object
    @roseuid 3B2798BF00B5
     */

public  abstract class DataType implements Cloneable
{

	private static final String RCSRevision = "$Revision: 1.3 $";
	private static final String RCSName     = "$Name:  $";


	/** @todo  */
	public int length = 0;
	public int scale = 0;


    public Object clone () throws CloneNotSupportedException
    {
        return super.clone();
    };

    public abstract String getName();

    public abstract DbPrimitiveType getPrimitiveType();

    public abstract int getPrimitiveTypeCode();

    public abstract boolean isPrimitive();

    public abstract boolean isUdt ();

    public  abstract boolean isNumeric();

    public  abstract boolean isDecimal();

    public  abstract boolean isInteger();

    public  abstract boolean isString();

    public  abstract boolean isNull();

    public  abstract boolean isDataTime();

    public abstract String pprint();

    public boolean isCompatibleTo(DataType type)
    {
        Trace.error(this,"isCompatibleTo","NIY!");
        return true;
    }
}
