/*
 * This file belongs to the XQuark distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquark.org.
 */

package org.xquark.extractor.metadata;

import java.util.ArrayList;
import java.util.List;

public class Table extends NamedNode
{

	private static final String RCSRevision = "$Revision: 1.3 $";
	private static final String RCSName     = "$Name:  $";


    public static final int TABLE = 0;
    public static final int VIEW = 1;
    public static final int SYNONYM = 1;

    protected int _type;
   protected List _keys;


   /**
   @roseuid 3B278EF20158
    */
   public Table()
   {

   }

   /**
   @param name
   @roseuid 3B278EF20180
    */
   public Table(String name)
   {
        super (name);
        _alias = name;
   }

   public Table(String name, String alias)
   {
        super (name);
        _alias = alias;
   }

   /**
   @param key
   @roseuid 3B278EF20298
    */
   public void addKey(Attribute key)
   {
        if (null == _keys) {
            _keys = new ArrayList();
        }
        List list = new ArrayList ();
        list.add(key);
        _keys.add(list);
        return ;
   }

   public void addKey(List key)
   {
        if (null == _keys) {
            _keys = new ArrayList();
        }
        _keys.add(key);
        return ;
   }

   /**
   @param keys
   @roseuid 3B278EF202F2
    */
   public void setKeys(List keys)
   {
        _keys = keys;
   }

   /**
   @return org.xquark.xqueryparser.xquery.List
   @roseuid 3B278EF20360
    */
   public List getKeys()
   {
        return _keys;
   }

   public Attribute findAttribute(String attributeName){
        String str = attributeName.toLowerCase() ;
        Attribute  retVal = (Attribute) findChild(attributeName) ;
        return retVal ;
    }

    public int getType() {  return _type; }

    public void setType(int type) { _type = type;}

//    public String getFullName() {
//        StringBuffer retVal = new StringBuffer();
//        String name = null;
//        name = getFather().getFather().getName();
//        if (null != name) {
//            retVal.append(name);
//            retVal.append('.');
//        }
//
//        name = getFather().getName();
//        if (null != name) {
//            retVal.append(name);
//            retVal.append('.');
//        }
//
//        retVal.append(_name);
//        return retVal.toString();
//    }

    public String pprint()
    {
        StringBuffer    retVal = new StringBuffer();

        String newLine = System.getProperty("line.separator");

        retVal.append("---------- Table : ");
        retVal.append(_name);
        retVal.append(" ----------");
        retVal.append(newLine);

        for (int i = 0; i < _children.size(); i++) {
            retVal.append(((NamedNode)_children.get(i)).pprint());
            retVal.append(newLine);
        }
        return retVal.toString();
    }

}

/*
Table.load(DatabaseMetaData,String,String,String){
        Table   table   = new Table (tableName) ;
        Column  column  = null ;
        ResultSet  resultSet = null ;
        String str = null ;
        try {
            resultSet = _databaseMetaData.getColumns(catalogName , schemaName,tableName,null );
            while (resultSet.next()) {
//                TABLE_CAT, 	TABLE_SCHEM, 	TABLE_NAME, 	COLUMN_NAME, 	DATA_TYPE, 	TYPE_NAME,
//                COLUMN_SIZE, 	BUFFER_LENGTH, 	DECIMAL_DIGITS, 	NUM_PREC_RADIX, 	NULLABLE,
//                REMARKS, 	COLUMN_DEF, 	SQL_DATA_TYPE, 	SQL_DATETIME_SUB, 	CHAR_OCTET_LENGTH,
//                ORDINAL_POSITION, 	IS_NULLABLE, 	SS_DATA_TYPE
                column = new Column () ;
                str = resultSet.getString ( "COLUMN_NAME");
                str = str.toLowerCase() ;
                column.setName(str);
                table.addColumn ( column );
            }
            resultSet = _databaseMetaData.getPrimaryKeys(catalogName , schemaName,tableName );
            while (resultSet.next()) {
//                TABLE_CAT, 	TABLE_SCHEM, 	TABLE_NAME, 	COLUMN_NAME, 	DATA_TYPE, 	TYPE_NAME,
//                COLUMN_SIZE, 	BUFFER_LENGTH, 	DECIMAL_DIGITS, 	NUM_PREC_RADIX, 	NULLABLE,
//                REMARKS, 	COLUMN_DEF, 	SQL_DATA_TYPE, 	SQL_DATETIME_SUB, 	CHAR_OCTET_LENGTH,
//                ORDINAL_POSITION, 	IS_NULLABLE, 	SS_DATA_TYPE
                str = resultSet.getString ( "COLUMN_NAME");
                str = str.toLowerCase() ;
                column=table.findColumn(str);
                table.addKey ( column );
            }
        }
        catch (Exception ex) {
            ex.printStackTrace();
        }
        return table ;
    }

Table.setName(String){
        _name = aName;
    }




 */
