/*
 * This file belongs to the XQuark distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquark.org.
 */

package org.xquark.extractor.progress;


import java.sql.Connection;
import java.sql.DatabaseMetaData;
import java.sql.ResultSet;
import java.util.ArrayList;
import java.util.List;

import org.xquark.extractor.Selection;
import org.xquark.extractor.common.MetaDataException;
import org.xquark.extractor.common.Trace;
import org.xquark.extractor.metadata.NamedNode;
import org.xquark.extractor.metadata.QNameEncoder;
import org.xquark.extractor.metadata.Site;

public  class Loader extends org.xquark.extractor.metadata.Loader {

	private static final String RCSRevision = "$Revision: 1.4 $";
	private static final String RCSName     = "$Name:  $";



    public Loader() {
        super();
    }
	public Loader( DatabaseMetaData databaseMetaData ) {
		super(databaseMetaData);
	}

        public void setConnection(Connection connection) { _connection = connection; }

	public void setEncoder(QNameEncoder encoder) { _encoder = encoder; }

	public DatabaseMetaData getDatabaseMetaData() {
		return _databaseMetaData;
	}

	public void setDatabaseMetaData(DatabaseMetaData aDatabaseMetaData) {
		_databaseMetaData = aDatabaseMetaData;
	}

	public Site loadSite(Selection selection, boolean hasQuotes) throws MetaDataException {
		Trace.enter( this,"loadSite(Selection selection)" );

        Site retVal = new Site(null);

        List children = new ArrayList();
        List subSelections = new ArrayList();

		NamedNode  catalog = null ;
		ResultSet  resultSet = null ;
		String name = null ;
		_nameSpaces.clear();

            children.add(null);
            Selection subSelection = selection.includesSubElement(null);
            subSelections.add(subSelection);

            for (int i = 0; i < children.size(); i++) {
                String child = (String)children.get(i);
                subSelection = (Selection)subSelections.get(i);
                retVal.addChild(loadCatalog(child, subSelection, hasQuotes));
            }


		Trace.exit( this,"loadSite(Selection selection)" );
		return retVal;
	}
}

