/*
 * This file belongs to the XQuark distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquark.org.
 */

package org.xquark.extractor.progress;

import java.util.List;

import org.xquark.extractor.metadata.DbPrimitiveType;
import org.xquark.extractor.sql.*;

public class ProgressFactory extends DefaultSqlFactory {
	private static final String RCSRevision = "$Revision: 1.3 $";
	private static final String RCSName     = "$Name:  $";

	static private ProgressFactory _instance = null;

	private ProgressFactory() {
	}

	static public ProgressFactory getInstance(){
		if (null ==_instance) {
			_instance = new ProgressFactory();
		}
		return _instance;
	}

	public SqlConvert createConvert() {
		return new org.xquark.extractor.progress.sql.SqlConvert();
	}

	public SqlConvert createConvert(SqlExpression expr, DbPrimitiveType originalType, DbPrimitiveType targetType){
		return new org.xquark.extractor.progress.sql.SqlConvert(expr, originalType, targetType);
	}

	public SqlUnOpIsNull createUnOpIsNull() {
		return new org.xquark.extractor.progress.sql.SqlUnOpIsNull();
	}

	public SqlUnOpIsNull createUnOpIsNull(SqlExpression expr, boolean notIsNull) {
		return new org.xquark.extractor.progress.sql.SqlUnOpIsNull(expr, notIsNull);
	}

	public SqlTable createTable() {
		return new org.xquark.extractor.progress.sql.SqlTable();
	}

	public SqlTable createTable(String name) {
		return new org.xquark.extractor.progress.sql.SqlTable(name);
	}


	public SqlTable createTable(String catalogName, String schemaName, String tableName) {
		return new org.xquark.extractor.progress.sql.SqlTable(catalogName, schemaName, tableName);
	}

	public SfConcat createSfConcat() {
		return new org.xquark.extractor.progress.sql.SfConcat();
	}

	public SfConcat createSfConcat(List list) {
		return new org.xquark.extractor.progress.sql.SfConcat(list);
	}

}
