/*
 * This file belongs to the XQuark distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquark.org.
 */

package org.xquark.extractor.sql;


import java.sql.*;
import java.util.Locale;

import org.xquark.extractor.common.Trace;

public class DatabaseManager {

	private static final String RCSRevision = "$Revision: 1.3 $";
	private static final String RCSName     = "$Name:  $";


    private Connection      _connection  = null;
    private Statement       _statement = null;
    private static Locale   _locale = new Locale ( "fr" , "fra");
//    private DatabaseMetadata _databaseMetadata ;

    public DatabaseManager()
    {
    }

    public void connectToDatabase (String driver,String url,String user,String password)
		throws SQLException , ClassNotFoundException
    {
		if (_connection != null) disconnectFromDatabase();
        Class.forName(driver);
        _connection = DriverManager.getConnection(url,user,password ) ;
        _statement = _connection.createStatement();
    }

    public  Connection getConnection ( )
    {
        return _connection ;
    }

    public  Statement getStatement ( )
    {
        return _statement ;
    }

    public static Locale getLocale ()
    {
        return  _locale ;
    }

    public String getTemporaryTableName ()
    {
        return "SqlWrapper" + System.currentTimeMillis() ;
    }

    public void disconnectFromDatabase () throws SQLException
    {
        _statement.close();
		_connection.close();
		_statement = null;
		_connection = null;
        Trace.message ( this,"disconnectFromDatabase", "DataBase disconnected" ) ;
    }


}
