/*
 * This file belongs to the XQuark distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquark.org.
 */

package org.xquark.extractor.sql;

import org.xquark.extractor.common.Trace;

public class SfSubString extends SqlFunction {

	private static final String RCSRevision = "$Revision: 1.3 $";
	private static final String RCSName     = "$Name:  $";

	private static final String OPERATOR_ID = "SUBSTR";

    public SfSubString()
    {
        super("SfSubString");
    }

    public SfSubString(SqlExpression arg0, SqlExpression arg1)
    {
        super("SfSubString");
        setArgument(0,arg0);
        setArgument(1,arg1);
    }

    public SfSubString(SqlExpression arg0, SqlExpression arg1, SqlExpression arg2)
    {
        super("SfSubString");
        setArgument(0,arg0);
        setArgument(1,arg1);
        setArgument(2,arg2);
    }

    public String toSql (Context context)
    {
        Trace.enter(this,"toSql(Context context)");

        StringBuffer retVal = new StringBuffer();
		retVal.append(getOperatorId());
		retVal.append('(');
        retVal.append(getArgument(0).toSql(context));
        int num = getArgumentNumber();
        if (1 < num){
            retVal.append(",");
            retVal.append(getArgument(1).toSql(context));
        }
        if ( 2 < num){
            retVal.append(",");
            retVal.append(getArgument(2).toSql(context));
        }
        retVal.append(")");

        Trace.exit(this,"toSql(Context context)");
        return retVal.toString();
    }
    
    protected String getOperatorId() { return OPERATOR_ID;}
}
