/*
 * This file belongs to the XQuark distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquark.org.
 */

package org.xquark.extractor.sql;

import java.sql.SQLException;
import java.sql.Statement;

public class SqlCreateTable extends SqlExpression
{

	private static final String RCSRevision = "$Revision: 1.3 $";
	private static final String RCSName     = "$Name:  $";

    private String _tableName;
    private SqlExpression _query;

    /**
    @param tableName
    @param query
    @roseuid 3BD177DA01AB
     */
    public SqlCreateTable(String tableName, SqlExpression query)
    {
        setTableName ( tableName )  ;
        setQuery (query ) ;
    }

    /**
    @roseuid 3BD177DA0179
     */
    public SqlCreateTable()
    {

    }

    /**
    Access method for the _query property.

    @return   the current value of the _query property
     */
    public SqlExpression getQuery()
    {
        return _query;
    }

    /**
    Sets the value of the _query property.

    @param aQuery the new value of the _query property
     */
    public void setQuery(SqlExpression aQuery)
    {
        //_query = query ;
        _query = aQuery;
    }

    /**
    @param tableName
    @roseuid 3BD177DA02C3
     */
    public void setTableName(String tableName)
    {
        _tableName = tableName ;
    }


    /**
    @return String
    @roseuid 3BD177DB0026
     */
    public String toSql(Context context)
    {
        String retStr ;
        retStr = " CREATE GLOBAL TEMPORAY TABLE " + _tableName + "AS ";
        retStr += _query.toSql(context) ;
        return retStr ;
    }

    /**
    @param statement
    @throws java.sql.SQLException
    @roseuid 3BD177DB0058
     */
    public void clean(Statement statement) throws SQLException
    {
        statement.executeQuery ( "DROP TABLE " + _tableName ) ;
    }
}
