/*
 * This file belongs to the XQuark distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquark.org.
 */

package org.xquark.extractor.sql;


public class SqlFunStrSubString extends SqlUnaryOperator
{

	private static final String RCSRevision = "$Revision: 1.3 $";
	private static final String RCSName     = "$Name:  $";

    private SqlExpression _start;
    private SqlExpression _length;

    /**
    @param operand
    @param start
    @param length
    @roseuid 3BD177F00211
     */
    public SqlFunStrSubString(SqlExpression operand, SqlExpression start, SqlExpression length)
    {
        super ( operand ) ;
        setStart ( start ) ;
        setLength ( length ) ;
    }

    /**
    @roseuid 3BD177F001DF
     */
    public SqlFunStrSubString()
    {

    }

    /**
    Access method for the _start property.

    @return   the current value of the _start property
     */
    public SqlExpression getStart()
    {
        return _start ;
    }

    /**
    Sets the value of the _start property.

    @param aStart the new value of the _start property
     */
    public void setStart(SqlExpression aStart)
    {
        //_start = start ;
        _start = aStart;
    }

    /**
    Access method for the _length property.

    @return   the current value of the _length property
     */
    public SqlExpression getLength()
    {
        return _length ;
    }

    /**
    Sets the value of the _length property.

    @param aLength the new value of the _length property
     */
    public void setLength(SqlExpression aLength)
    {
        //_length = length ;
        _length = aLength;
    }


}
