/*
 * This file belongs to the XQuark distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquark.org.
 */

package org.xquark.extractor.sql;

import org.xquark.extractor.common.Trace;

public class SqlRenameRelation extends SqlUnaryOperator
{
	private static final String RCSRevision = "$Revision: 1.4 $";
	private static final String RCSName     = "$Name:  $";

	private String _name;

	public SqlRenameRelation()
	{
	}

	/**
	@param relation
	@param name
	@roseuid 3BD182000164
	 */
	public SqlRenameRelation(SqlExpression relation, String name)
	{
		super(relation);
		setName(name);
	}

	public void setName (String name)
	{
//        Debug.assertTrue(null!=name,"null!=name");
		_name = name;
	}

	public String getName ()
	{
		return _name;
	}

	public String toSql(Context context) {
		return toSql(context,true);
	}
	
	public String toSql(Context context, boolean putQuotes)
	{
		Trace.enter(this,"toSql(Context context)");

		StringBuffer retVal = new StringBuffer();

		if (_operand instanceof Executable) {
			retVal.append(" (");
			retVal.append(_operand.toSql(context));
			retVal.append(") ");
		}
		else
			retVal.append(_operand.toSql(context));

		if (null != _name) {
			retVal.append(' ');
			if (putQuotes) retVal.append('"');
			retVal.append(_name);
			if (putQuotes) retVal.append('"');
		}

		Trace.exit(this,"toSql",retVal);
		return retVal.toString();
	}
}
