/*
 * This file belongs to the XQuark distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquark.org.
 */

package org.xquark.extractor.sql;


public class SqlTable extends SqlExpression
{

	private static final String RCSRevision = "$Revision: 1.4 $";
	private static final String RCSName     = "$Name:  $";


    protected String _catalogName = null;
    protected String _schemaName = null;
    protected String _name = null;;


    /**
    @roseuid 3BD17801037E
     */
    public SqlTable()
    {

    }

    /**
    @param name
    @roseuid 3BD1780103B0
     */
    public SqlTable(String name)
    {
        setName ( name ) ;
    }

    public SqlTable(String catalogName, String schemaName, String tableName)
    {
        setCatalogName(catalogName);
        setSchemaName(schemaName);
        setName(tableName);
    }

    public void setSchemaName(String schemaName) {
        _schemaName = schemaName;
    }

    public String getSchemaName()
    {
        return _schemaName;
    }


    public void setCatalogName(String catalogName) {
        _catalogName = catalogName;
    }

    public String getCatalogName()
    {
        return _catalogName;
    }

    /**
    Access method for the _name property.
    @return   the current value of the _name property
    @roseuid 3BD17802004A
     */
    public String getName()
    {
      return _name;
    }

    /**
    Sets the value of the _name property.
    @param aName the new value of the _name property
    @roseuid 3BD178020086
     */
    public void setName(String aName)
    {
      //name = aName;
      _name = aName;
    }

	public String toSql(Context context) {
		return toSql(context,true);
	}
	
    public String toSql(Context context, boolean putQuotes)
    {
        StringBuffer  retVal = new StringBuffer();

        String step = null;
        step = getCatalogName();
        if (null != step) {
            if (putQuotes) retVal.append('"');
            retVal.append(step);
			if (putQuotes) retVal.append('"');
            retVal.append('.');
        }

        step = getSchemaName();
        if (null != step) {
			if (putQuotes) retVal.append('"');
            retVal.append(step);
			if (putQuotes) retVal.append('"');
            retVal.append('.');
        }

        step =  getName();
		if (putQuotes) retVal.append('"');
        retVal.append(step);
		if (putQuotes) retVal.append('"');

        return retVal.toString();
    }
}
