/*
 * This file belongs to the XQuark distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquark.org.
 */

package org.xquark.extractor.sybase.sql;

import org.xquark.extractor.common.Trace;
import org.xquark.extractor.sql.Context;

public class SqlAttributeDefination extends org.xquark.extractor.sql.SqlExpression {
	private static final String RCSRevision = "$Revision: 1.3 $";
	private static final String RCSName = "$Name:  $";

	private String _name;
	private String _type;
	private boolean _nullable;
	private boolean _primaryKey;

	public SqlAttributeDefination() {

	}

	public String getName() {
		return _name;
	}

	public void setName(String aName) {
		_name = aName;
	}

	public String getType() {
		return _type;
	}

	public void setType(String type) {
		_type = type;
	}

	public boolean getNullable() {
		return _nullable;
	}

	public void setNullable(boolean nullable) {
		_nullable = nullable;
	}

	public boolean getPrimaryKey() {
		return _primaryKey;
	}

	public void setPrimaryKey(boolean primaryKey) {
		_primaryKey = primaryKey;
	}

    public String toSql(Context context) {
        Trace.enter(this,"toSql(Context context)");
        StringBuffer retVal = new StringBuffer();

		retVal.append(getName());
		retVal.append(' ');

		retVal.append(getType());

		if (getNullable()) {
			retVal.append(" NULL");
		}
		else  {
			retVal.append(" NOT NULL");
		}

		if (getPrimaryKey()) {
			retVal.append(" PRIMARY KEY");
		}

        Trace.exit(this,"toSql(Context context)", retVal);
        return retVal.toString() ;
    }
}

