/*
 * This file belongs to the XQuark distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquark.org.
 */

package org.xquark.extractor.sybase.sql;

import java.util.List;

import org.xquark.extractor.common.Trace;
import org.xquark.extractor.sql.Context;
import org.xquark.extractor.sql.SqlExpression;

public class SqlValueList extends org.xquark.extractor.sql.SqlExpression {
	private static final String RCSRevision = "$Revision: 1.3 $";
	private static final String RCSName = "$Name:  $";


	private List _valueList = null;
	public SqlValueList() {
		super();
	}

	public SqlValueList(List valueList) {
		super();
		setValueList(valueList);
	}

	public void setValueList(List valueList) {
	    _valueList = valueList;
	}

	public List getValueList() {
	    return _valueList;
	}

    public String toSql(Context context) {
        Trace.enter(this,"toSql(Context context)");
        StringBuffer retVal = new StringBuffer();

		retVal.append(" (");

		SqlExpression value = null;
	    for (int i = 0; i < getValueList().size(); i++) {
			value = (SqlExpression)getValueList().get(i);
			retVal.append(value.toSql(context));
			if (i != getValueList().size()-1 ) {
				retVal.append(" , ");
			}
		}
		retVal.append(")");

        Trace.exit(this,"toSql(Context context)", retVal);
        return retVal.toString() ;
    }

}

