{--
List the item number and description of all bicycles that currently have an auction in progress, ordered by item number.
Warning: as this query uses the current date, it might be necessary to adjust the values in the relational tables 
to obtain results
--}

<result>
{
for $i in collection("ITEMS")/*:ITEMS
where 	$i/START_DATE <= current-dateTime() 
	and $i/END_DATE >= current-dateTime() 
	and contains($i/DESCRIPTION, "Bicycle")
return
	<item>
		{ $i/ITEMNO }
		{ $i/DESCRIPTION }
	</item>
sortby (ITEMNO)
}
</result>