{--
For each item that has received a bid, list the item number, the highest bid, and the name of the highest bidder, ordered by item number.
--}

<result>
  {
    for $highbid in collection("BIDS")/*:BIDS,
        $user in collection("USERS")/*:USERS
    where $user/USERID = $highbid/USERID 
      and $highbid/BID = max(collection("BIDS")/*:BIDS
                              [ITEMNO = $highbid/ITEMNO]/BID)
    return
        <high_bid>
            { $highbid/ITEMNO }
            { $highbid/BID }
            <bidder>{ $user/NAME/text() }</bidder>
        </high_bid>
    sortby(ITEMNO)
  }
</result>
