{--
For each item whose highest bid is more than twice its reserve price, list the item number, description, reserve price, and highest bid.
--}
import schema namespace bid = "http://www.e-xmlmedia.com/XQuery/use-cases/bids" at "bids.xsd"
<result>
  {
    for $item in collection("ITEMS")/*:ITEMS
    let $b := doc("bids.xml")/bid:bids/bid_tuple[itemno = $item/ITEMNO]
    where $item/RESERVE_PRICE * 2 < max($b/bid)
    return
        <successful_item>
            { $item/ITEMNO }
            { $item/DESCRIPTION }
            { $item/RESERVE_PRICE }
            <high_bid>{ max($b/bid) }</high_bid>
        </successful_item>
 }
</result>
