{--
For each item that has received a bid, list the item number, the highest bid, and the name of the highest bidder, ordered by item number.
--}
import schema namespace bid = "http://www.e-xmlmedia.com/XQuery/use-cases/bids" at "bids.xsd"
<result>
  {
    for $highbid in doc("bids.xml")/bid:bids/bid_tuple,
        $user in collection("USERS")/*:USERS
    where $user/USERID = $highbid/userid 
      and $highbid/bid = max(doc("bids.xml")/bid:bids/bid_tuple
                              [itemno = $highbid/itemno]/bid)
    return
        <high_bid>
            { $highbid/itemno }
            { $highbid/bid }
            <bidder>{ $user/NAME/text() }</bidder>
        </high_bid>
    sortby(itemno)
  }
</result>
