{--
List item numbers and average bids for items that have received three or more bids, in descending order by average bid.
--}
import schema namespace bid = "http://www.e-xmlmedia.com/XQuery/use-cases/bids" at "bids.xsd"
<result>
  {
    for $i in distinct-values(doc("bids.xml")/bid:bids/bid_tuple/itemno)
    let $b := doc("bids.xml")/bid:bids/bid_tuple[itemno = $i]
    where count($b) >= 3
    return
        <popular_item>
            { $i }
            <avgbid>{ avg($b/bid) }</avgbid>
        </popular_item>
    sortby(avgbid descending)
  }
</result>

