import schema namespace ite = "http://www.e-xmlmedia.com/XQuery/use-cases/items" at "items.xsd"
import schema namespace bid = "http://www.e-xmlmedia.com/XQuery/use-cases/bids" at "bids.xsd"
import schema namespace use = "http://www.e-xmlmedia.com/XQuery/use-cases/users" at "users.xsd"
<result>
  {
	for $seller in doc("users.xml")/use:users//user_tuple,
	    $buyer in  doc("users.xml")/use:users//user_tuple,
	    $item in  doc("items.xml")/ite:items//item_tuple,
	    $highbid in  doc("bids.xml")/bid:bids//bid_tuple
	where $seller/name = "Tom Jones"
	  and $seller/userid = $item/offered_by
	  and contains($item/description, "Bicycle")
	  and $item/itemno = $highbid/itemno
	  and $highbid/userid = $buyer/userid
	  and $highbid/bid = max(doc("bids.xml")/bid:bids//bid_tuple[itemno = $item/itemno]/bid)
	return
		<jones_bike>
			{ $item/itemno }
			{ $item/description }
			<high_bid>{ $highbid/bid }</high_bid>
			<high_bidder>{ $buyer/name }</high_bidder>
		</jones_bike>
	sortby(itemno)
  }
</result>