/*
 * This file belongs to the XQuark distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquark.org.
 */

package org.xquark.mediator.plan;

import org.xquark.mediator.MediatorException;

public class DefaultOperatorVisitor implements OperatorVisitor {

	private static final String RCSRevision = "$Revision: 1.1 $";
	private static final String RCSName = "$Name:  $";

	public void visit(OpAggregateFunc arg) throws MediatorException {
		visit((UnOp) arg);
	}

	public void visit(BinOp arg) throws MediatorException {
		visit((MultOp) arg);
	}

	public void visit(OpCartesian arg) throws MediatorException {
		visit((MultOp) arg);
	}
	public void visit(Operator arg) throws MediatorException {
	}
	public void visit(OpMerge arg) throws MediatorException {
		visit((MultOp) arg);
	}
	public void visit(MultOp arg) throws MediatorException {
		visit((Operator) arg);
	}
	public void visit(OpNotSource arg) throws MediatorException {
		visit((UnOp) arg);
	}
	public void visit(OpRestrict arg) throws MediatorException {
		visit((UnOp) arg);
	}
	public void visit(OpSimpleMerge arg) throws MediatorException {
		visit((UnOp) arg);
	}
	public void visit(OpSort arg) throws MediatorException {
		visit((UnOp) arg);
	}
	public void visit(OpSource arg) throws MediatorException {
		visit((Operator) arg);
	}
	public void visit(OpSubQuery arg) throws MediatorException {
		visit((Operator) arg);
	}
	public void visit(OpUnion arg) throws MediatorException {
		visit((MultOp) arg);
	}
	public void visit(OpUnionSort arg) throws MediatorException {
		visit((MultOp) arg);
	}
	public void visit(UnOp arg) throws MediatorException {
		visit((UnOp) arg);
	}
	public void visit(OpValue arg) throws MediatorException {
		visit((Operator) arg);
	}
	public void visit(ZeroOp arg) throws MediatorException {
		visit((Operator) arg);
	}

}
