/*
 * This file belongs to the XQuark distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquark.org.
 */

package org.xquark.schema;

import org.xquark.schema.loader.*;

public interface SchemaVisitor { 
  public void visit(Schema schema) throws SchemaException;
  public void visit(SchemaComponent comp) throws SchemaException;
  public void visit(SchemaComponentRef ref) throws SchemaException;
  public void visit(Type type) throws SchemaException;
  public void visit(SimpleType type) throws SchemaException;
  public void visit(ComplexType type) throws SchemaException;
  public void visit(TypeRef ref) throws SchemaException;
  public void visit(SimpleBaseTypeRef ref) throws SchemaException;
  public void visit(Declaration decl) throws SchemaException;
  public void visit(ElementDeclaration decl) throws SchemaException;
  public void visit(AttributeDeclaration decl) throws SchemaException;
  public void visit(ElementDeclarationRef ref) throws SchemaException;
  public void visit(AttributeDeclarationRef ref) throws SchemaException;
  public void visit(Wildcard wildcard) throws SchemaException;
  public void visit(ModelGroupDefinition def) throws SchemaException;
  public void visit(AttributeGroupDefinition def) throws SchemaException;
  public void visit(ContentModel model) throws SchemaException;
  public void visit(Particle particle) throws SchemaException;
  public void visit(ModelGroup group) throws SchemaException;
  public void visit(AllModelGroup group) throws SchemaException;
  public void visit(ChoiceModelGroup group) throws SchemaException;
  public void visit(SequenceModelGroup group) throws SchemaException;
  public void visit(IdentityConstraint constraint) throws SchemaException;
  public void visit(IdentityConstraintRef ref) throws SchemaException;
  public void visit(NotationDeclaration notation) throws SchemaException;
}
