/*
 * This file belongs to the XQuark distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquark.org.
 */

package org.xquark.xpath;

import org.xquark.schema.Declaration;

/**
 * Abstract tree node with access to XML schema component.
 *
 */
public abstract class TypedXTreeNode extends XTreeNode
{
	private static final String RCSRevision = "$Revision: 1.1 $";
	private static final String RCSName = "$Name:  $";

	/**
	 * Constructor for element and attributes nodes.
	 * Calls its ancestor constructor for registrations.
	 * @param tree the owner tree
	 * @param parent the parent node
	 * @param namespace the namespace URI of the new node
	 * @param localName the local name of the new node
	 * @param the type of the new node
	 */
	protected TypedXTreeNode(
							XTree tree,
							XTreeNode parent,
							String namespace,
							String localName,
							byte type
							)
	{
		super(tree, parent, namespace, localName, type);
	}
	
	/**
	 * Accessor to the node XML schema declaration.
	 * @return null if not available
	 */
	public abstract Declaration getDeclaration();
}
