/*
 * This file belongs to the XQuark distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquark.org.
 */

package org.xquark.xpath.datamodel;

import org.xquark.schema.Declaration;
import org.xquark.schema.SimpleType;
import org.xquark.schema.Type;
import org.xquark.xpath.datamodel.xerces.dom.DocumentImpl;
import org.xquark.xpath.datamodel.xerces.dom.ElementNSImpl;

public class TypedElementImpl extends ElementNSImpl implements TypedElement {
    private static final String RCSRevision = "$Revision: 1.1 $";
    private static final String RCSName = "$Name:  $";
    public Type type = null;
    public Declaration declaration = null;

    public TypedElementImpl(DocumentImpl ownerDocument, String value) {
        super(ownerDocument, value);
    }

    public TypedElementImpl(DocumentImpl ownerDocument, String namespaceURI, 
                            String qualifiedName) {
        super(ownerDocument, namespaceURI, qualifiedName);
    }

    public void setType(Type type) {
        this.type = type;
    }

    public void setTypedValue(Object typedValue) {
    }

    public void setDeclaration(Declaration declaration) {
        this.declaration = declaration;
    }

    public Type getType() {
        return type;
    }

    public Object getTypedValue() {
        return null;
    }

    public Object getExtendedTypedValue() {
        SimpleType simpletype = type.getValueType();

        if (simpletype == null) {
            return null;
        }

        TypedNode typednode = (TypedNode) this.getFirstChild();

        return typednode.getTypedValue();
    }

    public Declaration getDeclaration() {
        return null;
    }

    public void setNormalizedStringValue(String normalizedStringValue) {
    }

    public String getNormalizedStringValue() {
        return null;
    }
}
