/*
 * This file belongs to the XQuark distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquark.org.
 */

/*
 * CData.java
 *
 * Created on 25 juin 2002, 15:46
 */

package org.xquark.xquery.parser;


public class CData extends XQueryExpression implements Cloneable {
    private static final String RCSRevision = "$Revision: 1.1 $";
    private static final String RCSName     = "$Name:  $";
    
    // can be null
    protected String data = null;
    
    // #############################################################################
    // VISITOR STUFF
    // #############################################################################
    
    public void accept(ParserVisitor visitor) throws XQueryException {
        visitor.visit(this);
    }
    
    // #############################################################################
    // CONSTRUCTOR STUFF
    // #############################################################################
    
    public CData(String data, TypeVisitor typeVisitor) throws TypeException, XQueryException {
        setCData(data);
        if (typeVisitor != null) accept(typeVisitor);
    }
    
    // #############################################################################
    // ATTRIBUTE ACCESS STUFF
    // #############################################################################
    
    public String getCData() {
        return data;
    }
    
    public void setCData(String data) throws XQueryException {
        this.data = data;
    }
    
    // #############################################################################
    // PRINT STUFF
    // #############################################################################
    
    public String print() {
        StringBuffer buf = new StringBuffer();
        buf.append("<![CDATA[ ");
        buf.append(data);
        buf.append(" ]]>");
        return buf.toString();
    }
    
    // #############################################################################
    // CLONE STUFF
    // #############################################################################
    
//    public synchronized Object clone() throws CloneNotSupportedException {
//        try {
//            CData newobj = (CData)super.clone();
//            newobj.setCData(getCData());
//            return newobj;
//        }
//        catch (Exception e) {
//            //System.err.println(e.getMessage()) ;
//            throw new CloneNotSupportedException("Error in cloning Element");
//        }
//    }
//    
//    public synchronized Object clone(HashMap mapvars) throws CloneNotSupportedException {
//        try {
//            CData newobj = (CData)super.clone(mapvars);
//            if (newobj == null) return null;
//            newobj.setCData(getCData());
//            return newobj;
//        }
//        catch (Exception e) {
//            //System.err.println(e.getMessage()) ;
//            throw new CloneNotSupportedException("Error in cloning Element");
//        }
//    }
    
}
