/*
 * This file belongs to the XQuark distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquark.org.
 */


package  org.xquark.xquery.parser;


// START_COMMON

public class ValueBoolean extends Value implements Cloneable {
    private static final String RCSRevision = "$Revision: 1.1 $";
    private static final String RCSName     = "$Name:  $";
    
    
    // #############################################################################
    // VISITOR STUFF
    // #############################################################################
    
    public void accept(ParserVisitor visitor) throws XQueryException {
        visitor.visit(this);
    }
    
    // #############################################################################
    // CONSTRUCTOR STUFF
    // #############################################################################
    
    public ValueBoolean(String value, TypeVisitor typevisitor) throws TypeException, XQueryException {
        super(value,typevisitor);
        setValue(value);
        if (typevisitor != null) accept(typevisitor);
    }
    
    // #############################################################################
    // ATTRIBUTE ACCESS STUFF
    // #############################################################################
    
    public boolean getBooleanValue() { if (value.equalsIgnoreCase("true")) return true; else return false; }
	public Object getObjectValue() { return null; } 
    public void setValue(String value) throws XQueryException {
        // must be FALSE or TRUE
        if (!value.equalsIgnoreCase("true") && !value.equalsIgnoreCase("false")) throw new XQueryException("value of ValueBoolean must be a Valid Boolean");
        this.value = value;
    }
    public void setValue(boolean value) throws XQueryException {
        setValue(String.valueOf(value));
    }
    
    // #############################################################################
    // PRINT STUFF
    // #############################################################################
    
    public String print() {
        return value;
    }
    
    // #############################################################################
    // CLONE STUFF
    // #############################################################################
    
//    public synchronized Object clone()
//    throws CloneNotSupportedException {
//        try {
//            ValueBoolean newobj = (ValueBoolean)super.clone();
//            newobj.setValue(getValue()) ;
//            return  newobj;
//        }
//        catch (Exception e) {
//            //System.err.println(e.getMessage()) ;
//            throw new CloneNotSupportedException("Error in cloning ValueBoolean");
//        }
//    }
//    
//    public synchronized Object clone(HashMap mapvars)
//    throws CloneNotSupportedException {
//        try {
//            ValueBoolean newobj = (ValueBoolean)super.clone(mapvars);
//            if (newobj == null) return null ;
//            newobj.setValue(getValue()) ;
//            return  newobj;
//        }
//        catch (Exception e) {
//            //System.err.println(e.getMessage()) ;
//            throw new CloneNotSupportedException("Error in cloning ValueBoolean");
//        }
//    }
//    
    
}



