/*
 * This file belongs to the XQuark distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquark.org.
 */

package org.xquark.xquery.parser.primitivefunctions.fnfunctions;

import java.util.ArrayList;

import org.xquark.xquery.parser.*;


/**
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class FunctionDOC extends RootNodeFunctionCall {

	private static final String RCSRevision = "$Revision: 1.2 $";
	private static final String RCSName = "$Name:  $";

	// #############################################################################
	// VISITOR STUFF
	// #############################################################################

	public void accept(ParserVisitor visitor) throws XQueryException {
		visitor.visit(this);
	}

	// #############################################################################
	// CONSTRUCTOR STUFF
	// #############################################################################

	public FunctionDOC(ArrayList args, TypeVisitor typevisitor)
		throws TypeException, XQueryException {
		super(new QName(null, null, "doc", null), args);
		if (typevisitor != null) {
			accept(typevisitor);
		}
	}

	public void setArguments(ArrayList arguments) throws XQueryException {
		if (arguments == null || arguments.size() != 1) throw new XQueryException("Function doc should have one argument");
//		// verify that arguments are strings
//		// of the following format "abc" or "*.abc" or "*" or "abc.*" or "abc.def" or "*.*"
//		// transforms () -> ("*.*")
//		// transforms ("*") -> ("*.*")
//		// transforms ("abc") -> ("*.abc")
//		if (arguments != null && arguments.size() != 0) {
//			for (int i = 0; i < arguments.size(); i++) {
//				ValueString valStr = null;
//				try {
//					valStr = (ValueString) arguments.get(i);
//				}
//				catch (Exception e) {
//					throw new XQueryException("Argument(s) of function doc must be a literal string(s)");
//				}
//				String arg = valStr.getValue();
//				// verify only one dot
//				int firstColon = arg.indexOf(":");
//				if (firstColon != -1) {
//					valStr.setValue(arg.substring(0, firstColon) + ":" + arg.substring(firstColon + 1));
//				}
//				else {
//					valStr.setValue("*:" + arg);
//				}
//			}
//		}
//		else {
//			arguments = new ArrayList();
//			arguments.add(new ValueString("*:*", null));
//		}
		super.setArguments(arguments);
	}

	public String getDocumentName() {
		return ((ValueString) arguments.get(0)).getValue();
	}

	// #############################################################################
	// CLONE STUFF
	// #############################################################################
	public synchronized Object clone() throws CloneNotSupportedException {
		try {
			FunctionDOC newobj = (FunctionDOC) super.clone();
			return newobj;
		}
		catch (Exception e) {
			//System.err.println(e.getMessage());
			throw new CloneNotSupportedException("Error in cloning FunctionDOC");
		}
	}

}
