/*
 * This file belongs to the XQuark distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquark.org.
 */


package org.xquark.xquery.parser.primitivefunctions.fnfunctions;

import java.util.ArrayList;

import org.xquark.xquery.parser.*;

// START_COMMON

public class FunctionNOT extends PrimitiveFunctionCall {
    
    private static final String RCSRevision = "$Revision: 1.1 $";
    private static final String RCSName     = "$Name:  $";
    
    // #############################################################################
    // VISITOR STUFF
    // #############################################################################
    
    public void accept(ParserVisitor visitor) throws XQueryException {
        visitor.visit(this);
    }
    
    // #############################################################################
    // CONSTRUCTOR STUFF
    // #############################################################################
    
    public FunctionNOT(ArrayList args, TypeVisitor typevisitor) throws TypeException, XQueryException {
        super(new QName(null,null,"not",null),args);
        if (typevisitor != null) accept(typevisitor);
    }
    
    // this function should be called with one argument
    public void setArguments(ArrayList arguments) throws XQueryException {
        if (arguments == null || arguments.size() != 1) throw new XQueryException("Function not should have one argument");
        super.setArguments(arguments);
    }
    
    // #############################################################################
    // CLONE STUFF
    // #############################################################################
    public synchronized Object clone()
    throws CloneNotSupportedException {
        try {
            FunctionNOT newobj = (FunctionNOT)super.clone();
            return  newobj;
        }
        catch (Exception e) {
            //System.err.println(e.getMessage()) ;
            throw new CloneNotSupportedException("Error in cloning FunctionNOT");
        }
    }
    
}


