/*
 * This file belongs to the XQuark distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquark.org.
 */

package org.xquark.xquery.parser.util;

import org.xquark.schema.SimpleType;
import org.xquark.xquery.parser.XQueryExpression;

public class ElementTools {

    private static final String RCSRevision = "$Revision: 1.1 $";
    private static final String RCSName     = "$Name:  $";

	private int countSimpleType = 0;
	private int countAttribute = 0;
	private int countSimpleList = 0;
	private int size = 0;
	private boolean mixed = false;
	private SimpleType simpleType = null;
	private XQueryExpression name = null;

	public ElementTools(int size, XQueryExpression name)
	{
		this.size = size;
		this.name = name;
	}
	
	// ******************************************
	// FOR ACCESS TO PRIVATE/PROTECTED ATTRIBUTES
	// ******************************************
	
	public int getCountSimpleType() { return countSimpleType; }

//	public void setCountSimpleType(int countSimpleType) { this.countSimpleType = countSimpleType; }

	public int getCountAttribute() { return countAttribute; }

//	public void setCountAttribute(int countAttribute) { this.countAttribute = countAttribute; }

	public int getCountSimpleList() { return countSimpleList; }

//	public void setCountSimpleList(int countSimpleList) { this.countSimpleList = countSimpleList; }

	public int getSize() { return size; }

	public void setSize(int size) { this.size = size; }

	public boolean getMixed() { return mixed; }

	public void setMixed(boolean mixed) { this.mixed = mixed; }
	
	public SimpleType getSimpleType() { return simpleType; }

	public void setSimpleType(SimpleType simpleType) { this.simpleType = simpleType; }
	
	public XQueryExpression getName() { return name; }

	public void setName(XQueryExpression name) { this.name = name; }
	
	// Increment methods
	
	public void incSize() { size++; }

	public void incCountSimpleType() { countSimpleType++; }

	public void incCountAttribute() { countAttribute++; }

	public void incCountSimpleList() { countSimpleList++; }

	// ***********************
	// STUFF JUST FOR PRINTING
	// ***********************

	public String toString()
	{
		StringBuffer sb = new StringBuffer();
		sb.append("*** ElementTools ***\n");
		sb.append("countSimpleType: "+countSimpleType+"\n");
		sb.append("countAttribute: "+countAttribute+"\n");
		sb.append("countSimpleList: "+countSimpleList+"\n");
		sb.append("size: "+size+"\n");
		sb.append("mixed: "+mixed+"\n");
		sb.append("********************");
		return sb.toString();
	}
}
