/*
 * This file belongs to the XQuark distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquark.org.
 */

package  org.xquark.xquery.parser.util;

import java.util.ArrayList;

import org.xquark.xquery.parser.XQueryExpression;

public class TransformXQueryExpression {
    
    private static final String RCSRevision = "$Revision: 1.1 $";
    private static final String RCSName     = "$Name:  $";
    
    protected ArrayList QDB = null;
    protected XQueryExpression QMEM = null;
    protected DependNode dependMap = null;
    protected ArrayList varList = null;
    protected ArrayList returnVarList = null;
    protected ArrayList idVarList = null;
    
    public TransformXQueryExpression(ArrayList QDB, XQueryExpression QMEM, DependNode dependMap, ArrayList varList) {
        setQDB(QDB);
        setQMEM(QMEM);
        setDependMap(dependMap);
        setVarList(varList);
    }
    
    public TransformXQueryExpression(ArrayList QDB, XQueryExpression QMEM, DependNode dependMap, ArrayList varList,  ArrayList returnVarList,  ArrayList idVarList) {
        setQDB(QDB);
        setQMEM(QMEM);
        setDependMap(dependMap);
        setVarList(varList);
        setReturnVarList(returnVarList);
        setIdVarList(idVarList);
    }
    
    public ArrayList getQDB() { return QDB; }
    
    public void setQDB(ArrayList QDB) { this.QDB = QDB; }
    
    public XQueryExpression getQMEM() { return QMEM; }
    
    public void setQMEM(XQueryExpression QMEM) { this.QMEM = QMEM; }
    
    public DependNode getDependMap() { return dependMap; }
    
    public void setDependMap(DependNode dependMap) { this.dependMap = dependMap; }
    
    public ArrayList getVarList() { return varList; }
    
    public void setVarList(ArrayList varList) { this.varList = varList; }
    
    public ArrayList getReturnVarList() { return returnVarList; }
    
    public void setReturnVarList(ArrayList returnVarList) { this.returnVarList = returnVarList; }
    
    public ArrayList getIdVarList() { return idVarList; }
    
    public void setIdVarList(ArrayList idVarList) { this.idVarList = idVarList; }
    
    // For debugging
    public String toString() {
        StringBuffer sb = new StringBuffer();
        sb.append("\n%%% QDB: "+QDB+"\n");
        sb.append("%%% QMEM: "+QMEM+"\n");
        sb.append("%%% dependMap: "+dependMap+"\n");
        sb.append("%%% varList: "+varList+"\n");
        sb.append("%%% returnVarList: "+returnVarList+"\n");
        sb.append("%%% idVarList: "+idVarList+"\n");
        return sb.toString();
    }
    
    //	public int getSize()
    //	{
    //		ArrayList result = new ArrayList();
    //		ArrayList list = new ArrayList(dependMap.values());
    //		ArrayList listi = null;
    //		for (int i = 0; i < list.size(); i++)
    //		{
    //			listi = (ArrayList) list.get(i);
    //			for (int j = 0; j < listi.size(); j++)
    //				if (!result.contains(listi.get(j))) result.add(listi.get(j));
    //		}
    //		return result.size();
    //	}
    
    public int getSize() { return varList.size(); }
    
    public ArrayList getBoundVariables() {
        if (QMEM != null) {
            try {
                return QMEM.getBoundVariables();
            }
            catch (Exception e) {}
        }
        return null;
    }
    
}
