/*
 * This file belongs to the XQuark distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquark.org.
 */


package org.xquark.xquery.parser.util;

import java.util.ArrayList;

import org.xquark.xquery.parser.Variable;

// the hashtable contains a string (name of the variable)
// associated to an XQueryExpression

public class UnitEnvironment {
    private static final String RCSRevision = "$Revision: 1.2 $";
    private static final String RCSName     = "$Name:  $";
    
    // tells if variables should be replaced in paths calculation
    boolean replaceVar = true;
    // contains all defined variables
    ArrayList variables = null;
    // contains the current XQueryUnit (and function library and context declarations)
    //XQueryUnit queryUnit = null;
    // contains the current call stack
    //ArrayList functionCallStack = null;
    // contains the values for each path in the retrun expression
    //Hashtable hashValues = null;
    // contains the artificial variables add
    //ArrayList artificialVariables = null;
    
    // constructors
    
    private void init() {
        variables = new ArrayList();
        //functionCallStack = new ArrayList();
    }
    
//    public UnitEnvironment(XQueryUnit queryUnit) {
//        init();
//        this.queryUnit = queryUnit;
//    }
    
//    public UnitEnvironment(XQueryUnit queryUnit,boolean replaceVar) {
//        init();
//        this.queryUnit = queryUnit;
//        this.replaceVar = replaceVar;
//    }
    
//    public UnitEnvironment(boolean replaceVar) {
//        init();
//        this.replaceVar = replaceVar;
//    }
    
    public UnitEnvironment() {
        init();
    }
    
    // manipulation methods
    
    public boolean getReplaceVar() {
        return replaceVar;
    }
    
//    public boolean existsVariable(Variable var) {
//        if (var == null) return false;
//        return variables.contains(var);
//    }
    
//    public ArrayList getVariables() {
//        return variables;
//    }
    
//    public FunctionDefinition getFunctionDefinition(String name) {
//        if (queryUnit == null) return null;
//        return queryUnit.getFunctionDefinition(name);
//    }
    
//    public Hashtable getHashValues() {
//        return hashValues;
//    }
    
//    private boolean isVarInPath(String varName,String path) {
//        //org.xquark.xml.misc.Debug.print(this,"isVarInPath : var = " + varName + " path = " + path);
//        int index = path.indexOf(varName);
//        if (index == -1) return false;
//        if (path.equals(varName)) return true;
//        int varLen = varName.length();
//        if (index == 0)
//            if (path.charAt(varLen) == '/') return true;
//            else return false;
//        if (path.charAt(index-1) == '/') return false;
//        if (path.length() == index+varLen) return true;
//        if (path.charAt(index+varLen) == '/') return true;
//        return false;
//    }
    
//    public void setHashValues(Hashtable hashValues) {
//        this.hashValues = hashValues;
//        // fill variable values
//        if (variables == null || hashValues == null) return;
//        for (int i=0;i<variables.size();i++) {
//            Enumeration hashValuesKeys = hashValues.keys();
//            boolean first = true;
//            Variable var = (Variable)variables.get(i);
//            String varName = var.getName();
//            ArrayList varPaths = new ArrayList();
//            
//            while (hashValuesKeys.hasMoreElements()) {
//                String path = (String)hashValuesKeys.nextElement();
//                if (isVarInPath(varName,path)) varPaths.add(path);
//            }
//        }
//    }
    
//    public String getValueFromHashValues(String key) {
//        if (hashValues == null) return null;
//        return (String)hashValues.get(key);
//    }
    
    // CALL STACK  STUFF
    
//    public boolean inCallStack(String name) {
//        if (name == null) return false;
//        return functionCallStack.contains(name);
//    }
    
//    public void pushCallStack(String name) {
//        if (name == null) return;
//        functionCallStack.add(name);
//    }
    
//    public void pullCallStack(String name) {
//        if (name == null) return;
//        functionCallStack.remove(functionCallStack.size()-1);
//    }
    
    // BINDING STUFF
    
    public void addVariables(ArrayList vars) {
        if (vars == null) return;
        for (int i=0;i<vars.size();i++)
            addVariable((Variable)vars.get(i));
    }
    
    public void addVariable(Variable var) {
        if (var == null) return;
        //org.xquark.xml.misc.Debug.print(this,"BIND  variable : " + var.getName() + " --> " + ((XQueryExpression)var.getExpression()).pprint());
        variables.add(var);
    }
    
//    private void addArtificialVariable(Variable var) {
//        if (var == null) return;
//        if (artificialVariables == null) artificialVariables = new ArrayList();
//        artificialVariables.add(var);
//    }
    
    //	public Variable getArtificialVariable() throws Exception
    //	{
    //		Variable var = null;
    //		String varName = "tmp_var";
    //		if (artificialVariables == null) artificialVariables = new ArrayList();
    //		if (artificialVariables.isEmpty())
    //			var = new Variable(new QName(null,varName+"0"));
    //		else
    //		{
    //			var = (Variable)artificialVariables.lastElement();
    //			String str = ((QName)var.getVarName()).getName().substring(7);
    //			var = new Variable(new QName(null,varName+(Integer.parseInt(str)+1)));
    //		}
    //		addArtificialVariable(var);
    //		return var;
    //	}
    
    
    public void removeVariables(ArrayList vars) {
        if (vars == null) return;
        for (int i=0;i<vars.size();i++)
            removeVariable((Variable)vars.get(i));
    }
    
    public void removeVariable(Variable var) {
        if (var == null) return;
        //org.xquark.xml.misc.Debug.print(this,"REMOVE  variable : " + var.getName() + " --> " + ((XQueryExpression)var.getExpression()).pprint());
        if (variables.contains(var)) variables.remove(var);
    }
    
    // debug methods
    
    //	public String pprint()
    //	{
    //		StringBuffer buf = new StringBuffer();
    //		Enumeration names = environment.keys();
    //		Enumeration values =  environment.elements();
    //		while(names.hasMoreElements())
    //		{
    //			buf.append(names.nextElement());
    //			buf.append(" --> ");
    //			buf.append(((XQueryExpression)values.nextElement()).pprint());
    //			buf.append("\n ");
    //		}
    //		return buf.toString();
    //	}
    
    // STOP_COMMON
    
}
