/*
 * This file belongs to the XQuark distribution.
 * Copyright (C) 2003 XQuark Group.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquark.org.
 */

package org.xquark.xquery.typing;

import org.xquark.xquery.parser.XQueryException;

public class DefaultQTypeVisitor implements QTypeVisitor {

	private static final String RCSRevision = "$Revision: 1.1 $";
	private static final String RCSName = "$Name:  $";

	public void visit(QType arg) throws XQueryException {}
	public void visit(QTypeAtom arg) throws XQueryException {
		visit((QTypeItem) arg);
	}
	public void visit(QTypeText arg) throws XQueryException {
		visit((QTypeNode) arg);
	}
	public void visit(QTypeAttribute arg) throws XQueryException {
		visit((QTypeNode) arg);
	}
	public void visit(QTypeComment arg) throws XQueryException {
		visit((QTypeNode) arg);
	}
	public void visit(QTypeDocument arg) throws XQueryException {
		visit((QTypeNode) arg);
	}
	public void visit(QTypeElement arg) throws XQueryException {
		visit((QTypeNode) arg);
	}
	public void visit(QTypeProcessingInstruction arg) throws XQueryException {
		visit((QTypeNode) arg);
	}
	public void visit(QTypeSequence arg) throws XQueryException {
		visit((QTypePrime) arg);
	}
	public void visit(QTypeUnion arg) throws XQueryException {
		visit((QTypePrime) arg);
	}
	public void visit(QTypeNode arg) throws XQueryException {
		visit((QTypeItem) arg);
	}
	public void visit(QTypePrime arg) throws XQueryException {
		visit((QType) arg);
	}
	public void visit(QTypeItem arg) throws XQueryException {
		visit((QType) arg);
	}
}
