/*
 * This file belongs to the XQuark distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * Copyright (C) 2003 XQuark Group.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquark.org.
 */

/*
 * QTypeComment.java
 *
 * Created on 25 juin 2002, 17:45
 */

package org.xquark.xquery.typing;

import org.xquark.xquery.parser.XQueryException;

public class QTypeComment extends QTypeNode implements QTypeVisitable {
	private static final String RCSRevision = "$Revision: 1.1 $";
	private static final String RCSName = "$Name:  $";

	// #############################################################################
	// CONSTRUCTOR STUFF
	// #############################################################################

	public QTypeComment() {
		subclass = COMMENT;
		occurence = OCC_1_1;
	}
	public QTypeComment(byte occurence) {
		subclass = COMMENT;
		this.occurence = occurence;
	}

	// #############################################################################
	// VISITOR STUFF
	// #############################################################################

	public void accept(QTypeVisitor visitor) throws XQueryException {
		visitor.visit(this);
	}

	// #############################################################################
	// ATTRIBUTE ACCESS STUFF
	// #############################################################################

	// equals
	public boolean equals(Object qtype) {
		if (!(qtype instanceof QTypeComment))
			return false;
//		if (((QTypeComment) qtype).getOccurence() != occurence)
//			return false;
		return true;
	}

	// tells whether qtype is a node
	public boolean isNode() {
		return true;
	}

	// clone
	public Object clone() throws CloneNotSupportedException {
		QTypeComment newObj = new QTypeComment(occurence);
		return newObj;
	}
	// print
	public String toSimpleString() {
		return "QTypeComment()";
	}

	public String toString() {
		return "QTypeComment()";
	}
}
