/*
 * This file belongs to the XQuark distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * Copyright (C) 2003 XQuark Group.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquark.org.
 */

package org.xquark.xquery.typing;

import java.util.List;

import org.xquark.xquery.parser.XQueryException;

public class QTypeSequence extends QTypePrime implements QTypeVisitable {
	private static final String RCSRevision = "$Revision: 1.2 $";
	private static final String RCSName = "$Name:  $";

	List list = null;

	public QTypeSequence(List list) {
		super(list,SEQUENCE);
		setList(list);
		subclass = SEQUENCE;
		//primeList = list;
		this.occurence = OCC_1_1;
	}
	public QTypeSequence(List list, byte occurence) {
		super(list,SEQUENCE);
		setList(list);
		subclass = SEQUENCE;
		//primeList = list;
		this.occurence = occurence;
	}

	// #############################################################################
	// VISITOR STUFF
	// #############################################################################

	public void accept(QTypeVisitor visitor) throws XQueryException {
		visitor.visit(this);
	}

	// get/set
	public List getList() {
		return list;
	}

	private void setList(List list) {
		//if (list == null) throw new TypeException("list of QTypeSequence cannot be null");
		this.list = list;
	}

//	// equals
//	public boolean equals(Object qtype) {
//		//org.xquark.xml.misc.Debug.print(this,"QTypeSequence::equals");
//		if (!(qtype instanceof QTypeSequence))
//			return false;
//		if (((QTypeSequence) qtype).getOccurence() != occurence)
//			return false;
//		if (list == null && ((QTypeSequence) qtype).getList() == null)
//			return true;
//		if (list == null || ((QTypeSequence) qtype).getList() == null)
//			return false;
//		Iterator it1 = list.iterator();
//		Iterator it2 = ((QTypeSequence) qtype).getList().iterator();
//		while (it1.hasNext() && it2.hasNext())
//			if (!((QType) it1.next()).equals((QType) it2.next()))
//				return false;
//		if (it1.hasNext() || it2.hasNext())
//			return false;
//		return true;
//	}


//	// tells whether qtype is numeric
//	public boolean isNumeric() {
//		if (list == null || list.isEmpty())
//			return false;
//		Iterator it = list.iterator();
//		while (it.hasNext())
//			if (!((QType) it.next()).isNumeric())
//				return false;
//		return true;
//	}
//
//	// tells whether qtype is boolean
//	public boolean isBoolean() {
//		if (list == null || list.isEmpty())
//			return false;
//		Iterator it = list.iterator();
//		while (it.hasNext())
//			if (!((QType) it.next()).isBoolean())
//				return false;
//		return true;
//	}
//
//	// tells whether qtype is integer
//	public boolean isInteger() {
//		if (list == null || list.isEmpty())
//			return false;
//		int size = list.size();
//		for (int i = 0; i < size; i++)
//			if (!((QType) list.get(i)).isInteger())
//				return false;
//		return true;
//	}
//
//	// tells whether qtype is string
//	public boolean isString() {
//		if (list == null || list.isEmpty())
//			return false;
//		Iterator it = list.iterator();
//		while (it.hasNext())
//			if (!((QType) it.next()).isString())
//				return false;
//		return true;
//	}
//
//	// tells whether qtype is an atom
//	public boolean isAtom() {
//		if (list == null || list.isEmpty())
//			return false;
//		Iterator it = list.iterator();
//		while (it.hasNext())
//			if (!((QType) it.next()).isAtom())
//				return false;
//		return true;
//	}
//
//	// tells whether qtype can react to text()
//	public boolean isText() {
//		if (list == null || list.isEmpty())
//			return false;
//		Iterator it = list.iterator();
//		while (it.hasNext())
//			if (!((QType) it.next()).isText())
//				return false;
//		return true;
//	}
//
//	// tells whether qtype is a date or collection of dates
//	public boolean isDate() {
//		if (list == null || list.isEmpty())
//			return false;
//		Iterator it = list.iterator();
//		while (it.hasNext())
//			if (!((QType) it.next()).isDate())
//				return false;
//		return true;
//	}
//
//	// tells whether qtype is a attribte or collection or sequence
//	public boolean isAttribute() {
//		if (list == null || list.isEmpty())
//			return false;
//		Iterator it = list.iterator();
//		while (it.hasNext())
//			if (!((QType) it.next()).isAttribute())
//				return false;
//		return true;
//	}
//
//	// tells whether qtype is a ID, IDREF or IDREFS type
//	public boolean isIDAttribute() {
//		if (list == null || list.isEmpty())
//			return false;
//		Iterator it = list.iterator();
//		while (it.hasNext())
//			if (!((QType) it.next()).isIDAttribute())
//				return false;
//		return true;
//	}
//
//	// tells whether qtype is a node
//	public boolean isNode() {
//		if (list == null || list.isEmpty())
//			return false;
//		Iterator it = list.iterator();
//		while (it.hasNext())
//			if (!((QType) it.next()).isNode())
//				return false;
//		return true;
//	}
//
//	// tells whether qtype is a node with simple type
//	public boolean isSimpleTypeNode() {
//		if (list == null || list.isEmpty())
//			return false;
//		Iterator it = list.iterator();
//		while (it.hasNext())
//			if (!((QType) it.next()).isSimpleTypeNode())
//				return false;
//		return true;
//	}
//
//	// tells whether qtype is a collection
//	public boolean isCollection() {
//		return false;
//	}
//
//	// tells whether qtype is a document
//	public boolean isDocument() {
//		return false;
//	}
//
//	// tells whether qtype is multiple
//	public boolean isMultiple() {
//		if (list == null || list.size() <= 1)
//			return false;
//		return true;
//	}
//
//	// tells whether qtype is atomic (atom or element with simple content
//	public boolean isAtomic() {
//		if (list == null || list.isEmpty())
//			return false;
//		if (list.size() == 1)
//			return ((QType) list.get(0)).isAtomic();
//		return false;
//	}
//
//	// tells whether qtype is mixed
//	public boolean isMixed() {
//		if (list == null || list.isEmpty())
//			return false;
//		Iterator it = list.iterator();
//		while (it.hasNext())
//			if (!((QType) it.next()).isMixed())
//				return false;
//		return true;
//	}
//
//	// tells whether qtype is element
//	public boolean isElement() {
//		if (list == null || list.isEmpty())
//			return false;
//		Iterator it = list.iterator();
//		while (it.hasNext())
//			if (!((QType) it.next()).isElement())
//				return false;
//		return true;
//	}

//	public QType applyDATAFunction() throws TypeException {
//		ArrayList newList = new ArrayList();
//		Iterator it = list.iterator();
//		while (it.hasNext()) {
//			QType qtype = (QType) it.next();
//			qtype = qtype.applyDATAFunction();
//			if (qtype != null)
//				newList.add(qtype);
//		}
//		if (!newList.isEmpty()) {
//			if (newList.size() == 1)
//				return (QType) newList.get(0);
//			else
//				return new QTypeSequence(newList);
//		}
//		return null;
//	}

	// clone
	public Object clone() throws CloneNotSupportedException {
		QTypeSequence newObj = new QTypeSequence(list,occurence);
		return newObj;
	}
	// print
	public String toSimpleString() {
		return "QTypeSequence(" + list + ")";
	}

	public String toString() {
		return "QTypeSequence(" + list + ")";
	}

}
