/*
 * This file belongs to the XQuark distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * Copyright (C) 2003 XQuark Group.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquark.org.
 */

package org.xquark.xquery.typing;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.xquark.xquery.parser.XQueryException;

public class QTypeUnion extends QTypePrime implements QTypeVisitable {
	private static final String RCSRevision = "$Revision: 1.2 $";
	private static final String RCSName = "$Name:  $";

	List list = null;

	public QTypeUnion(List list) {
		super(list,UNION);
		setList(list);
		subclass = UNION;
		//primeList = list;
		occurence = OCC_1_1;
	}
	public QTypeUnion(List list, byte occurence) {
		super(list,UNION);
		setList(list);
		subclass = UNION;
		//primeList = list;
		this.occurence = occurence;
	}

	// #############################################################################
	// VISITOR STUFF
	// #############################################################################

	public void accept(QTypeVisitor visitor) throws XQueryException {
		visitor.visit(this);
	}

	// get/set
	public List getList() {
		return list;
	}

	private void setList(List list) {
		// if (list == null || list.isEmpty()) throw new TypeException("list of QTypeUnion cannot be null or empty");
		this.list = new ArrayList();
		Iterator it = list.iterator();
		while (it.hasNext()) {
			QType qtype = (QType) it.next();
			if (qtype instanceof QTypeUnion)
				this.list.addAll(((QTypeUnion) qtype).getList());
			else
				this.list.add(qtype);
		}
	}

	//	// equals
	//	public boolean equals(Object qtype) {
	//		//org.xquark.xml.misc.Debug.print(this,"QTypeUnion::equals");
	//		if (!(qtype instanceof QTypeUnion))
	//			return false;
	//		if (((QTypeUnion) qtype).getOccurence() != occurence)
	//			return false;
	//		List list2 = ((QTypeUnion) qtype).getList();
	//		int size1 = list.size();
	//		int size2 = list.size();
	//		if (size1 != size2)
	//			return false;
	//		for (int i = 0; i < size1; i++) {
	//			QType qtype1 = (QType) list.get(i);
	//			boolean found = false;
	//			for (int j = 0; j < size2; j++)
	//				if (found = qtype1.equals((QType) list2.get(i)))
	//					break;
	//			if (!found)
	//				return false;
	//		}
	//		return true;
	//	}
	//
	//	// tells whether qtype is numeric
	//	public boolean isNumeric() {
	//		Iterator it = list.iterator();
	//		while (it.hasNext())
	//			if (((QType) it.next()).isNumeric())
	//				return true;
	//		return false;
	//	}
	//
	//	// tells whether qtype is boolean
	//	public boolean isBoolean() {
	//		int size = list.size();
	//		for (int i = 0; i < size; i++)
	//			if (((QType) list.get(i)).isBoolean())
	//				return true;
	//		return false;
	//	}
	//
	//	// tells whether qtype is integer
	//	public boolean isInteger() {
	//		int size = list.size();
	//		for (int i = 0; i < size; i++)
	//			if (((QType) list.get(i)).isInteger())
	//				return true;
	//		return false;
	//	}
	//
	//	// tells whether qtype is string
	//	public boolean isString() {
	//		int size = list.size();
	//		for (int i = 0; i < size; i++)
	//			if (((QType) list.get(i)).isString())
	//				return true;
	//		return false;
	//	}
	//
	//	// tells whether qtype is an atom
	//	public boolean isAtom() {
	//		int size = list.size();
	//		for (int i = 0; i < size; i++)
	//			if (((QType) list.get(i)).isAtom())
	//				return true;
	//		return false;
	//	}
	//
	//	// tells whether qtype can react to text()
	//	public boolean isText() {
	//		Iterator it = list.iterator();
	//		while (it.hasNext())
	//			if (((QType) it.next()).isText())
	//				return true;
	//		return false;
	//	}
	//
	//	// tells whether qtype is a date or collection of dates
	//	public boolean isDate() {
	//		Iterator it = list.iterator();
	//		while (it.hasNext())
	//			if (((QType) it.next()).isDate())
	//				return true;
	//		return false;
	//	}
	//
	//	// tells whether qtype is a attribte or collection or sequence
	//	public boolean isAttribute() {
	//		Iterator it = list.iterator();
	//		while (it.hasNext())
	//			if (((QType) it.next()).isAttribute())
	//				return true;
	//		return false;
	//	}
	//
	//	// tells whether qtype is a ID, IDREF or IDREFS type
	//	public boolean isIDAttribute() {
	//		Iterator it = list.iterator();
	//		while (it.hasNext())
	//			if (((QType) it.next()).isIDAttribute())
	//				return true;
	//		return false;
	//	}
	//
	//	// tells whether qtype is a node
	//	public boolean isNode() {
	//		Iterator it = list.iterator();
	//		while (it.hasNext())
	//			if (((QType) it.next()).isNode())
	//				return true;
	//		return false;
	//	}
	//
	//	// tells whether qtype is a node with simple type
	//	public boolean isSimpleTypeNode() {
	//		Iterator it = list.iterator();
	//		while (it.hasNext())
	//			if (((QType) it.next()).isSimpleTypeNode())
	//				return true;
	//		return false;
	//	}

	//	// tells whether qtype is a document
	//	public boolean isDocument() {
	//		Iterator it = list.iterator();
	//		while (it.hasNext())
	//			if (((QType) it.next()).isDocument())
	//				return true;
	//		return false;
	//	}
	//
	//	// tells whether qtype is multiple
	//	public boolean isMultiple() {
	//		Iterator it = list.iterator();
	//		while (it.hasNext())
	//			if (((QType) it.next()).isMultiple())
	//				return true;
	//		return false;
	//	}
	//
	//	// tells whether qtype is atomic (atom or element with simple content
	//	public boolean isAtomic() {
	//		Iterator it = list.iterator();
	//		while (it.hasNext())
	//			if (((QType) it.next()).isAtomic())
	//				return true;
	//		return false;
	//	}
	//
	//	// tells whether qtype is mixed
	//	public boolean isMixed() {
	//		Iterator it = list.iterator();
	//		while (it.hasNext())
	//			if (((QType) it.next()).isMixed())
	//				return true;
	//		return false;
	//	}
	//
	//	// tells whether qtype is element
	//	public boolean isElement() {
	//		Iterator it = list.iterator();
	//		while (it.hasNext())
	//			if (((QType) it.next()).isElement())
	//				return true;
	//		return false;
	//	}
	//
	//	public boolean canBeComparedTo(QType compType) {
	//		if (compType == null)
	//			return false;
	//		Iterator it = list.iterator();
	//		while (it.hasNext())
	//			if (((QType) it.next()).canBeComparedTo(compType))
	//				return true;
	//		return false;
	//	}

	//	public QType applyDATAFunction() throws TypeException {
	//		ArrayList newList = new ArrayList();
	//		Iterator it = list.iterator();
	//		while (it.hasNext()) {
	//			QType qtype = (QType) it.next();
	//			qtype = qtype.applyDATAFunction();
	//			if (qtype != null)
	//				newList.add(qtype);
	//		}
	//		if (!newList.isEmpty()) {
	//			if (newList.size() == 1)
	//				return (QType) newList.get(0);
	//			else
	//				return new QTypeUnion(newList);
	//		}
	//		return null;
	//	}
	//
	//	public QType uncollect() throws TypeException {
	//		ArrayList newList = new ArrayList();
	//		Iterator it = list.iterator();
	//		while (it.hasNext()) {
	//			QType qtype = (QType) it.next();
	//			qtype = qtype.unMultiple();
	//			if (qtype != null)
	//				newList.add(qtype);
	//		}
	//		if (!newList.isEmpty()) {
	//			if (newList.size() == 1)
	//				return (QType) newList.get(0);
	//			else
	//				return new QTypeUnion(newList);
	//		}
	//		return null;
	//	}

	// clone
	public Object clone() throws CloneNotSupportedException {
		QTypeUnion newObj = new QTypeUnion(list, occurence);
		return newObj;
	}
	// print
	public String toSimpleString() {
		return "QTypeUnion(" + list + ")";
	}

	public String toString() {
		return "QTypeUnion(" + list + ")";
	}
}
