/*
 * This file belongs to the XQuark distribution.
 * Copyright (C) 2003 XQuark Group.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquark.org.
 */

package org.xquark.xquery.typing;

import org.xquark.schema.Particle;
import org.xquark.schema.SchemaManager;
import org.xquark.xpath.StepExpr;
import org.xquark.xquery.parser.TypeException;

public class Utils {

	private static ComputeSubTypeVisitor subTypeVisistor = null;

	public static QType getSubType(byte contextType, QType qtype, StepExpr step, SchemaManager schemamanager) throws TypeException {
		if (subTypeVisistor == null)
			subTypeVisistor = new ComputeSubTypeVisitor();
		subTypeVisistor.reset(contextType, step, schemamanager);
		try {
			qtype.accept(subTypeVisistor);
		} catch (Exception e) {
			throw new TypeException(e.getMessage());
		}
		return subTypeVisistor.getResultQType();
	}

	private static OccurrenceVisitor occurrenceVisistor = null;

	public static OccurrenceVisitor getOccurrenceVisitor() {
		return occurrenceVisistor;
	}

	public static void getSubType(Particle particle, String namespace, String name, SchemaManager schemamanager) throws TypeException {
		if (occurrenceVisistor == null)
			occurrenceVisistor = new OccurrenceVisitor();
		occurrenceVisistor.reset(namespace, name, schemamanager);
		try {
			particle.accept(occurrenceVisistor);
		} catch (Exception e) {
			throw new TypeException(e.getMessage());
		}
	}

}
