/* Generated By:JavaCC: Do not edit this line. xqueryParser.java */
package org.xquark.xquery.parser;

import java.net.URL;
import java.util.*;

import org.xquark.util.NamespaceContextStack;
import org.xquark.xpath.Axis;
import org.xquark.xpath.NodeKind;
import org.xquark.xquery.parser.hinttree.HintTree;
import org.xquark.xquery.parser.normalize.LocatedExpressionReducer;
import org.xquark.xquery.parser.normalize.NormalizeException;
import org.xquark.xquery.parser.primitivefunctions.fnfunctions.FunctionCONCAT;
import org.xquark.xquery.parser.primitivefunctions.xsfunctions.*;
import org.xquark.xquery.parser.util.Constants;

public class xqueryParser implements xqueryParserConstants {
        private static final String RCSRevision = "$Revision$";
        private static final String RCSName = "$Name$";

        // for debug purpose
        private boolean debug = true;

        // to restrict parser, by default: true
        private boolean restriction = true;

        //private Token previousToken = null;
        private Token currentToken = null;
        private TypeVisitor typevisitor = null;

        private final String VAR_NAME = "var";
        private int varIndex = 0;

        private ParserFactoryInterfaceMediator factory = null;

        /* a Map from view name to view definition(String)*/
        private Map viewDefinitions = null;

        private HashMap funDefNames = new HashMap();
        private HashMap varDefNames = new HashMap();
        private HashMap linkMap = new HashMap();
        private HashMap realVarNames = new HashMap();

        private NamespaceContextStack hashDeclList = null;

        private HashMap hashFuncList = null;
        private String defaultNameSpace = null;
        private String defaultCollation = null;
        private boolean xmlspace = true; // "strip" default value (preserve -> false)

        private HashMap hashParamList = null;
        private boolean renameVars = true;
        private String baseURI = null;
        private boolean inPredicate = false;
        private Stack stateStack = new Stack();

        public void setRenameVars(boolean rename) {
                renameVars = rename;
        }

        public void setBaseURI(String uri) {
                baseURI = uri;
        }

        private String chop(String s) {
                return s.substring(1);
        }

        private String unquote(String s) {
                return s.substring(1, s.length()-1);
        }

        private String getNameSpace(String prefixname) {
                if (prefixname == null) return  null;
                return hashDeclList.getNamespaceURI(prefixname);
        }

        private void setTypeVisitor(TypeVisitor visitor) {
                typevisitor = visitor;
        }

        public void setFactory(String factoryClassName) throws ParseException {
                try {
                        Class c = Class.forName (factoryClassName) ;
                        factory = (ParserFactoryInterfaceMediator) c.newInstance () ;
                }
                catch (ClassNotFoundException e) {
                        throw new ParseException("Could not find class " + factoryClassName);
                }
                catch (Exception e) {
                        throw new ParseException("Could not instantiate factory");
                }
        }


        public void setViewDefinitions(Map viewDefinitions) {
                this.viewDefinitions = viewDefinitions;
        }

        /* parses a view */
        /*
	private XQueryExpression view(String viewDefinition) throws ParseException , Exception {
		xqueryParser parser = new xqueryParser(new StringReader("dummy"));
		parser.setFactory("org.xquark.xquery.parser.ParserFactoryMediator");
		parser.setViewDefinitions(viewDefinitions);
		parser.ReInit(new StringReader(viewDefinition));
		XQueryFile file = parser.Start(typevisitor);
		XQueryUnit unit = (XQueryUnit)file.getUnit(0);
		return (XQueryExpression)unit.getExpressions().get(0);
	}
	*/
        private String parsePredefinedEntityRef(String predefinedEntityRef) throws ParseException {
                if (predefinedEntityRef.equals("&lt;")) return "<";
                if (predefinedEntityRef.equals("&gt;")) return ">";
                if (predefinedEntityRef.equals("&amp;")) return "&";
                if (predefinedEntityRef.equals("&quot;")) return "\"";
                if (predefinedEntityRef.equals("&apos;")) return "'";
                throw new ParseException("Invalid token error.");
        }

        private static String parseCharRef(String charRef) {
                Character ch = null;
                int value = -1;
                if (charRef.startsWith("&#x")) value = Integer.parseInt(charRef.substring(3, charRef.length() - 1), 16);
                else value = Integer.parseInt(charRef.substring(2, charRef.length() - 1));
                switch(value) {
                        case(9):
                                return "\t";
                        case(10):
                                return "\n";
                        case(13):
                                return "\r";
                        default:
                                ch = new Character((char)value);
                                return ch.toString();
                }
        }

        private void switchState(int newState) {
                //System.out.println("Old State = " + ((Integer)stateStack.peek()).intValue());
                stateStack.pop();
                stateStack.push(new Integer(newState));
                token_source.SwitchTo(newState);
                //System.out.println("New State = " + ((Integer)stateStack.peek()).intValue());
        }

        private void pushState(int newState) {
                //System.out.println("Old State = " + ((Integer)stateStack.peek()).intValue());
                stateStack.push(new Integer(newState));
                token_source.SwitchTo(newState);
                //System.out.println("New State = " + ((Integer)stateStack.peek()).intValue());
        }

        private void popState() {
                //System.out.println("Old State = " + ((Integer)stateStack.peek()).intValue());
                stateStack.pop();
                token_source.SwitchTo(((Integer)stateStack.peek()).intValue());
                //System.out.println("New State = " + ((Integer)stateStack.peek()).intValue());
        }

        public XQueryFile Start(TypeVisitor typevisitor) throws ParseException, Exception {
                return Start(typevisitor, true);
        }

  final public XQueryFile Start(TypeVisitor typevisitor, boolean restriction) throws ParseException, ParseException, Exception {
        this.restriction = restriction;
        if (factory == null) factory = new ParserFactoryMediator();
        XQueryFile queryFile = null;
        varIndex = 0;
        setTypeVisitor(typevisitor);
        stateStack.clear();
        stateStack.push(new Integer(DEFAULT));
    try {
      queryFile = XQueryFile();
      jj_consume_token(0);
                        {if (true) return queryFile;}
    } catch (TypeException te) {
                String strmsg = te.getMessage();
                Set entries = linkMap.entrySet();
                Iterator it = entries.iterator();
                while (it.hasNext())
                {
                        Map.Entry entry = (Map.Entry)it.next();
                        String search = (String)entry.getValue();
                        int index=-1;
                        while ((index = strmsg.indexOf(search, index+1)) != -1)
                        {
                                strmsg = strmsg.substring(0, index)+(String)entry.getKey()+strmsg.substring(index+search.length());
                        }
                }
                {if (true) throw new TypeException(strmsg);}
    } catch (TokenMgrError tme) {
                {if (true) throw new ParseException(tme.getMessage());}
    }
    throw new Error("Missing return statement in function");
  }

/**************************************************************************************
[0]		XQueryFile ::=						Query
**************************************************************************************/
  final public XQueryFile XQueryFile() throws ParseException, ParseException, Exception {
        if (factory == null) factory = new ParserFactoryMediator();
        XQueryUnit queryUnit = null;
        ArrayList resVect = new ArrayList();
    queryUnit = Query();
                        resVect.add(queryUnit);
                try
                {
                        {if (true) return factory.createXQueryFile(resVect, typevisitor);}
                }
                catch (TypeException te)
                {
                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                }
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[1]		Query ::=							QueryProlog QueryBody
***************************************************************************************/
  final public XQueryUnit Query() throws ParseException, ParseException, Exception {
        if (factory == null) factory = new ParserFactoryMediator();
        ContextDeclaration contextDeclaration = null;
        hashDeclList = new NamespaceContextStack();
        // XQuery has four predefined namespace prefixes
        // "xml" add in hashDeclList by default, cf NamespaceContextStack.java
        //hashDeclList.declarePrefix("xml", "http://www.w3.org/XML/1998/namespace");
        // for now we doesn't declare these prefix: "xs", "xsd" and "xsi"
        //hashDeclList.declarePrefix("xs", "http://www.w3.org/2001/XMLSchema");
        //hashDeclList.declarePrefix("xsd", "http://www.w3.org/2001/XMLSchema-datatypes");
        //hashDeclList.declarePrefix("xsi", "http://www.w3.org/2001/XMLSchema-instance");
        hashFuncList = new HashMap();
        hashParamList = new HashMap();
        ArrayList tmpVect = null;
        XQueryExpression expression = null;
        defaultNameSpace = null;
        NamespaceContextStack mainContext = new NamespaceContextStack();
                funDefNames.clear();
                varDefNames.clear();
                realVarNames.clear();
    QueryProlog();
    /*		{
    			List list = hashDeclList.getDeclaredPrefixes();
    			for (int i = 0; i < list.size(); i++)
    			{
    				String prefix = (String)list.get(i);
    				if (prefix.equals("xml")) continue;
    				mainContext.declarePrefix(prefix, hashDeclList.getNamespaceURI(prefix));
    			}
    		}
    */              expression = QueryBody();
                        tmpVect = ((XQueryExpressionSequence)expression).getSubExpressions();
                if (hashFuncList.isEmpty()) hashFuncList = null;
                try
                {
                        {if (true) return factory.createXQueryUnit(hashDeclList, hashFuncList, tmpVect, defaultCollation, typevisitor);}
                }
                catch (TypeException te)
                {
                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                }
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[2]		QueryProlog ::=						( OldDeclaration | NamespaceDecl | XMLSpaceDecl | DefaultNamespaceDecl | DefaultCollationDecl | SchemaImport )* FunctionDefn*
		W3C WD 16 August 2002 ->			( NamespaceDecl | XMLSpaceDecl | DefaultNamespaceDecl | DefaultCollationDecl | SchemaImport )* FunctionDefn*
***************************************************************************************/
  final public void QueryProlog() throws ParseException, ParseException, Exception {
        ContextDeclaration contextDeclaration = null;
        FunctionDefinition functionDefinition = null;
    label_1:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case DECLARE_XMLSPACE_EQUALS:
      case DECLARE_NAMESPACE:
      case DECLARE_PARAMETER:
      case DEFAULT_ELEMENT_NAMESPACE_EQUALS:
      case DEFAULT_FUNCTION_NAMESPACE_EQUALS:
      case DEFAULT_COLLATION_EQUALS:
      case DEFAULT_NAMESPACE:
      case IMPORT_SCHEMA:
      case NAMESPACE_DT:
        ;
        break;
      default:
        jj_la1[0] = jj_gen;
        break label_1;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case DEFAULT_NAMESPACE:
      case NAMESPACE_DT:
        OldDeclaration();
        break;
      case DECLARE_NAMESPACE:
        NamespaceDecl();
        break;
      case DECLARE_XMLSPACE_EQUALS:
        XMLSpaceDecl();
        break;
      case DEFAULT_ELEMENT_NAMESPACE_EQUALS:
      case DEFAULT_FUNCTION_NAMESPACE_EQUALS:
        DefaultNamespaceDecl();
        break;
      case DEFAULT_COLLATION_EQUALS:
        DefaultCollationDecl();
        break;
      case IMPORT_SCHEMA:
        SchemaImport();
        break;
      case DECLARE_PARAMETER:
        DeclareParameter();
        break;
      default:
        jj_la1[1] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
    label_2:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case DEFINE_FUNCTION:
        ;
        break;
      default:
        jj_la1[2] = jj_gen;
        break label_2;
      }
      functionDefinition = FunctionDefn();
                        hashFuncList.put(functionDefinition.getFuncName().getName(),functionDefinition);
                        varDefNames.clear();
    }
  }

/***************************************************************************************
[3]		QueryBody ::=						ExprSequence?
***************************************************************************************/
  final public XQueryExpressionSequence QueryBody() throws ParseException, ParseException, Exception {
        XQueryExpression expression = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case AND:
    case ASCENDING:
    case AT:
    case ATTRIBUTE:
    case ATTRIBUTE_DCOLON:
    case ATTRIBUTE_L_BRACE:
    case BY:
    case CASE:
    case CAST_AS:
    case CDATA_START:
    case CHILD_DCOLON:
    case COMMENT_L_PAREN_R_PAREN:
    case DEFAULT_:
    case DESCENDANT_DCOLON:
    case DESCENDANT_SELF_DCOLON:
    case DESCENDING:
    case DIVISION:
    case DOCUMENT_L_BRACE:
    case DOT:
    case DOTDOT:
    case DecimalLiteral:
    case DoubleLiteral:
    case ELEMENT:
    case ELEMENT_L_BRACE:
    case ELSE:
    case EVERY:
    case EXCEPT:
    case FOR:
    case IF_L_PAREN:
    case IN:
    case INTEGER_DIVISION:
    case INTERSECT:
    case IS:
    case ISNOT:
    case IntegerLiteral:
    case LESS_THAN:
    case LET:
    case L_PAREN:
    case MINUS:
    case MODULO:
    case NODE_L_PAREN_R_PAREN:
    case OR:
    case PARENT_DCOLON:
    case PLUS:
    case PROCESSING_INSTRUCTION_L_PAREN:
    case RETURN:
    case SATISFIES:
    case SELF_DCOLON:
    case SLASH:
    case SLASHSLASH:
    case SOME:
    case SORT:
    case SORTBY:
    case STABLE:
    case STAR:
    case StringLiteral:
    case TEXT_L_PAREN_R_PAREN:
    case TO:
    case TREAT_AS:
    case TYPESWITCH_L_PAREN:
    case UNION:
    case UNORDERED:
    case VALIDATE:
    case VALUE_EQUALS:
    case VALUE_GREATER_THAN:
    case VALUE_GREATER_THAN_EQUALS:
    case VALUE_LESS_THAN:
    case VALUE_LESS_THAN_EQUALS:
    case VALUE_NOT_EQUALS:
    case VARName:
    case WHERE:
    case XMLCOMMENT_START:
    case XMLPROCESSING_START:
    case NCName:
    case START_TAG_NCName:
    case END_TAG_NCName:
    case ELT_LESS_THAN:
    case ELT_XMLCOMMENT_START:
    case ELT_XMLPROCESSING_START:
    case ELT_CDATA_START:
      expression = ExprSequence(true);
      break;
    default:
      jj_la1[3] = jj_gen;
      ;
    }
                        {if (true) return (XQueryExpressionSequence)expression;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[4]		ExprSequence ::=					Expr ( ", " Expr )*
***************************************************************************************/
  final public XQueryExpression ExprSequence(boolean forceSequence) throws ParseException, ParseException, Exception {
        XQueryExpression expression = null;
        ArrayList sequence = new ArrayList(1);
    expression = Expr();
                        sequence.add(expression);
    label_3:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        jj_la1[4] = jj_gen;
        break label_3;
      }
      currentToken = jj_consume_token(COMMA);

      expression = Expr();
                                sequence.add(expression);
    }
                try
                {
                        if (forceSequence)
                        {
                                {if (true) return factory.createXQueryExpressionSequence(sequence, typevisitor);}
                        }
                        if (sequence.size() > 1)
                        {
                                {if (true) return factory.createXQueryExpressionSequence(sequence, typevisitor);}
                        }
                        else
                        {
                                {if (true) return expression;}
                        }
                }
                catch (TypeException te)
                {
                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                }
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[5]		Expr ::=							SortExpr
***************************************************************************************/
  final public XQueryExpression Expr() throws ParseException, ParseException, Exception {
        XQueryExpression expression = null;
    expression = SortExpr();
                {if (true) return expression;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[6]		SortExpr ::=						OrExpr ( "stable"? ( <"sortby" "("> | <"sort" "by" "("> ) SortSpecList ")" )*
		W3C WD 16 August 2002 ->			OrExpr ( "stable"? <"sort" "by" "("> SortSpecList ")" )*
***************************************************************************************/
  final public XQueryExpression SortExpr() throws ParseException, ParseException, Exception {
        XQueryExpression expression = null;
        boolean stable = false;
        ArrayList tmpVect = null;
        ArrayList sortSpecList = new ArrayList(1);
        boolean oldInPredicate = false;
    expression = OrExpr();
    label_4:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SORT:
      case SORTBY:
      case STABLE:
        ;
        break;
      default:
        jj_la1[5] = jj_gen;
        break label_4;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case STABLE:
        currentToken = jj_consume_token(STABLE);
                                        //previousToken = currentToken;
                                        // if (debug) System.out.println("SortExpr - Read <STABLE> " + currentToken.image);
                                        if (restriction) {if (true) throw new ParseException("Encountered \"" + currentToken.image + "\" at line " + currentToken.beginLine + ", column " + currentToken.beginColumn + ". \"stable\" in SortExpr is not supported yet.");}
                                        stable = true;
        break;
      default:
        jj_la1[6] = jj_gen;
        ;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SORT:
        currentToken = jj_consume_token(SORT);

        currentToken = jj_consume_token(BY);

        currentToken = jj_consume_token(L_PAREN);

        break;
      case SORTBY:
        currentToken = jj_consume_token(SORTBY);

        currentToken = jj_consume_token(L_PAREN);

        break;
      default:
        jj_la1[7] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
                                oldInPredicate = inPredicate;
                                inPredicate = true;
      tmpVect = SortSpecList();
                                sortSpecList.addAll(tmpVect);
                                inPredicate = oldInPredicate;
      currentToken = jj_consume_token(R_PAREN);

    }
                if (!sortSpecList.isEmpty())
                {
                        try
                        {
                                {if (true) return factory.createSortedExpression(expression, sortSpecList, stable, typevisitor);}
                        }
                        catch (TypeException te)
                        {
                                {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                        }
                }
                {if (true) return expression;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[7]		OrExpr ::=							AndExpr ( "or" AndExpr )*
***************************************************************************************/
  final public XQueryExpression OrExpr() throws ParseException, ParseException, Exception {
        XQueryExpression mainExpression = null;
        XQueryExpression expression = null;
        BinOpORExpression binOpORExpression = null;
    mainExpression = AndExpr();
    label_5:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case OR:
        ;
        break;
      default:
        jj_la1[8] = jj_gen;
        break label_5;
      }
      currentToken = jj_consume_token(OR);

      expression = AndExpr();
                                try
                                {
                                        binOpORExpression = factory.createBinOpORExpression(mainExpression, expression, typevisitor);
                                }
                                catch (TypeException te)
                                {
                                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                                }
                                mainExpression = binOpORExpression;
    }
                {if (true) return mainExpression;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[8]		AndExpr ::=							UnorderedExpr ( "and" UnorderedExpr )*
***************************************************************************************/
  final public XQueryExpression AndExpr() throws ParseException, ParseException, Exception {
        XQueryExpression mainExpression = null;
        XQueryExpression expression = null;
        BinOpANDExpression binOpANDExpression = null;
    mainExpression = UnorderedExpr();
    label_6:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case AND:
        ;
        break;
      default:
        jj_la1[9] = jj_gen;
        break label_6;
      }
      currentToken = jj_consume_token(AND);

      expression = UnorderedExpr();
                                try
                                {
                                        binOpANDExpression = factory.createBinOpANDExpression(mainExpression, expression, typevisitor);
                                }
                                catch (TypeException te)
                                {
                                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                                }
                                mainExpression = binOpANDExpression;
    }
                {if (true) return mainExpression;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[9]		UnorderedExpr ::=					"unordered"? FLWRExpr
***************************************************************************************/
  final public XQueryExpression UnorderedExpr() throws ParseException, ParseException, Exception {
        XQueryExpression expression = null;
        boolean unordered = false;
    if (jj_2_1(2)) {
      currentToken = jj_consume_token(UNORDERED);
                        //previousToken = currentToken;
                        // if (debug) System.out.println("UnorderedExpr - Read <UNORDERED> " + currentToken.image);
                        unordered = true;
    } else {
      ;
    }
    expression = FLOWRExpr();
                expression.setUnordered(unordered);
                {if (true) return expression;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[10]	FLWRExpr ::=						( ( ForClause | LetClause )+ HintClause? WhereClause? "return" )* QuantifiedExpr
		W3C WD 16 August 2002 ->			( ( ForClause | LetClause )+ WhereClause? "return" )* QuantifiedExpr
***************************************************************************************/
  final public XQueryExpression FLOWRExpr() throws ParseException, ParseException, Exception {
        XQueryExpression whereClause = null;
        XQueryExpression returnClause = null;
        ArrayList bindings = new ArrayList();
        ArrayList orderbys = null;
        ArrayList tmpVect = null;
        HintTree hintClause = null;
    if (jj_2_2(4)) {
      label_7:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case FOR:
          tmpVect = ForClause();
          break;
        case LET:
          tmpVect = LetClause();
          break;
        default:
          jj_la1[10] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
                                        bindings.addAll(tmpVect);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case FOR:
        case LET:
          ;
          break;
        default:
          jj_la1[11] = jj_gen;
          break label_7;
        }
      }
                                whereClause = null;
                                orderbys = null;
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case CARTESIAN_PRODUCT:
      case END_PRAGMA:
      case HINT_OUTER_MERGE:
      case HINT_OUTER_NESTED:
      case JOIN:
      case MERGE:
      case NESTED_LOOP:
        hintClause = HintClause();
        break;
      default:
        jj_la1[12] = jj_gen;
        ;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case WHERE:
        whereClause = WhereClause();
        break;
      default:
        jj_la1[13] = jj_gen;
        ;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ORDER:
        orderbys = OrderExpr();
        break;
      default:
        jj_la1[14] = jj_gen;
        ;
      }
      currentToken = jj_consume_token(RETURN);
      returnClause = FLOWRExpr();
                                for (int i = 0; i < bindings.size(); i++)
                                {
                                        varDefNames.remove(((Variable) bindings.get(i)).print());
                                        realVarNames.remove(((Variable) bindings.get(i)).print());
                                }
                                try
                                {
                                        {if (true) return factory.createFLWRExpression(bindings, hintClause, whereClause, orderbys, returnClause, typevisitor);}
                                }
                                catch (TypeException te)
                                {
                                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                                }
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case AND:
      case ASCENDING:
      case AT:
      case ATTRIBUTE:
      case ATTRIBUTE_DCOLON:
      case ATTRIBUTE_L_BRACE:
      case BY:
      case CASE:
      case CAST_AS:
      case CDATA_START:
      case CHILD_DCOLON:
      case COMMENT_L_PAREN_R_PAREN:
      case DEFAULT_:
      case DESCENDANT_DCOLON:
      case DESCENDANT_SELF_DCOLON:
      case DESCENDING:
      case DIVISION:
      case DOCUMENT_L_BRACE:
      case DOT:
      case DOTDOT:
      case DecimalLiteral:
      case DoubleLiteral:
      case ELEMENT:
      case ELEMENT_L_BRACE:
      case ELSE:
      case EVERY:
      case EXCEPT:
      case FOR:
      case IF_L_PAREN:
      case IN:
      case INTEGER_DIVISION:
      case INTERSECT:
      case IS:
      case ISNOT:
      case IntegerLiteral:
      case LESS_THAN:
      case LET:
      case L_PAREN:
      case MINUS:
      case MODULO:
      case NODE_L_PAREN_R_PAREN:
      case OR:
      case PARENT_DCOLON:
      case PLUS:
      case PROCESSING_INSTRUCTION_L_PAREN:
      case RETURN:
      case SATISFIES:
      case SELF_DCOLON:
      case SLASH:
      case SLASHSLASH:
      case SOME:
      case SORT:
      case SORTBY:
      case STABLE:
      case STAR:
      case StringLiteral:
      case TEXT_L_PAREN_R_PAREN:
      case TO:
      case TREAT_AS:
      case TYPESWITCH_L_PAREN:
      case UNION:
      case UNORDERED:
      case VALIDATE:
      case VALUE_EQUALS:
      case VALUE_GREATER_THAN:
      case VALUE_GREATER_THAN_EQUALS:
      case VALUE_LESS_THAN:
      case VALUE_LESS_THAN_EQUALS:
      case VALUE_NOT_EQUALS:
      case VARName:
      case WHERE:
      case XMLCOMMENT_START:
      case XMLPROCESSING_START:
      case NCName:
      case START_TAG_NCName:
      case END_TAG_NCName:
      case ELT_LESS_THAN:
      case ELT_XMLCOMMENT_START:
      case ELT_XMLPROCESSING_START:
      case ELT_CDATA_START:
        returnClause = QuantifiedExpr();
                        {if (true) return returnClause;}
        break;
      default:
        jj_la1[15] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[11]	QuantifiedExpr ::=					( ( "some" | "every" ) Param "in" Expr ( ", " Param "in" Expr)* "satisfies" )* TypeswitchExpr
		W3C WD 16 August 2002 ->			( ( "some" | "every" ) TypeDeclaration? "$" VarName "in" Expr ( ", " TypeDeclaration? "$" VarName "in" Expr)* "satisfies" )* TypeswitchExpr
***************************************************************************************/
  final public XQueryExpression QuantifiedExpr() throws ParseException, ParseException, Exception {
        int kind = -1;
        XQueryExpression var = null;
        ArrayList varlist = new ArrayList();
        XQueryExpression expression = null;
        XQueryExpression satisfies = null;
    if (jj_2_3(4)) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SOME:
        currentToken = jj_consume_token(SOME);
                                        //previousToken = currentToken;
                                        // if (debug) System.out.println("QuantifiedExpr - Read <SOME> " + currentToken.image);
                                        kind = Constants.SOME_QUANTIFIER;
        break;
      case EVERY:
        currentToken = jj_consume_token(EVERY);
                                        //previousToken = currentToken;
                                        // if (debug) System.out.println("QuantifiedExpr - Read <EVERY> " + currentToken.image);
                                        kind = Constants.EVERY_QUANTIFIER;
        break;
      default:
        jj_la1[16] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      var = Param(true);
      currentToken = jj_consume_token(IN);

      expression = Expr();
                                        var.setBindingType(Constants.QUANTIFIER_BINDINGTYPE);
                                        var.setExpression(expression, typevisitor);
                                        if (typevisitor != null)
                                        {
                                                var.accept(typevisitor);
                                        }
                                        varDefNames.put(var.print(), var);
                                        varlist.add(var);
      label_8:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[17] = jj_gen;
          break label_8;
        }
        currentToken = jj_consume_token(COMMA);

        var = Param(true);
        currentToken = jj_consume_token(IN);

        expression = Expr();
                                                var.setBindingType(Constants.QUANTIFIER_BINDINGTYPE);
                                                var.setExpression(expression, typevisitor);
                                                if (typevisitor != null)
                                                {
                                                        var.accept(typevisitor);
                                                }
                                                varDefNames.put(var.print(), var);
                                                varlist.add(var);
      }
      currentToken = jj_consume_token(SATISFIES);
      satisfies = QuantifiedExpr();
                                for (int i=0;i<varlist.size();i++)
                                {
                                        varDefNames.remove(((Variable)varlist.get(i)).print());
                                        realVarNames.remove(((Variable)varlist.get(i)).print());
                                }
                                try
                                {
                                        {if (true) return factory.createQuantifiedExpression(kind, varlist, satisfies, typevisitor);}
                                }
                                catch (TypeException te)
                                {
                                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                                }
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case AND:
      case ASCENDING:
      case AT:
      case ATTRIBUTE:
      case ATTRIBUTE_DCOLON:
      case ATTRIBUTE_L_BRACE:
      case BY:
      case CASE:
      case CAST_AS:
      case CDATA_START:
      case CHILD_DCOLON:
      case COMMENT_L_PAREN_R_PAREN:
      case DEFAULT_:
      case DESCENDANT_DCOLON:
      case DESCENDANT_SELF_DCOLON:
      case DESCENDING:
      case DIVISION:
      case DOCUMENT_L_BRACE:
      case DOT:
      case DOTDOT:
      case DecimalLiteral:
      case DoubleLiteral:
      case ELEMENT:
      case ELEMENT_L_BRACE:
      case ELSE:
      case EVERY:
      case EXCEPT:
      case FOR:
      case IF_L_PAREN:
      case IN:
      case INTEGER_DIVISION:
      case INTERSECT:
      case IS:
      case ISNOT:
      case IntegerLiteral:
      case LESS_THAN:
      case LET:
      case L_PAREN:
      case MINUS:
      case MODULO:
      case NODE_L_PAREN_R_PAREN:
      case OR:
      case PARENT_DCOLON:
      case PLUS:
      case PROCESSING_INSTRUCTION_L_PAREN:
      case RETURN:
      case SATISFIES:
      case SELF_DCOLON:
      case SLASH:
      case SLASHSLASH:
      case SOME:
      case SORT:
      case SORTBY:
      case STABLE:
      case STAR:
      case StringLiteral:
      case TEXT_L_PAREN_R_PAREN:
      case TO:
      case TREAT_AS:
      case TYPESWITCH_L_PAREN:
      case UNION:
      case UNORDERED:
      case VALIDATE:
      case VALUE_EQUALS:
      case VALUE_GREATER_THAN:
      case VALUE_GREATER_THAN_EQUALS:
      case VALUE_LESS_THAN:
      case VALUE_LESS_THAN_EQUALS:
      case VALUE_NOT_EQUALS:
      case VARName:
      case WHERE:
      case XMLCOMMENT_START:
      case XMLPROCESSING_START:
      case NCName:
      case START_TAG_NCName:
      case END_TAG_NCName:
      case ELT_LESS_THAN:
      case ELT_XMLCOMMENT_START:
      case ELT_XMLPROCESSING_START:
      case ELT_CDATA_START:
        satisfies = TypeswitchExpr();
                        {if (true) return satisfies;}
        break;
      default:
        jj_la1[18] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[12]	TypeswitchExpr ::=					( <"typeswitch" "("> Expr ")" CaseClause+ "default" VAR? "return" )* IfExpr
		W3C WD 16 August 2002 ->			( <"typeswitch" "("> Expr ")" CaseClause+ "default" ("$" VarName)? "return" )* IfExpr
***************************************************************************************/
  final public XQueryExpression TypeswitchExpr() throws ParseException, ParseException, Exception {
        XQueryExpression switchExpression = null;
        CaseClauseExpression caseClause = null;
        XQueryExpression returnClause = null;
        HashMap cases = new HashMap();
        XQueryExpression var = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case TYPESWITCH_L_PAREN:
      currentToken = jj_consume_token(TYPESWITCH_L_PAREN);
                                //previousToken = currentToken;
                                // if (debug) System.out.println("TypeswitchExpr - Read <TYPESWITCH_L_PAREN> " + currentToken.image);
                                if (restriction) {if (true) throw new ParseException("Encountered \"" + currentToken.image + "\" at line " + currentToken.beginLine + ", column " + currentToken.beginColumn + ". TypeswitchExpr is not supported yet.");}
      switchExpression = Expr();
      currentToken = jj_consume_token(R_PAREN);

      label_9:
      while (true) {
        caseClause = CaseClause();
                                        cases.put(caseClause.getSequenceType(), caseClause);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case CASE:
          ;
          break;
        default:
          jj_la1[19] = jj_gen;
          break label_9;
        }
      }
      currentToken = jj_consume_token(DEFAULT_);
                                //previousToken = currentToken;
                                // if (debug) System.out.println("TypeswitchExpr - Read <DEFAULT_> " + currentToken.image);
                                var = null;
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case VARName:
        var = VAR(false, false);
        break;
      default:
        jj_la1[20] = jj_gen;
        ;
      }
      currentToken = jj_consume_token(RETURN);
      returnClause = TypeswitchExpr();
                                try
                                {
                                        if (var != null)
                                        {
                                                {if (true) return factory.createTypeSwitchExpression(switchExpression, cases, (Variable)var, returnClause, typevisitor);}
                                        }
                                        else
                                        {
                                                {if (true) return factory.createTypeSwitchExpression(switchExpression, cases, null, returnClause, typevisitor);}
                                        }
                                }
                                catch (TypeException te)
                                {
                                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                                }
      break;
    case AND:
    case ASCENDING:
    case AT:
    case ATTRIBUTE:
    case ATTRIBUTE_DCOLON:
    case ATTRIBUTE_L_BRACE:
    case BY:
    case CASE:
    case CAST_AS:
    case CDATA_START:
    case CHILD_DCOLON:
    case COMMENT_L_PAREN_R_PAREN:
    case DEFAULT_:
    case DESCENDANT_DCOLON:
    case DESCENDANT_SELF_DCOLON:
    case DESCENDING:
    case DIVISION:
    case DOCUMENT_L_BRACE:
    case DOT:
    case DOTDOT:
    case DecimalLiteral:
    case DoubleLiteral:
    case ELEMENT:
    case ELEMENT_L_BRACE:
    case ELSE:
    case EVERY:
    case EXCEPT:
    case FOR:
    case IF_L_PAREN:
    case IN:
    case INTEGER_DIVISION:
    case INTERSECT:
    case IS:
    case ISNOT:
    case IntegerLiteral:
    case LESS_THAN:
    case LET:
    case L_PAREN:
    case MINUS:
    case MODULO:
    case NODE_L_PAREN_R_PAREN:
    case OR:
    case PARENT_DCOLON:
    case PLUS:
    case PROCESSING_INSTRUCTION_L_PAREN:
    case RETURN:
    case SATISFIES:
    case SELF_DCOLON:
    case SLASH:
    case SLASHSLASH:
    case SOME:
    case SORT:
    case SORTBY:
    case STABLE:
    case STAR:
    case StringLiteral:
    case TEXT_L_PAREN_R_PAREN:
    case TO:
    case TREAT_AS:
    case UNION:
    case UNORDERED:
    case VALIDATE:
    case VALUE_EQUALS:
    case VALUE_GREATER_THAN:
    case VALUE_GREATER_THAN_EQUALS:
    case VALUE_LESS_THAN:
    case VALUE_LESS_THAN_EQUALS:
    case VALUE_NOT_EQUALS:
    case VARName:
    case WHERE:
    case XMLCOMMENT_START:
    case XMLPROCESSING_START:
    case NCName:
    case START_TAG_NCName:
    case END_TAG_NCName:
    case ELT_LESS_THAN:
    case ELT_XMLCOMMENT_START:
    case ELT_XMLPROCESSING_START:
    case ELT_CDATA_START:
      returnClause = IfExpr();
                        {if (true) return returnClause;}
      break;
    default:
      jj_la1[21] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[13]	IfExpr ::=							( <"if" "("> Expr ")" "then" Expr "else" )* InstanceofExpr
***************************************************************************************/
  final public XQueryExpression IfExpr() throws ParseException, ParseException, Exception {
        XQueryExpression ifClause = null;
        XQueryExpression thenClause = null;
        XQueryExpression elseClause = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IF_L_PAREN:
      currentToken = jj_consume_token(IF_L_PAREN);

      ifClause = Expr();
      currentToken = jj_consume_token(R_PAREN_THEN);

      thenClause = Expr();
      currentToken = jj_consume_token(ELSE);

      elseClause = IfExpr();
                                try
                                {
                                        {if (true) return factory.createITEExpression(ifClause, thenClause, elseClause, typevisitor);}
                                }
                                catch (TypeException te)
                                {
                                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                                }
      break;
    case AND:
    case ASCENDING:
    case AT:
    case ATTRIBUTE:
    case ATTRIBUTE_DCOLON:
    case ATTRIBUTE_L_BRACE:
    case BY:
    case CASE:
    case CAST_AS:
    case CDATA_START:
    case CHILD_DCOLON:
    case COMMENT_L_PAREN_R_PAREN:
    case DEFAULT_:
    case DESCENDANT_DCOLON:
    case DESCENDANT_SELF_DCOLON:
    case DESCENDING:
    case DIVISION:
    case DOCUMENT_L_BRACE:
    case DOT:
    case DOTDOT:
    case DecimalLiteral:
    case DoubleLiteral:
    case ELEMENT:
    case ELEMENT_L_BRACE:
    case ELSE:
    case EVERY:
    case EXCEPT:
    case FOR:
    case IN:
    case INTEGER_DIVISION:
    case INTERSECT:
    case IS:
    case ISNOT:
    case IntegerLiteral:
    case LESS_THAN:
    case LET:
    case L_PAREN:
    case MINUS:
    case MODULO:
    case NODE_L_PAREN_R_PAREN:
    case OR:
    case PARENT_DCOLON:
    case PLUS:
    case PROCESSING_INSTRUCTION_L_PAREN:
    case RETURN:
    case SATISFIES:
    case SELF_DCOLON:
    case SLASH:
    case SLASHSLASH:
    case SOME:
    case SORT:
    case SORTBY:
    case STABLE:
    case STAR:
    case StringLiteral:
    case TEXT_L_PAREN_R_PAREN:
    case TO:
    case TREAT_AS:
    case UNION:
    case UNORDERED:
    case VALIDATE:
    case VALUE_EQUALS:
    case VALUE_GREATER_THAN:
    case VALUE_GREATER_THAN_EQUALS:
    case VALUE_LESS_THAN:
    case VALUE_LESS_THAN_EQUALS:
    case VALUE_NOT_EQUALS:
    case VARName:
    case WHERE:
    case XMLCOMMENT_START:
    case XMLPROCESSING_START:
    case NCName:
    case START_TAG_NCName:
    case END_TAG_NCName:
    case ELT_LESS_THAN:
    case ELT_XMLCOMMENT_START:
    case ELT_XMLPROCESSING_START:
    case ELT_CDATA_START:
      elseClause = InstanceofExpr();
                        {if (true) return elseClause;}
      break;
    default:
      jj_la1[22] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[14]	InstanceofExpr ::=					ComparisonExpr ( <"instance" "of"> SequenceType )?
***************************************************************************************/
  final public XQueryExpression InstanceofExpr() throws ParseException, ParseException, Exception {
        XQueryExpression expression = null;
        SequenceTypeExpression sequenceType = null;
    expression = ComparisonExpr();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case INSTANCE_OF:

      currentToken = jj_consume_token(INSTANCE_OF);
                                if (restriction) {if (true) throw new ParseException("Encountered \"" + currentToken.image + "\" at line " + currentToken.beginLine + ", column " + currentToken.beginColumn + ". InstanceOfExpr is not supported yet.");}
                                switchState(ITEMTYPE);
                                //previousToken = currentToken;
                                // if (debug) System.out.println("InstanceofExpr - Read <INSTANCE_OF> " + currentToken.image);

      sequenceType = SequenceType();
                                // if (debug) System.out.println("*************************** DEFAULT");
                                try
                                {
                                        expression = factory.createInstanceOfExpression(expression, sequenceType, typevisitor);
                                }
                                catch (TypeException te)
                                {
                                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                                }
      break;
    default:
      jj_la1[23] = jj_gen;
      ;
    }
                {if (true) return expression;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[15]	ComparisonExpr ::=					RangeExpr ( ( ValueComp | GeneralComp | NodeComp | OrderComp ) RangeExpr )?
***************************************************************************************/
  final public XQueryExpression ComparisonExpr() throws ParseException, ParseException, Exception {
        XQueryExpression mainExpression = null;
        XQueryExpression expression = null;
        int kind = -1;
    mainExpression = RangeExpr();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case EQUALS:
    case GREATER_GREATER_THAN:
    case GREATER_THAN:
    case GREATER_THAN_EQUALS:
    case IS:
    case ISNOT:
    case LESS_LESS_THAN:
    case LESS_THAN:
    case LESS_THAN_EQUALS:
    case NOT_EQUALS:
    case VALUE_EQUALS:
    case VALUE_GREATER_THAN:
    case VALUE_GREATER_THAN_EQUALS:
    case VALUE_LESS_THAN:
    case VALUE_LESS_THAN_EQUALS:
    case VALUE_NOT_EQUALS:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case VALUE_EQUALS:
      case VALUE_GREATER_THAN:
      case VALUE_GREATER_THAN_EQUALS:
      case VALUE_LESS_THAN:
      case VALUE_LESS_THAN_EQUALS:
      case VALUE_NOT_EQUALS:
        kind = ValueComp();
        break;
      case EQUALS:
      case GREATER_THAN:
      case GREATER_THAN_EQUALS:
      case LESS_THAN:
      case LESS_THAN_EQUALS:
      case NOT_EQUALS:
        kind = GeneralComp();
        break;
      case IS:
      case ISNOT:
        kind = NodeComp();
        break;
      case GREATER_GREATER_THAN:
      case LESS_LESS_THAN:
        kind = OrderComp();
        break;
      default:
        jj_la1[24] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      expression = RangeExpr();
      break;
    default:
      jj_la1[25] = jj_gen;
      ;
    }
                if (kind != -1)
                {
                        try
                        {
                                {if (true) return factory.createListOpCompExpression(mainExpression, expression, kind, typevisitor);}
                        }
                        catch (TypeException te)
                        {
                                {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                        }
                }
                {if (true) return mainExpression;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[16]	RangeExpr ::=						AdditiveExpr ( "to" AdditiveExpr )?
		W3C WD 16 August 2002 ->			AdditiveExpr ( "to" AdditiveExpr )*
***************************************************************************************/
  final public XQueryExpression RangeExpr() throws ParseException, ParseException, Exception {
        XQueryExpression mainExpression = null;
        XQueryExpression expression = null;
        XQueryExpression rangeExpr = null;
    mainExpression = AdditiveExpr();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case TO:
      currentToken = jj_consume_token(TO);
                                //previousToken = currentToken;
                                // if (debug) System.out.println("RangeExpr - Read <TO> " + currentToken.image);
                                if (restriction) {if (true) throw new ParseException("Encountered \"" + currentToken.image + "\" at line " + currentToken.beginLine + ", column " + currentToken.beginColumn + ". RangeExpr is not supported yet.");}
      expression = AdditiveExpr();
                                try
                                {
                                        rangeExpr = factory.createRangeExpression(mainExpression, expression, typevisitor);
                                }
                                catch (TypeException te)
                                {
                                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                                }
                                mainExpression = rangeExpr;
      break;
    default:
      jj_la1[26] = jj_gen;
      ;
    }
                {if (true) return mainExpression;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[17]	AdditiveExpr ::=					MultiplicativeExpr ( ( "+" | "-" ) MultiplicativeExpr )*
***************************************************************************************/
  final public XQueryExpression AdditiveExpr() throws ParseException, ParseException, Exception {
        int kind = -1;
        XQueryExpression mainExpression = null;
        XQueryExpression expression = null;
        ListOpArithExpression listOpArithExpression = null;
    mainExpression = MultiplicativeExpr();
    label_10:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case MINUS:
      case PLUS:
        ;
        break;
      default:
        jj_la1[27] = jj_gen;
        break label_10;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case PLUS:
        currentToken = jj_consume_token(PLUS);
                                        //previousToken = currentToken;
                                        // if (debug) System.out.println("AdditiveExpr - Read <PLUS> " + currentToken.image);
                                        kind = Constants.PLUS_ARITHMETICS;
        break;
      case MINUS:
        currentToken = jj_consume_token(MINUS);
                                        //previousToken = currentToken;
                                        // if (debug) System.out.println("AdditiveExpr - Read <MINUS> " + currentToken.image);
                                        kind = Constants.MINUS_ARITHMETICS;
        break;
      default:
        jj_la1[28] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      expression = MultiplicativeExpr();
                                try
                                {
                                        listOpArithExpression = factory.createListOpArithExpression(mainExpression, expression, kind, typevisitor);
                                }
                                catch (TypeException te)
                                {
                                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                                }
                                mainExpression = listOpArithExpression;
    }
                {if (true) return mainExpression;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[18]	MultiplicativeExpr ::=				UnionExpr ( ( "*" | "div" | "idiv" | "mod" ) UnionExpr )*
***************************************************************************************/
  final public XQueryExpression MultiplicativeExpr() throws ParseException, ParseException, Exception {
        int kind = -1;
        XQueryExpression mainExpression = null;
        XQueryExpression expression = null;
        ListOpArithExpression listOpArithExpression = null;
    mainExpression = UnionExpr();
    label_11:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case DIVISION:
      case INTEGER_DIVISION:
      case MODULO:
      case STAR:
        ;
        break;
      default:
        jj_la1[29] = jj_gen;
        break label_11;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case STAR:
        currentToken = jj_consume_token(STAR);
                                        //previousToken = currentToken;
                                        // if (debug) System.out.println("MultiplicativeExpr - Read <STAR> " + currentToken.image);
                                        kind = Constants.MULTIPLY_ARITHMETICS;
        break;
      case DIVISION:
        currentToken = jj_consume_token(DIVISION);
                                        //previousToken = currentToken;
                                        // if (debug) System.out.println("MultiplicativeExpr - Read <DIVISION> " + currentToken.image);
                                        kind = Constants.DIVIDE_ARITHMETICS;
        break;
      case INTEGER_DIVISION:
        currentToken = jj_consume_token(INTEGER_DIVISION);
                                        //previousToken = currentToken;
                                        // if (debug) System.out.println("MultiplicativeExpr - Read <INTEGER_DIVISION> " + currentToken.image);
                                        if (restriction) {if (true) throw new ParseException("Encountered \"" + currentToken.image + "\" at line " + currentToken.beginLine + ", column " + currentToken.beginColumn + ". Integer division is not supported yet.");}
                                        kind = Constants.INTEGER_DIVIDE_ARITHMETICS;
        break;
      case MODULO:
        currentToken = jj_consume_token(MODULO);
                                        //previousToken = currentToken;
                                        // if (debug) System.out.println("MultiplicativeExpr - Read <MODULO> " + currentToken.image);
                                        kind = Constants.MODULO_ARITHMETICS;
        break;
      default:
        jj_la1[30] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      expression = UnionExpr();
                                try
                                {
                                        listOpArithExpression = factory.createListOpArithExpression(mainExpression, expression, kind, typevisitor);
                                }
                                catch (TypeException te)
                                {
                                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                                }
                                mainExpression = listOpArithExpression;
    }
                {if (true) return mainExpression;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[19]	UnionExpr ::=						IntersectExceptExpr ( ( "union" | "|" ) IntersectExceptExpr )*
***************************************************************************************/
  final public XQueryExpression UnionExpr() throws ParseException, ParseException, Exception {
        XQueryExpression mainExpression = null;
        XQueryExpression expression = null;
        ListOpUNIONExpression listOpUNIONExpression = null;
    mainExpression = IntersectExceptExpr();
    label_12:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case BAR:
      case UNION:
        ;
        break;
      default:
        jj_la1[31] = jj_gen;
        break label_12;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case UNION:
        currentToken = jj_consume_token(UNION);

        break;
      case BAR:
        currentToken = jj_consume_token(BAR);

        break;
      default:
        jj_la1[32] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
                                if (restriction) {if (true) throw new ParseException("Encountered \"" + currentToken.image + "\" at line " + currentToken.beginLine + ", column " + currentToken.beginColumn + ". UnionExpr is not supported yet.");}
      expression = IntersectExceptExpr();
                                try
                                {
                                        listOpUNIONExpression = factory.createListOpUNIONExpression(mainExpression, expression, typevisitor);
                                }
                                catch (TypeException te)
                                {
                                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                                }
                                mainExpression = listOpUNIONExpression;
    }
                {if (true) return mainExpression;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[20]	IntersectExceptExpr ::=				UnaryExpr ( ( "intersect" | "except" ) UnaryExpr )*
***************************************************************************************/
  final public XQueryExpression IntersectExceptExpr() throws ParseException, ParseException, Exception {
        XQueryExpression mainExpression = null;
        XQueryExpression expression = null;
        XQueryExpression resultExpression = null;
        boolean kind = false;
    mainExpression = UnaryExpr();
    label_13:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case EXCEPT:
      case INTERSECT:
        ;
        break;
      default:
        jj_la1[33] = jj_gen;
        break label_13;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case INTERSECT:
        currentToken = jj_consume_token(INTERSECT);
                                        //previousToken = currentToken;
                                        // if (debug) System.out.println("IntersectExceptExpr - Read <INTERSECT> " + currentToken.image);
                                        kind = true;
        break;
      case EXCEPT:
        currentToken = jj_consume_token(EXCEPT);
                                        //previousToken = currentToken;
                                        // if (debug) System.out.println("IntersectExceptExpr - Read <EXCEPT> " + currentToken.image);
                                        kind = false;
        break;
      default:
        jj_la1[34] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
                                if (restriction) {if (true) throw new ParseException("Encountered \"" + currentToken.image + "\" at line " + currentToken.beginLine + ", column " + currentToken.beginColumn + ". IntersectExceptExpr is not supported yet.");}
      expression = UnaryExpr();
                                try
                                {
                                        if (kind)
                                        {
                                                resultExpression = factory.createListOpINTERSECTExpression(mainExpression, expression, typevisitor);
                                        }
                                        else
                                        {
                                                resultExpression = factory.createListOpEXCEPTExpression(mainExpression, expression, typevisitor);
                                        }
                                }
                                catch (TypeException te)
                                {
                                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                                }
                                mainExpression = resultExpression;
    }
                {if (true) return mainExpression;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[21]	UnaryExpr ::=						( "-" | "+" )? ValueExpr
		W3C WD 16 August 2002 ->			( "-" | "+" )* ValueExpr
***************************************************************************************/
  final public XQueryExpression UnaryExpr() throws ParseException, ParseException, Exception {
        XQueryExpression expression = null;
        boolean minus = false;
        boolean hasSign = false;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case MINUS:
    case PLUS:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case MINUS:
        currentToken = jj_consume_token(MINUS);
                                //previousToken = currentToken;
                                // if (debug) System.out.println("UnaryExpr - Read <MINUS> " + currentToken.image);
                                hasSign = true;
                                minus = true;
        break;
      case PLUS:
        currentToken = jj_consume_token(PLUS);
                                //previousToken = currentToken;
                                // if (debug) System.out.println("UnaryExpr - Read <PLUS> " + currentToken.image);
                                hasSign = true;
        break;
      default:
        jj_la1[35] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      break;
    default:
      jj_la1[36] = jj_gen;
      ;
    }
    expression = ValueExpr();
                if (hasSign)
                {
                        try
                        {
                                {if (true) return factory.createUnOpMinusExpression(expression, minus, typevisitor);}
                        }
                        catch (TypeException te)
                        {
                                {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                        }
                }
                {if (true) return expression;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[22]	ValueExpr ::=						ValidateExpr | CastExpr | Constructor | PathExpr
***************************************************************************************/
  final public XQueryExpression ValueExpr() throws ParseException, ParseException, Exception {
        XQueryExpression expression = null;
    if (jj_2_4(2)) {
      expression = ValidateExpr();
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case CAST_AS:
      case TREAT_AS:
        expression = CastExpr();
        break;
      default:
        jj_la1[37] = jj_gen;
        if (jj_2_5(2)) {
          expression = Constructor();
        } else {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case AND:
          case ASCENDING:
          case AT:
          case ATTRIBUTE:
          case ATTRIBUTE_DCOLON:
          case BY:
          case CASE:
          case CHILD_DCOLON:
          case COMMENT_L_PAREN_R_PAREN:
          case DEFAULT_:
          case DESCENDANT_DCOLON:
          case DESCENDANT_SELF_DCOLON:
          case DESCENDING:
          case DIVISION:
          case DOT:
          case DOTDOT:
          case DecimalLiteral:
          case DoubleLiteral:
          case ELEMENT:
          case ELSE:
          case EVERY:
          case EXCEPT:
          case FOR:
          case IN:
          case INTEGER_DIVISION:
          case INTERSECT:
          case IS:
          case ISNOT:
          case IntegerLiteral:
          case LET:
          case L_PAREN:
          case MODULO:
          case NODE_L_PAREN_R_PAREN:
          case OR:
          case PARENT_DCOLON:
          case PROCESSING_INSTRUCTION_L_PAREN:
          case RETURN:
          case SATISFIES:
          case SELF_DCOLON:
          case SLASH:
          case SLASHSLASH:
          case SOME:
          case SORT:
          case SORTBY:
          case STABLE:
          case STAR:
          case StringLiteral:
          case TEXT_L_PAREN_R_PAREN:
          case TO:
          case UNION:
          case UNORDERED:
          case VALIDATE:
          case VALUE_EQUALS:
          case VALUE_GREATER_THAN:
          case VALUE_GREATER_THAN_EQUALS:
          case VALUE_LESS_THAN:
          case VALUE_LESS_THAN_EQUALS:
          case VALUE_NOT_EQUALS:
          case VARName:
          case WHERE:
          case NCName:
          case START_TAG_NCName:
          case END_TAG_NCName:
            expression = PathExpr();
            break;
          default:
            jj_la1[38] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
        }
      }
    }
                {if (true) return expression;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[23]	PathExpr ::=						( "/" RelativePathExpr? ) | ( "//" RelativePathExpr ) | RelativePathExpr
***************************************************************************************/
  final public XQueryExpression PathExpr() throws ParseException, ParseException, Exception {
        boolean separator = false;
        Step step = null;
        NodeType nodeType = null;
        ArrayList tmpSteps = null;
        ArrayList resSteps = new ArrayList();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case SLASH:
      currentToken = jj_consume_token(SLASH);
                                //previousToken = currentToken;
                                // if (debug) System.out.println("PathExpr - Read <SLASH> " + currentToken.image);
                                separator = true;
      if (jj_2_6(2)) {
        tmpSteps = RelativePathExpr(separator);
                                        if (tmpSteps != null) resSteps.addAll(tmpSteps);
      } else {
        ;
      }
                                if (tmpSteps == null)
                                {
                                        try
                                        {
                                                nodeType = factory.createNodeType(NodeKind.NODE, null, typevisitor);
                                                step = factory.createStep(separator, Axis.CHILD, nodeType, null, typevisitor);
                                                resSteps.add(step);
                                        }
                                        catch (TypeException te)
                                        {
                                                {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                                        }
                                }
      break;
    case SLASHSLASH:
      currentToken = jj_consume_token(SLASHSLASH);
                                //previousToken = currentToken;
                                // if (debug) System.out.println("PathExpr - Read <SLASHSLASH> " + currentToken.image);
                                separator = true;
                                try
                                {
                                        nodeType = factory.createNodeType(NodeKind.NODE, null, typevisitor);
                                        step = factory.createStep(separator, Axis.DESCENDANT_OR_SELF, nodeType, null, typevisitor);
                                        resSteps.add(step);
                                }
                                catch (TypeException te)
                                {
                                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                                }
      tmpSteps = RelativePathExpr(separator);
                                resSteps.addAll(tmpSteps);
      break;
    case AND:
    case ASCENDING:
    case AT:
    case ATTRIBUTE:
    case ATTRIBUTE_DCOLON:
    case BY:
    case CASE:
    case CHILD_DCOLON:
    case COMMENT_L_PAREN_R_PAREN:
    case DEFAULT_:
    case DESCENDANT_DCOLON:
    case DESCENDANT_SELF_DCOLON:
    case DESCENDING:
    case DIVISION:
    case DOT:
    case DOTDOT:
    case DecimalLiteral:
    case DoubleLiteral:
    case ELEMENT:
    case ELSE:
    case EVERY:
    case EXCEPT:
    case FOR:
    case IN:
    case INTEGER_DIVISION:
    case INTERSECT:
    case IS:
    case ISNOT:
    case IntegerLiteral:
    case LET:
    case L_PAREN:
    case MODULO:
    case NODE_L_PAREN_R_PAREN:
    case OR:
    case PARENT_DCOLON:
    case PROCESSING_INSTRUCTION_L_PAREN:
    case RETURN:
    case SATISFIES:
    case SELF_DCOLON:
    case SOME:
    case SORT:
    case SORTBY:
    case STABLE:
    case STAR:
    case StringLiteral:
    case TEXT_L_PAREN_R_PAREN:
    case TO:
    case UNION:
    case UNORDERED:
    case VALIDATE:
    case VALUE_EQUALS:
    case VALUE_GREATER_THAN:
    case VALUE_GREATER_THAN_EQUALS:
    case VALUE_LESS_THAN:
    case VALUE_LESS_THAN_EQUALS:
    case VALUE_NOT_EQUALS:
    case VARName:
    case WHERE:
    case NCName:
    case START_TAG_NCName:
    case END_TAG_NCName:
      tmpSteps = RelativePathExpr(separator);
                                resSteps.addAll(tmpSteps);
      break;
    default:
      jj_la1[39] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                if (resSteps.size() == 1)
                {
                        step = (Step) resSteps.get(0);
                        if (!step.hasSeparator() && step.getAxis() == Axis.NONE && step.getPredicates() == null)
                        {
                                {if (true) return step.getExpression();}
                        }
                }
                try {
                        if (LocatedExpressionReducer.simplifySteps(resSteps, inPredicate, typevisitor) == 0)
                                {if (true) throw new TypeException("steps of LocatedExpression are not valid", currentToken.beginLine, currentToken.beginColumn);}
                }
                catch (NormalizeException ne) {
                        {if (true) throw new TypeException(ne.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                }
                try
                {
                        {if (true) return factory.createLocatedExpression(resSteps, inPredicate, typevisitor);}
                }
                catch (TypeException te)
                {
                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                }
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[24]	RelativePathExpr ::=				StepExpr ( ( "/" | "//" ) StepExpr )*
***************************************************************************************/
  final public ArrayList RelativePathExpr(boolean separator) throws ParseException, ParseException, Exception {
        Step step = null;
        ArrayList steps = new ArrayList();
        NodeType nodeType = null;
    step = StepExpr(separator);
                                steps.add(step);
    label_14:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SLASH:
      case SLASHSLASH:
        ;
        break;
      default:
        jj_la1[40] = jj_gen;
        break label_14;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SLASH:
        currentToken = jj_consume_token(SLASH);
                                        //previousToken = currentToken;
                                        // if (debug) System.out.println("RelativePathExpr - Read <SLASH> " + currentToken.image);
                                        separator = true;
        break;
      case SLASHSLASH:
        currentToken = jj_consume_token(SLASHSLASH);
                                        //previousToken = currentToken;
                                        // if (debug) System.out.println("RelativePathExpr - Read <SLASHSLASH> " + currentToken.image);
                                        separator = true;
                                        try
                                        {
                                                nodeType = factory.createNodeType(NodeKind.NODE, null, typevisitor);
                                                step = factory.createStep(separator, Axis.DESCENDANT_OR_SELF, nodeType, null, typevisitor);
                                                steps.add(step);
                                        }
                                        catch (TypeException te)
                                        {
                                                {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                                        }
        break;
      default:
        jj_la1[41] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      step = StepExpr(separator);
                                steps.add(step);
    }
                {if (true) return steps;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[25]	StepExpr ::=						( PrimaryExpr | ForwardStep | ReverseStep ) Predicates
		W3C WD 16 August 2002 ->			( ForwardStep | ReverseStep | PrimaryExpr ) Predicates
***************************************************************************************/
  final public Step StepExpr(boolean separator) throws ParseException, ParseException, Exception {
        Step step = null;
        ArrayList predicates = new ArrayList();
    if (jj_2_7(2)) {
      step = PrimaryExpr(separator);
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case AND:
      case ASCENDING:
      case AT:
      case ATTRIBUTE:
      case ATTRIBUTE_DCOLON:
      case BY:
      case CASE:
      case CHILD_DCOLON:
      case COMMENT_L_PAREN_R_PAREN:
      case DEFAULT_:
      case DESCENDANT_DCOLON:
      case DESCENDANT_SELF_DCOLON:
      case DESCENDING:
      case DIVISION:
      case DOT:
      case ELEMENT:
      case ELSE:
      case EVERY:
      case EXCEPT:
      case FOR:
      case IN:
      case INTEGER_DIVISION:
      case INTERSECT:
      case IS:
      case ISNOT:
      case LET:
      case MODULO:
      case NODE_L_PAREN_R_PAREN:
      case OR:
      case PROCESSING_INSTRUCTION_L_PAREN:
      case RETURN:
      case SATISFIES:
      case SELF_DCOLON:
      case SOME:
      case SORT:
      case SORTBY:
      case STABLE:
      case STAR:
      case TEXT_L_PAREN_R_PAREN:
      case TO:
      case UNION:
      case UNORDERED:
      case VALIDATE:
      case VALUE_EQUALS:
      case VALUE_GREATER_THAN:
      case VALUE_GREATER_THAN_EQUALS:
      case VALUE_LESS_THAN:
      case VALUE_LESS_THAN_EQUALS:
      case VALUE_NOT_EQUALS:
      case WHERE:
      case NCName:
      case START_TAG_NCName:
      case END_TAG_NCName:
        step = ForwardStep(separator);
        break;
      case DOTDOT:
      case PARENT_DCOLON:
        step = ReverseStep(separator);
        break;
      default:
        jj_la1[42] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
    predicates = Predicates();
                if (predicates != null)
                {
                        step.setPredicates(predicates);
                        if (typevisitor != null) step.accept(typevisitor);
                }
                {if (true) return step;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[26]	ForClause ::=						"for" Param "in" Expr ( ", " Param "in" Expr )*
		W3C WD 16 August 2002 ->			"for" TypeDeclaration? "$" VarName "in" Expr ( ", " TypeDeclaration? "$" VarName "in" Expr )*
***************************************************************************************/
  final public ArrayList ForClause() throws ParseException, ParseException, Exception {
        boolean hasTypeDeclaration = false;
        SequenceTypeExpression typeDeclaration = null;
        ArrayList vectVar = new ArrayList(1);
        XQueryExpression var = null;
        XQueryExpression expression = null;
    currentToken = jj_consume_token(FOR);

    var = Param(true);
                        vectVar.add(var);
    currentToken = jj_consume_token(IN);

    expression = Expr();
                        var.setBindingType(Constants.FOR_BINDINGTYPE);
                        var.setExpression(expression, typevisitor);
                        if (typevisitor != null) var.accept(typevisitor);
                        varDefNames.put(var.print(), var);
    label_15:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        jj_la1[43] = jj_gen;
        break label_15;
      }
      currentToken = jj_consume_token(COMMA);

      var = Param(true);
                                vectVar.add(var);
      currentToken = jj_consume_token(IN);

      expression = Expr();
                                var.setBindingType(Constants.FOR_BINDINGTYPE);
                                var.setExpression(expression, typevisitor);
                                if (typevisitor != null) var.accept(typevisitor);
                                varDefNames.put(var.print(), var);
    }
                {if (true) return vectVar;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[27]	LetClause ::=						"let" Param ":=" Expr ( ", " Param ":=" Expr )*
		W3C WD 16 August 2002 ->			"let" TypeDeclaration? "$" VarName ":=" Expr ( ", " TypeDeclaration? "$" VarName ":=" Expr )*
***************************************************************************************/
  final public ArrayList LetClause() throws ParseException, ParseException, Exception {
        boolean hasTypeDeclaration = false;
        SequenceTypeExpression typeDeclaration = null;
        ArrayList vectVar = new ArrayList();
        XQueryExpression var = null;
        XQueryExpression expression = null;
    currentToken = jj_consume_token(LET);

    var = Param(true);
                        vectVar.add(var);
    currentToken = jj_consume_token(SET_EQUAL_TO);

    expression = Expr();
                        var.setBindingType(Constants.LET_BINDINGTYPE);
                        var.setExpression(expression, typevisitor);
                        if (typevisitor != null) var.accept(typevisitor);
                        varDefNames.put(var.print(), var);
    label_16:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        jj_la1[44] = jj_gen;
        break label_16;
      }
      currentToken = jj_consume_token(COMMA);

      var = Param(true);
                                vectVar.add(var);
      currentToken = jj_consume_token(SET_EQUAL_TO);

      expression = Expr();
                                var.setBindingType(Constants.LET_BINDINGTYPE);
                                var.setExpression(expression, typevisitor);
                                if (typevisitor != null) var.accept(typevisitor);
                                varDefNames.put(var.print(), var);
    }
                {if (true) return vectVar;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[28]	WhereClause ::=						"where" Expr
***************************************************************************************/
  final public XQueryExpression WhereClause() throws ParseException, ParseException, Exception {
        XQueryExpression expression = null;
    currentToken = jj_consume_token(WHERE);

    expression = Expr();
                {if (true) return expression;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[29]	ValidateExpr ::=					"validate" SchemaContext? "{" Expr "}"
***************************************************************************************/
  final public XQueryExpression ValidateExpr() throws ParseException, ParseException, Exception {
        XQueryExpression schemaContext = null;
        XQueryExpression validateExpression = null;
    currentToken = jj_consume_token(VALIDATE);
                        //previousToken = currentToken;
                        // if (debug) System.out.println("ValidateExpr - Read <VALIDATE> " + currentToken.image);
                        if (restriction) {if (true) throw new ParseException("Encountered \"" + currentToken.image + "\" at line " + currentToken.beginLine + ", column " + currentToken.beginColumn + ". ValidateExpr is not supported yet.");}
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IN_TYPE:
      schemaContext = SchemaContext();
      break;
    default:
      jj_la1[45] = jj_gen;
      ;
    }
    currentToken = jj_consume_token(L_BRACE);

    validateExpression = Expr();
    currentToken = jj_consume_token(R_BRACE);

                try
                {
                        {if (true) return factory.createValidateExpression(schemaContext, validateExpression, typevisitor);}
                }
                catch (TypeException te)
                {
                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                }
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[30]	CastExpr ::=						( <"cast" "as"> | <"treat" "as"> ) SequenceType ParenthesizedExpr
***************************************************************************************/
  final public XQueryExpression CastExpr() throws ParseException, ParseException, Exception {
        int kind = -1;
        SequenceTypeExpression sequenceType = null;
        XQueryExpression expression = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case CAST_AS:
      currentToken = jj_consume_token(CAST_AS);
                                //previousToken = currentToken;
                                // if (debug) System.out.println("CastExpr - Read <CAST_AS> " + currentToken.image);
                                kind = Constants.CAST_TYPING;
      break;
    case TREAT_AS:
      currentToken = jj_consume_token(TREAT_AS);
                                //previousToken = currentToken;
                                // if (debug) System.out.println("CastExpr - Read <TREAT_AS> " + currentToken.image);
                                kind = Constants.TREAT_TYPING;
      break;
    default:
      jj_la1[46] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                        if (restriction) {if (true) throw new ParseException("Encountered \"" + currentToken.image + "\" at line " + currentToken.beginLine + ", column " + currentToken.beginColumn + ". CastExpr is not supported yet.");}
    sequenceType = SequenceType();
    expression = ParenthesizedExpr();
                try
                {
                        {if (true) return factory.createCastTreatExpression(kind, sequenceType, expression, typevisitor);}
                }
                catch (TypeException te)
                {
                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                }
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[31]	Constructor ::=		
ElementConstructor | 
XmlComment | 
XmlProcessingInstruction | 
CdataSection | 
ComputedDocumentConstructor | 
ComputedElementConstructor | 
ComputedAttributeConstructor

[79]    Constructor    ::=    
ElementConstructor
| XmlComment
| XmlPI
| CdataSection
| CompDocConstructor
| CompElemConstructor
| CompAttrConstructor
| CompNSConstructor
| CompTextConstructor
| CompXmlPI
| ComputedXmlComment 


***************************************************************************************/
  final public XQueryExpression Constructor() throws ParseException, ParseException, Exception {
        XQueryExpression expression = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LESS_THAN:
    case ELT_LESS_THAN:
      expression = ElementConstructor();
      break;
    case XMLCOMMENT_START:
    case ELT_XMLCOMMENT_START:
      expression = XmlComment();
      break;
    case XMLPROCESSING_START:
    case ELT_XMLPROCESSING_START:
      expression = XmlProcessingInstruction();
      break;
    case CDATA_START:
    case ELT_CDATA_START:
      expression = CdataSection();
      break;
    case DOCUMENT_L_BRACE:
      expression = ComputedDocumentConstructor();
      break;
    case ELEMENT:
    case ELEMENT_L_BRACE:
      expression = ComputedElementConstructor();
      break;
    case ATTRIBUTE:
    case ATTRIBUTE_L_BRACE:
      expression = ComputedAttributeConstructor();
      break;
    default:
      jj_la1[47] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                {if (true) return expression;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[32]	GeneralComp ::=						"=" | "!=" | "<" | "<=" | ">" | ">="
***************************************************************************************/
  final public int GeneralComp() throws ParseException, ParseException, Exception {
        int kind = -1;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case EQUALS:
      currentToken = jj_consume_token(EQUALS);
                        //previousToken = currentToken;
                        // if (debug) System.out.println("GeneralComp - Read <EQUALS> " + currentToken.image);
                        kind = Constants.EQ_COMPOP;
      break;
    case NOT_EQUALS:
      currentToken = jj_consume_token(NOT_EQUALS);
                        //previousToken = currentToken;
                        // if (debug) System.out.println("GeneralComp - Read <NOT_EQUALS> " + currentToken.image);
                        kind = Constants.NEQ_COMPOP;
      break;
    case LESS_THAN:
      currentToken = jj_consume_token(LESS_THAN);
                        //previousToken = currentToken;
                        // if (debug) System.out.println("GeneralComp - Read <LESS_THAN> " + currentToken.image);
                        kind = Constants.LT_COMPOP;
      break;
    case LESS_THAN_EQUALS:
      currentToken = jj_consume_token(LESS_THAN_EQUALS);
                        //previousToken = currentToken;
                        // if (debug) System.out.println("GeneralComp - Read <LESS_THAN_EQUALS> " + currentToken.image);
                        kind = Constants.LEQ_COMPOP;
      break;
    case GREATER_THAN:
      currentToken = jj_consume_token(GREATER_THAN);
                        //previousToken = currentToken;
                        // if (debug) System.out.println("GeneralComp - Read <GREATER_THAN> " + currentToken.image);
                        kind = Constants.GT_COMPOP;
      break;
    case GREATER_THAN_EQUALS:
      currentToken = jj_consume_token(GREATER_THAN_EQUALS);
                        //previousToken = currentToken;
                        // if (debug) System.out.println("GeneralComp - Read <GREATER_THAN_EQUALS> " + currentToken.image);
                        kind = Constants.GEQ_COMPOP;
      break;
    default:
      jj_la1[48] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                {if (true) return kind;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[33]	ValueComp ::=						"eq" | "ne" | "lt" | "le" | "gt" | "ge"
***************************************************************************************/
  final public int ValueComp() throws ParseException, ParseException, Exception {
        int kind = -1;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case VALUE_EQUALS:
      currentToken = jj_consume_token(VALUE_EQUALS);
                        //previousToken = currentToken;
                        // if (debug) System.out.println("ValueComp - Read <VALUE_EQUALS> " + currentToken.image);
                        kind = Constants.EQ_VALUECOMP;
      break;
    case VALUE_NOT_EQUALS:
      currentToken = jj_consume_token(VALUE_NOT_EQUALS);
                        //previousToken = currentToken;
                        // if (debug) System.out.println("ValueComp - Read <VALUE_NOT_EQUALS> " + currentToken.image);
                        kind = Constants.NE_VALUECOMP;
      break;
    case VALUE_LESS_THAN:
      currentToken = jj_consume_token(VALUE_LESS_THAN);
                        //previousToken = currentToken;
                        // if (debug) System.out.println("ValueComp - Read <VALUE_LESS_THAN> " + currentToken.image);
                        kind = Constants.LT_VALUECOMP;
      break;
    case VALUE_LESS_THAN_EQUALS:
      currentToken = jj_consume_token(VALUE_LESS_THAN_EQUALS);
                        //previousToken = currentToken;
                        // if (debug) System.out.println("ValueComp - Read <VALUE_LESS_THAN_EQUALS> " + currentToken.image);
                        kind = Constants.LE_VALUECOMP;
      break;
    case VALUE_GREATER_THAN:
      currentToken = jj_consume_token(VALUE_GREATER_THAN);
                        //previousToken = currentToken;
                        // if (debug) System.out.println("ValueComp - Read <VALUE_GREATER_THAN> " + currentToken.image);
                        kind = Constants.GT_VALUECOMP;
      break;
    case VALUE_GREATER_THAN_EQUALS:
      currentToken = jj_consume_token(VALUE_GREATER_THAN_EQUALS);
                        //previousToken = currentToken;
                        // if (debug) System.out.println("ValueComp - Read <VALUE_GREATER_THAN_EQUALS> " + currentToken.image);
                        kind = Constants.GE_VALUECOMP;
      break;
    default:
      jj_la1[49] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                {if (true) return kind;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[34]	NodeComp ::=						"is" | "isnot"
***************************************************************************************/
  final public int NodeComp() throws ParseException, ParseException, Exception {
        int kind = -1;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IS:
      currentToken = jj_consume_token(IS);
                        //previousToken = currentToken;
                        // if (debug) System.out.println("NodeComp - Read <IS> " + currentToken.image);
                        kind = Constants.IS_NODECOMP;
      break;
    case ISNOT:
      currentToken = jj_consume_token(ISNOT);
                        //previousToken = currentToken;
                        // if (debug) System.out.println("NodeComp - Read <ISNOT> " + currentToken.image);
                        kind = Constants.ISNOT_NODECOMP;
      break;
    default:
      jj_la1[50] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                if (restriction) {if (true) throw new ParseException("Encountered \"" + currentToken.image + "\" at line " + currentToken.beginLine + ", column " + currentToken.beginColumn + ". Node comparison is not supported yet.");}
                {if (true) return kind;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[35]	OrderComp ::=						"<<" | ">>"
***************************************************************************************/
  final public int OrderComp() throws ParseException, ParseException, Exception {
        int kind = -1;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LESS_LESS_THAN:
      currentToken = jj_consume_token(LESS_LESS_THAN);
                        //previousToken = currentToken;
                        // if (debug) System.out.println("OrderComp - Read <LESS_LESS_THAN> " + currentToken.image);
                        kind = Constants.LEAST_ORDERCOMP;
      break;
    case GREATER_GREATER_THAN:
      currentToken = jj_consume_token(GREATER_GREATER_THAN);
                        //previousToken = currentToken;
                        // if (debug) System.out.println("OrderComp - Read <GREATER_GREATER_THAN> " + currentToken.image);
                        kind = Constants.GREATEST_ORDERCOMP;
      break;
    default:
      jj_la1[51] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                if (restriction) {if (true) throw new ParseException("Encountered \"" + currentToken.image + "\" at line " + currentToken.beginLine + ", column " + currentToken.beginColumn + ". Order comparison is not supported yet.");}
                {if (true) return kind;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[36]	SortSpecList ::=					Expr SortModifier ( ", " SortSpecList )?
***************************************************************************************/
  final public ArrayList SortSpecList() throws ParseException, ParseException, Exception {
        ArrayList resVect = new ArrayList();
        ArrayList tmpVect = null;
        XQueryExpression expression = null;
        int[] order = {-1, -1};
    expression = Expr();
    order = SortModifier();
                        // expression.setOrder(order);
                        expression.setOrder(order);
                        resVect.add(expression);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case COMMA:
      currentToken = jj_consume_token(COMMA);

      tmpVect = SortSpecList();
                                resVect.addAll(tmpVect);
      break;
    default:
      jj_la1[52] = jj_gen;
      ;
    }
                {if (true) return resVect;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[37]	SortModifier ::=					( "ascending" | "descending" )? ( <"empty" "greatest"> | <"empty" "least"> )?
***************************************************************************************/
  final public int[] SortModifier() throws ParseException, ParseException, Exception {
        int[] order = {Constants.ASCENDING_ORDER, -1};
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ASCENDING:
    case DESCENDING:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ASCENDING:
        currentToken = jj_consume_token(ASCENDING);
                                //previousToken = currentToken;
                                // if (debug) System.out.println("SortModifier - Read <ASCENDING> " + currentToken.image);
                                order[0] = Constants.ASCENDING_ORDER;
        break;
      case DESCENDING:
        currentToken = jj_consume_token(DESCENDING);
                                //previousToken = currentToken;
                                // if (debug) System.out.println("SortModifier - Read <DESCENDING> " + currentToken.image);
                                order[0] = Constants.DESCENDING_ORDER;
        break;
      default:
        jj_la1[53] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      break;
    default:
      jj_la1[54] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case EMPTY_GREATEST:
    case EMPTY_LEAST:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case EMPTY_GREATEST:
        currentToken = jj_consume_token(EMPTY_GREATEST);
                                        //previousToken = currentToken;
                                        // if (debug) System.out.println("SortModifier - Read <EMPTY_GREATEST> " + currentToken.image);
                                        order[1] = Constants.GREATEST_ORDER;
        break;
      case EMPTY_LEAST:
        currentToken = jj_consume_token(EMPTY_LEAST);
                                        //previousToken = currentToken;
                                        // if (debug) System.out.println("SortModifier - Read <EMPTY_LEAST> " + currentToken.image);
                                        order[1] = Constants.LEAST_ORDER;
        break;
      default:
        jj_la1[55] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
                                if (restriction) {if (true) throw new ParseException("Encountered \"" + currentToken.image + "\" at line " + currentToken.beginLine + ", column " + currentToken.beginColumn + ". Handling of empty sequence in SortModifier is not supported yet.");}
      break;
    default:
      jj_la1[56] = jj_gen;
      ;
    }
                {if (true) return order;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[38]	CaseClause ::=						"case" SequenceType VAR? "return" Expr
		W3C WD 16 August 2002 ->			"case" SequenceType ( "$" VarName )? "return" Expr
***************************************************************************************/
  final public CaseClauseExpression CaseClause() throws ParseException, ParseException, Exception {
        XQueryExpression var = null;
        SequenceTypeExpression sequenceType = null;
        XQueryExpression returnExpression = null;
    currentToken = jj_consume_token(CASE);

    sequenceType = SequenceType();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case VARName:
      var = VAR(true, false);
                                var.setTypeDeclaration(sequenceType);
                                if (typevisitor != null)
                                {
                                        var.accept(typevisitor);
                                }
      break;
    default:
      jj_la1[57] = jj_gen;
      ;
    }
    currentToken = jj_consume_token(RETURN);

    returnExpression = Expr();
                try
                {
                        if (var == null)
                        {
                                {if (true) return factory.createCaseClauseExpression(sequenceType, null, returnExpression, typevisitor);}
                        }
                        else
                        {
                                varDefNames.remove(var.print());
                                realVarNames.remove(var.print());
                                {if (true) return factory.createCaseClauseExpression(null, (Variable)var, returnExpression, typevisitor);}
                        }
                }
                catch (TypeException te)
                {
                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                }
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[39]	PrimaryExpr ::=						Literal | FunctionCall | VAR | ParenthesizedExpr
		W3C WD 16 August 2002 ->			Literal | FunctionCall | ( "$" VarName ) | ParenthesizedExpr
***************************************************************************************/
  final public Step PrimaryExpr(boolean separator) throws ParseException, ParseException, Exception {
        byte axis = Axis.NONE;
        XQueryExpression expression = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case DecimalLiteral:
    case DoubleLiteral:
    case IntegerLiteral:
    case StringLiteral:
      expression = Literal();
      break;
    case AND:
    case ASCENDING:
    case ATTRIBUTE:
    case BY:
    case CASE:
    case DEFAULT_:
    case DESCENDING:
    case DIVISION:
    case ELEMENT:
    case ELSE:
    case EVERY:
    case EXCEPT:
    case FOR:
    case IN:
    case INTEGER_DIVISION:
    case INTERSECT:
    case IS:
    case ISNOT:
    case LET:
    case MODULO:
    case OR:
    case RETURN:
    case SATISFIES:
    case SOME:
    case SORT:
    case SORTBY:
    case STABLE:
    case STAR:
    case TO:
    case UNION:
    case UNORDERED:
    case VALIDATE:
    case VALUE_EQUALS:
    case VALUE_GREATER_THAN:
    case VALUE_GREATER_THAN_EQUALS:
    case VALUE_LESS_THAN:
    case VALUE_LESS_THAN_EQUALS:
    case VALUE_NOT_EQUALS:
    case WHERE:
    case NCName:
    case START_TAG_NCName:
    case END_TAG_NCName:
      expression = FunctionCall();
      break;
    case VARName:
      expression = VAR(false, false);
      break;
    default:
      jj_la1[58] = jj_gen;
      if (jj_2_8(2)) {
        expression = ParenthesizedExpr();
      } else {
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
                if (separator)
                {
                        axis = Axis.CHILD;
                }
                try
                {
                        Step step = factory.createStep(separator, axis, expression, null, typevisitor);
                        if (expression.getParenthesis()) step.setParenthesis(true);
                        {if (true) return step;}
                }
                catch (TypeException te)
                {
                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                }
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[40]	ForwardAxis ::=						<"child" "::"> | <"descendant" "::"> | <"attribute" "::"> | <"self" "::"> | <"descendant-or-self" "::">
***************************************************************************************/
  final public byte ForwardAxis() throws ParseException, ParseException, Exception {
        byte axis = Axis.NONE;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case CHILD_DCOLON:
      currentToken = jj_consume_token(CHILD_DCOLON);
                        //previousToken = currentToken;
                        // if (debug) System.out.println("ForwardAxis - Read <CHILD_DCOLON> " + currentToken.image);
                        axis = Axis.CHILD;
      break;
    case DESCENDANT_DCOLON:
      currentToken = jj_consume_token(DESCENDANT_DCOLON);
                        //previousToken = currentToken;
                        // if (debug) System.out.println("ForwardAxis - Read <DESCENDANT_DCOLON> " + currentToken.image);
                        axis = Axis.DESCENDANT;
      break;
    case ATTRIBUTE_DCOLON:
      currentToken = jj_consume_token(ATTRIBUTE_DCOLON);
                        //previousToken = currentToken;
                        // if (debug) System.out.println("ForwardAxis - Read <ATTRIBUTE_DCOLON> " + currentToken.image);
                        axis = Axis.ATTRIBUTE;
      break;
    case SELF_DCOLON:
      currentToken = jj_consume_token(SELF_DCOLON);
                        //previousToken = currentToken;
                        // if (debug) System.out.println("ForwardAxis - Read <SELF_DCOLON> " + currentToken.image);
                        axis = Axis.SELF;
      break;
    case DESCENDANT_SELF_DCOLON:
      currentToken = jj_consume_token(DESCENDANT_SELF_DCOLON);
                        //previousToken = currentToken;
                        // if (debug) System.out.println("ForwardAxis - Read <DESCENDANT_SELF_DCOLON> " + currentToken.image);
                        axis = Axis.DESCENDANT_OR_SELF;
      break;
    default:
      jj_la1[59] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                {if (true) return axis;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[41]	ReverseAxis ::=						<"parent" "::">
***************************************************************************************/
  final public byte ReverseAxis() throws ParseException, ParseException, Exception {
        byte axis = Axis.NONE;
    currentToken = jj_consume_token(PARENT_DCOLON);
                        //previousToken = currentToken;
                        // if (debug) System.out.println("ReverseAxis - Read <PARENT_DCOLON> " + currentToken.image);
                        axis = Axis.PARENT;
                {if (true) return axis;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[42]	NodeTest ::=						KindTest | NameTest
***************************************************************************************/
  final public XQueryExpression NodeTest() throws ParseException, ParseException, Exception {
        XQueryExpression expression = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case COMMENT_L_PAREN_R_PAREN:
    case NODE_L_PAREN_R_PAREN:
    case PROCESSING_INSTRUCTION_L_PAREN:
    case TEXT_L_PAREN_R_PAREN:
      expression = KindTest();
      break;
    case AND:
    case ASCENDING:
    case ATTRIBUTE:
    case BY:
    case CASE:
    case DEFAULT_:
    case DESCENDING:
    case DIVISION:
    case ELEMENT:
    case ELSE:
    case EVERY:
    case EXCEPT:
    case FOR:
    case IN:
    case INTEGER_DIVISION:
    case INTERSECT:
    case IS:
    case ISNOT:
    case LET:
    case MODULO:
    case OR:
    case RETURN:
    case SATISFIES:
    case SOME:
    case SORT:
    case SORTBY:
    case STABLE:
    case STAR:
    case TO:
    case UNION:
    case UNORDERED:
    case VALIDATE:
    case VALUE_EQUALS:
    case VALUE_GREATER_THAN:
    case VALUE_GREATER_THAN_EQUALS:
    case VALUE_LESS_THAN:
    case VALUE_LESS_THAN_EQUALS:
    case VALUE_NOT_EQUALS:
    case WHERE:
    case NCName:
    case START_TAG_NCName:
    case END_TAG_NCName:
      expression = NameTest();
      break;
    default:
      jj_la1[60] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                {if (true) return expression;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[43]	NameTest ::=						QName | Wildcard
***************************************************************************************/
  final public QName NameTest() throws ParseException, ParseException, Exception {
        QName nameTest = null;
    if (jj_2_9(3)) {
      nameTest = QName(true);
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case AND:
      case ASCENDING:
      case ATTRIBUTE:
      case BY:
      case CASE:
      case DEFAULT_:
      case DESCENDING:
      case DIVISION:
      case ELEMENT:
      case ELSE:
      case EVERY:
      case EXCEPT:
      case FOR:
      case IN:
      case INTEGER_DIVISION:
      case INTERSECT:
      case IS:
      case ISNOT:
      case LET:
      case MODULO:
      case OR:
      case RETURN:
      case SATISFIES:
      case SOME:
      case SORT:
      case SORTBY:
      case STABLE:
      case STAR:
      case TO:
      case UNION:
      case UNORDERED:
      case VALIDATE:
      case VALUE_EQUALS:
      case VALUE_GREATER_THAN:
      case VALUE_GREATER_THAN_EQUALS:
      case VALUE_LESS_THAN:
      case VALUE_LESS_THAN_EQUALS:
      case VALUE_NOT_EQUALS:
      case WHERE:
      case NCName:
      case START_TAG_NCName:
      case END_TAG_NCName:
        nameTest = Wildcard();
        break;
      default:
        jj_la1[61] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
                {if (true) return nameTest;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[44]	Wildcard ::=						( "*" ( <":" NCName> )? ) | <NCName ":" "*">
		W3C WD 16 August 2002 ->			"*" | <NCName ":" "*"> | <"*" ":" NCName>
***************************************************************************************/
  final public QName Wildcard() throws ParseException, ParseException, Exception {
        String namespace = null;
        String prefixname = null;
        String localname = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case STAR:
      currentToken = jj_consume_token(STAR);
                                //previousToken = currentToken;
                                // if (debug) System.out.println("Wildcard - Read <STAR> " + currentToken.image);
                                prefixname = currentToken.image;
                                localname = prefixname;
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COLON:
        currentToken = jj_consume_token(COLON);

        localname = NCName();
        break;
      default:
        jj_la1[62] = jj_gen;
        ;
      }
      break;
    case AND:
    case ASCENDING:
    case ATTRIBUTE:
    case BY:
    case CASE:
    case DEFAULT_:
    case DESCENDING:
    case DIVISION:
    case ELEMENT:
    case ELSE:
    case EVERY:
    case EXCEPT:
    case FOR:
    case IN:
    case INTEGER_DIVISION:
    case INTERSECT:
    case IS:
    case ISNOT:
    case LET:
    case MODULO:
    case OR:
    case RETURN:
    case SATISFIES:
    case SOME:
    case SORT:
    case SORTBY:
    case STABLE:
    case TO:
    case UNION:
    case UNORDERED:
    case VALIDATE:
    case VALUE_EQUALS:
    case VALUE_GREATER_THAN:
    case VALUE_GREATER_THAN_EQUALS:
    case VALUE_LESS_THAN:
    case VALUE_LESS_THAN_EQUALS:
    case VALUE_NOT_EQUALS:
    case WHERE:
    case NCName:
    case START_TAG_NCName:
    case END_TAG_NCName:
      prefixname = NCName();
      currentToken = jj_consume_token(COLON);

      currentToken = jj_consume_token(STAR);
                                //previousToken = currentToken;
                                // if (debug) System.out.println("Wildcard - Read <STAR> " + currentToken.image);
                                localname = currentToken.image;
      break;
    default:
      jj_la1[63] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                try
                {
                        String tmpStr = null;
                        if (prefixname == null)
                        {
                                namespace = defaultNameSpace;
                        }
                        else if (prefixname.equals("*"))
                        {
                                namespace = prefixname;
                        }
                        else
                        {
                                tmpStr = getNameSpace(prefixname);
                                if (tmpStr == null)
                                {
                                        {if (true) throw new TypeException("Could not match prefix [ " + prefixname + " ]" , currentToken.beginLine, currentToken.beginColumn);}
                                }
                                namespace = tmpStr;
                        }
                        {if (true) return factory.createQName(namespace, prefixname, localname, typevisitor);}
                }
                catch (TypeException te)
                {
                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                }
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[45]	KindTest ::=						ProcessingInstructionTest | CommentTest | TextTest | AnyKindTest
***************************************************************************************/
  final public NodeType KindTest() throws ParseException, ParseException, Exception {
        NodeType nodeType = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case PROCESSING_INSTRUCTION_L_PAREN:
      nodeType = ProcessingInstructionTest();
      break;
    case COMMENT_L_PAREN_R_PAREN:
      nodeType = CommentTest();
      break;
    case TEXT_L_PAREN_R_PAREN:
      nodeType = TextTest();
      break;
    case NODE_L_PAREN_R_PAREN:
      nodeType = AnyKindTest();
      break;
    default:
      jj_la1[64] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                {if (true) return nodeType;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[46]	ProcessingInstructionTest ::=		<"processing-instruction" "("> StringLiteral? ")"
***************************************************************************************/
  final public NodeType ProcessingInstructionTest() throws ParseException, ParseException, Exception {
        String value = null;
    currentToken = jj_consume_token(PROCESSING_INSTRUCTION_L_PAREN);

    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case StringLiteral:
      currentToken = jj_consume_token(StringLiteral);
                                //previousToken = currentToken;
                                // if (debug) System.out.println("ProcessingInstructionTest - Read <StringLiteral> " + currentToken.image);
                                value = currentToken.image;
      break;
    default:
      jj_la1[65] = jj_gen;
      ;
    }
    currentToken = jj_consume_token(R_PAREN);

                try
                {
                        {if (true) return factory.createNodeType(NodeKind.PI, value, typevisitor);}
                }
                catch (TypeException te)
                {
                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                }
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[47]	CommentTest ::=						<"comment" "("> ")"
***************************************************************************************/
  final public NodeType CommentTest() throws ParseException, ParseException, Exception {
    currentToken = jj_consume_token(COMMENT_L_PAREN_R_PAREN);

                try
                {
                        {if (true) return factory.createNodeType(NodeKind.COMMENT, null, typevisitor);}
                }
                catch (TypeException te)
                {
                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                }
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[48]	TextTest ::=						<"text" "("> ")"
***************************************************************************************/
  final public NodeType TextTest() throws ParseException, ParseException, Exception {
    currentToken = jj_consume_token(TEXT_L_PAREN_R_PAREN);

                try
                {
                        {if (true) return factory.createNodeType(NodeKind.TEXT, null, typevisitor);}
                }
                catch (TypeException te)
                {
                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                }
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[49]	AnyKindTest ::=						<"node" "("> ")"
***************************************************************************************/
  final public NodeType AnyKindTest() throws ParseException, ParseException, Exception {
    currentToken = jj_consume_token(NODE_L_PAREN_R_PAREN);

                try
                {
                        {if (true) return factory.createNodeType(NodeKind.NODE, null, typevisitor);}
                }
                catch (TypeException te)
                {
                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                }
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[50]	ForwardStep ::=						AbbreviatedForwardStep | ( ForwardAxis NodeTest )
		W3C WD 16 August 2002 ->			( ForwardAxis NodeTest ) | AbbreviatedForwardStep
***************************************************************************************/
  final public Step ForwardStep(boolean separator) throws ParseException, ParseException, Exception {
        byte axis = Axis.NONE;
        XQueryExpression expression = null;
        Step step = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case AND:
    case ASCENDING:
    case AT:
    case ATTRIBUTE:
    case BY:
    case CASE:
    case COMMENT_L_PAREN_R_PAREN:
    case DEFAULT_:
    case DESCENDING:
    case DIVISION:
    case DOT:
    case ELEMENT:
    case ELSE:
    case EVERY:
    case EXCEPT:
    case FOR:
    case IN:
    case INTEGER_DIVISION:
    case INTERSECT:
    case IS:
    case ISNOT:
    case LET:
    case MODULO:
    case NODE_L_PAREN_R_PAREN:
    case OR:
    case PROCESSING_INSTRUCTION_L_PAREN:
    case RETURN:
    case SATISFIES:
    case SOME:
    case SORT:
    case SORTBY:
    case STABLE:
    case STAR:
    case TEXT_L_PAREN_R_PAREN:
    case TO:
    case UNION:
    case UNORDERED:
    case VALIDATE:
    case VALUE_EQUALS:
    case VALUE_GREATER_THAN:
    case VALUE_GREATER_THAN_EQUALS:
    case VALUE_LESS_THAN:
    case VALUE_LESS_THAN_EQUALS:
    case VALUE_NOT_EQUALS:
    case WHERE:
    case NCName:
    case START_TAG_NCName:
    case END_TAG_NCName:
      step = AbbreviatedForwardStep(separator);
      break;
    case ATTRIBUTE_DCOLON:
    case CHILD_DCOLON:
    case DESCENDANT_DCOLON:
    case DESCENDANT_SELF_DCOLON:
    case SELF_DCOLON:
      axis = ForwardAxis();
      expression = NodeTest();
                                try
                                {
                                        if (axis == Axis.ATTRIBUTE && defaultNameSpace != null && expression instanceof QName) ((QName) expression).setNameSpace(null);
                                        step = factory.createStep(separator, axis, expression, null, typevisitor);
                                }
                                catch (TypeException te)
                                {
                                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                                }
      break;
    default:
      jj_la1[66] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                {if (true) return step;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[51]	ReverseStep ::=						AbbreviatedReverseStep | ( ReverseAxis NodeTest )
		W3C WD 16 August 2002 ->			( ReverseAxis NodeTest ) | AbbreviatedReverseStep
***************************************************************************************/
  final public Step ReverseStep(boolean separator) throws ParseException, ParseException, Exception {
        byte axis = Axis.NONE;
        XQueryExpression expression = null;
        Step step = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case DOTDOT:
      step = AbbreviatedReverseStep(separator);
      break;
    case PARENT_DCOLON:
      axis = ReverseAxis();
      expression = NodeTest();
                                try
                                {
                                        step = factory.createStep(separator, axis, expression, null, typevisitor);
                                }
                                catch (TypeException te)
                                {
                                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                                }
      break;
    default:
      jj_la1[67] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                {if (true) return step;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[52]	AbbreviatedForwardStep ::=			"." | ( "@" NameTest ) | NodeTest
***************************************************************************************/
  final public Step AbbreviatedForwardStep(boolean separator) throws ParseException, ParseException, Exception {
        XQueryExpression expression = null;
        byte axis = Axis.NONE;
        if (separator)
        {
                axis = Axis.CHILD;
        }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case DOT:
      currentToken = jj_consume_token(DOT);

                                try
                                {
                                        expression = factory.createNodeType(NodeKind.NODE, null, typevisitor);
                                }
                                catch (TypeException te)
                                {
                                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                                }
                                axis = Axis.SELF;
      break;
    case AT:
      currentToken = jj_consume_token(AT);
                                //previousToken = currentToken;
                                // if (debug) System.out.println("AbbreviatedForwardStep - Read <AT> " + currentToken.image);
                                axis = Axis.ATTRIBUTE;
      expression = NameTest();
                                if (defaultNameSpace != null) ((QName) expression).setNameSpace(null);
      break;
    case AND:
    case ASCENDING:
    case ATTRIBUTE:
    case BY:
    case CASE:
    case COMMENT_L_PAREN_R_PAREN:
    case DEFAULT_:
    case DESCENDING:
    case DIVISION:
    case ELEMENT:
    case ELSE:
    case EVERY:
    case EXCEPT:
    case FOR:
    case IN:
    case INTEGER_DIVISION:
    case INTERSECT:
    case IS:
    case ISNOT:
    case LET:
    case MODULO:
    case NODE_L_PAREN_R_PAREN:
    case OR:
    case PROCESSING_INSTRUCTION_L_PAREN:
    case RETURN:
    case SATISFIES:
    case SOME:
    case SORT:
    case SORTBY:
    case STABLE:
    case STAR:
    case TEXT_L_PAREN_R_PAREN:
    case TO:
    case UNION:
    case UNORDERED:
    case VALIDATE:
    case VALUE_EQUALS:
    case VALUE_GREATER_THAN:
    case VALUE_GREATER_THAN_EQUALS:
    case VALUE_LESS_THAN:
    case VALUE_LESS_THAN_EQUALS:
    case VALUE_NOT_EQUALS:
    case WHERE:
    case NCName:
    case START_TAG_NCName:
    case END_TAG_NCName:
      expression = NodeTest();
      break;
    default:
      jj_la1[68] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                try
                {
                        {if (true) return factory.createStep(separator, axis, expression, null, typevisitor);}
                }
                catch (TypeException te)
                {
                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                }
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[53]	AbbreviatedReverseStep ::=			".."
***************************************************************************************/
  final public Step AbbreviatedReverseStep(boolean separator) throws ParseException, ParseException, Exception {
        XQueryExpression expression = null;
        byte axis = Axis.NONE;
    currentToken = jj_consume_token(DOTDOT);

                        try
                        {
                                expression = factory.createNodeType(NodeKind.NODE, null, typevisitor);
                        }
                        catch (TypeException te)
                        {
                                {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                        }
                        axis = Axis.PARENT;
                try
                {
                        {if (true) return factory.createStep(separator, axis, expression, null, typevisitor);}
                }
                catch (TypeException te)
                {
                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                }
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[54]	Predicates ::=						( "[" Expr "]" )*
***************************************************************************************/
  final public ArrayList Predicates() throws ParseException, ParseException, Exception {
        XQueryExpression expression = null;
        ArrayList predicates = null;
        boolean oldInPredicate = false;
    label_17:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case L_BRACKET:
        ;
        break;
      default:
        jj_la1[69] = jj_gen;
        break label_17;
      }
      currentToken = jj_consume_token(L_BRACKET);
                                //previousToken = currentToken;
                                // if (debug) System.out.println("Predicates - Read <L_BRACKET> " + currentToken.image);
                                oldInPredicate = inPredicate;
                                inPredicate = true;
      expression = Expr();
                                if (restriction && expression instanceof Value) {if (true) throw new ParseException("Encountered \"" + currentToken.image + "\" at line " + currentToken.beginLine + ", column " + currentToken.beginColumn + ". RangeExpr is not supported yet.");}
      currentToken = jj_consume_token(R_BRACKET);
                                //previousToken = currentToken;
                                // if (debug) System.out.println("Predicates - Read <R_BRACKET> " + currentToken.image);
                                inPredicate = oldInPredicate;
                        if (predicates == null)
                        {
                                predicates = new ArrayList(1);
                        }
                        expression.setBracket(true);
                        predicates.add(expression);
    }
                {if (true) return predicates;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[55]	NumericLiteral ::=					IntegerLiteral | DecimalLiteral | DoubleLiteral
***************************************************************************************/
  final public Value NumericLiteral() throws ParseException, ParseException, Exception {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IntegerLiteral:
      currentToken = jj_consume_token(IntegerLiteral);
                //previousToken = currentToken;
                // if (debug) System.out.println("NumericLiteral - Read <IntegerLiteral> " + currentToken.image);
                try
                {
                        {if (true) return factory.createValueInteger(currentToken.image, typevisitor);}
                }
                catch (TypeException te)
                {
                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                }
      break;
    case DecimalLiteral:
      currentToken = jj_consume_token(DecimalLiteral);
                //previousToken = currentToken;
                // if (debug) System.out.println("NumericLiteral - Read <DecimalLiteral> " + currentToken.image);
                try
                {
                        {if (true) return factory.createValueDecimal(currentToken.image, typevisitor);}
                }
                catch (TypeException te)
                {
                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                }
      break;
    case DoubleLiteral:
      currentToken = jj_consume_token(DoubleLiteral);
                //previousToken = currentToken;
                // if (debug) System.out.println("NumericLiteral - Read <DoubleLiteral> " + currentToken.image);
                try
                {
                        {if (true) return factory.createValueDouble(currentToken.image, typevisitor);}
                }
                catch (TypeException te)
                {
                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                }
      break;
    default:
      jj_la1[70] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[56]	Literal ::=							NumericLiteral | StringLiteral
***************************************************************************************/
  final public Value Literal() throws ParseException, ParseException, Exception {
        Value value = null;
        String stringLiteral;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case DecimalLiteral:
    case DoubleLiteral:
    case IntegerLiteral:
      value = NumericLiteral();
      break;
    case StringLiteral:
      currentToken = jj_consume_token(StringLiteral);
                        //previousToken = currentToken;
                        // if (debug) System.out.println("Literal - Read <StringLiteral> " + currentToken.image);
                        stringLiteral = currentToken.image;
                        try
                        {
                                value = factory.createValueString(unquote(stringLiteral), typevisitor);
                        }
                        catch (TypeException te)
                        {
                                {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                        }
      break;
    default:
      jj_la1[71] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                {if (true) return value;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[57]	ParenthesizedExpr ::=				"(" ExprSequence? ")"
***************************************************************************************/
  final public XQueryExpression ParenthesizedExpr() throws ParseException, ParseException, Exception {
        XQueryExpression expression = null;
    currentToken = jj_consume_token(L_PAREN);

    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case AND:
    case ASCENDING:
    case AT:
    case ATTRIBUTE:
    case ATTRIBUTE_DCOLON:
    case ATTRIBUTE_L_BRACE:
    case BY:
    case CASE:
    case CAST_AS:
    case CDATA_START:
    case CHILD_DCOLON:
    case COMMENT_L_PAREN_R_PAREN:
    case DEFAULT_:
    case DESCENDANT_DCOLON:
    case DESCENDANT_SELF_DCOLON:
    case DESCENDING:
    case DIVISION:
    case DOCUMENT_L_BRACE:
    case DOT:
    case DOTDOT:
    case DecimalLiteral:
    case DoubleLiteral:
    case ELEMENT:
    case ELEMENT_L_BRACE:
    case ELSE:
    case EVERY:
    case EXCEPT:
    case FOR:
    case IF_L_PAREN:
    case IN:
    case INTEGER_DIVISION:
    case INTERSECT:
    case IS:
    case ISNOT:
    case IntegerLiteral:
    case LESS_THAN:
    case LET:
    case L_PAREN:
    case MINUS:
    case MODULO:
    case NODE_L_PAREN_R_PAREN:
    case OR:
    case PARENT_DCOLON:
    case PLUS:
    case PROCESSING_INSTRUCTION_L_PAREN:
    case RETURN:
    case SATISFIES:
    case SELF_DCOLON:
    case SLASH:
    case SLASHSLASH:
    case SOME:
    case SORT:
    case SORTBY:
    case STABLE:
    case STAR:
    case StringLiteral:
    case TEXT_L_PAREN_R_PAREN:
    case TO:
    case TREAT_AS:
    case TYPESWITCH_L_PAREN:
    case UNION:
    case UNORDERED:
    case VALIDATE:
    case VALUE_EQUALS:
    case VALUE_GREATER_THAN:
    case VALUE_GREATER_THAN_EQUALS:
    case VALUE_LESS_THAN:
    case VALUE_LESS_THAN_EQUALS:
    case VALUE_NOT_EQUALS:
    case VARName:
    case WHERE:
    case XMLCOMMENT_START:
    case XMLPROCESSING_START:
    case NCName:
    case START_TAG_NCName:
    case END_TAG_NCName:
    case ELT_LESS_THAN:
    case ELT_XMLCOMMENT_START:
    case ELT_XMLPROCESSING_START:
    case ELT_CDATA_START:
      expression = ExprSequence(false);
      break;
    default:
      jj_la1[72] = jj_gen;
      ;
    }
    currentToken = jj_consume_token(R_PAREN);

                        if (expression == null)
                        {
                                expression = factory.createXQueryVoid(typevisitor);
                        }
                        else
                        {
                                expression.setParenthesis(true);
                        }
                {if (true) return expression;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[58]	FunctionCall ::=					<QName "("> ( Expr ( "," Expr )* )? ")"
***************************************************************************************/
  final public XQueryExpression FunctionCall() throws ParseException, ParseException, Exception {
        QName funcName = null;
        XQueryExpression expression = null;
        XQueryExpressionSequence tmpExpr = null;
        ArrayList arguments = null;
        boolean isFunc = false;
    if (jj_2_10(3)) {
      funcName = QName(true);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case L_PAREN:
        currentToken = jj_consume_token(L_PAREN);
                                //previousToken = currentToken;
                                // if (debug) System.out.println("FunctionCall - Read <L_PAREN> " + currentToken.image);
                                isFunc = true;
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case AND:
        case ASCENDING:
        case AT:
        case ATTRIBUTE:
        case ATTRIBUTE_DCOLON:
        case ATTRIBUTE_L_BRACE:
        case BY:
        case CASE:
        case CAST_AS:
        case CDATA_START:
        case CHILD_DCOLON:
        case COMMENT_L_PAREN_R_PAREN:
        case DEFAULT_:
        case DESCENDANT_DCOLON:
        case DESCENDANT_SELF_DCOLON:
        case DESCENDING:
        case DIVISION:
        case DOCUMENT_L_BRACE:
        case DOT:
        case DOTDOT:
        case DecimalLiteral:
        case DoubleLiteral:
        case ELEMENT:
        case ELEMENT_L_BRACE:
        case ELSE:
        case EVERY:
        case EXCEPT:
        case FOR:
        case IF_L_PAREN:
        case IN:
        case INTEGER_DIVISION:
        case INTERSECT:
        case IS:
        case ISNOT:
        case IntegerLiteral:
        case LESS_THAN:
        case LET:
        case L_PAREN:
        case MINUS:
        case MODULO:
        case NODE_L_PAREN_R_PAREN:
        case OR:
        case PARENT_DCOLON:
        case PLUS:
        case PROCESSING_INSTRUCTION_L_PAREN:
        case RETURN:
        case SATISFIES:
        case SELF_DCOLON:
        case SLASH:
        case SLASHSLASH:
        case SOME:
        case SORT:
        case SORTBY:
        case STABLE:
        case STAR:
        case StringLiteral:
        case TEXT_L_PAREN_R_PAREN:
        case TO:
        case TREAT_AS:
        case TYPESWITCH_L_PAREN:
        case UNION:
        case UNORDERED:
        case VALIDATE:
        case VALUE_EQUALS:
        case VALUE_GREATER_THAN:
        case VALUE_GREATER_THAN_EQUALS:
        case VALUE_LESS_THAN:
        case VALUE_LESS_THAN_EQUALS:
        case VALUE_NOT_EQUALS:
        case VARName:
        case WHERE:
        case XMLCOMMENT_START:
        case XMLPROCESSING_START:
        case NCName:
        case START_TAG_NCName:
        case END_TAG_NCName:
        case ELT_LESS_THAN:
        case ELT_XMLCOMMENT_START:
        case ELT_XMLPROCESSING_START:
        case ELT_CDATA_START:
          expression = Expr();
                                        if (arguments == null) arguments = new ArrayList(1);
                                        arguments.add(expression);
          label_18:
          while (true) {
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case COMMA:
              ;
              break;
            default:
              jj_la1[73] = jj_gen;
              break label_18;
            }
            currentToken = jj_consume_token(COMMA);

            expression = Expr();
                                                arguments.add(expression);
          }
          break;
        default:
          jj_la1[74] = jj_gen;
          ;
        }
        currentToken = jj_consume_token(R_PAREN);

        break;
      default:
        jj_la1[75] = jj_gen;
        ;
      }
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case AND:
      case ASCENDING:
      case ATTRIBUTE:
      case BY:
      case CASE:
      case DEFAULT_:
      case DESCENDING:
      case DIVISION:
      case ELEMENT:
      case ELSE:
      case EVERY:
      case EXCEPT:
      case FOR:
      case IN:
      case INTEGER_DIVISION:
      case INTERSECT:
      case IS:
      case ISNOT:
      case LET:
      case MODULO:
      case OR:
      case RETURN:
      case SATISFIES:
      case SOME:
      case SORT:
      case SORTBY:
      case STABLE:
      case STAR:
      case TO:
      case UNION:
      case UNORDERED:
      case VALIDATE:
      case VALUE_EQUALS:
      case VALUE_GREATER_THAN:
      case VALUE_GREATER_THAN_EQUALS:
      case VALUE_LESS_THAN:
      case VALUE_LESS_THAN_EQUALS:
      case VALUE_NOT_EQUALS:
      case WHERE:
      case NCName:
      case START_TAG_NCName:
      case END_TAG_NCName:
        funcName = Wildcard();
        break;
      default:
        jj_la1[76] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
                if (!isFunc) {if (true) return funcName;}
                if (funDefNames.containsKey(funcName.getLocalName()))
                {
                        try
                        {
                                funcName.setPrefixName(null);
                                {if (true) return factory.createLibraryFunctionCall(funcName, arguments, (FunctionDefinition)funDefNames.get(funcName.getLocalName()), typevisitor);}
                        }
                        catch (TypeException te)
                        {
                                {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                        }
                }
                try
                {

                        String functionName = funcName.getLocalName();
                        if (functionName.equals("collection"))
                        {
                                /* looks up view definition */
                                ValueString viewName = (ValueString)arguments.get(0);
                                String viewNameString = viewName.getValue();
                                if (null != viewDefinitions) {
                                        XQueryFile resFile = (XQueryFile)viewDefinitions.get(viewNameString);
                                        XQueryExpression resExpr = null;
                                        try {
                                                resExpr = (XQueryExpression)resFile.getUnit(0).getExpressions().get(0);
                                        }
                                        catch (Exception e) {}
                                        if (resExpr != null) {if (true) return resExpr;}
                                        /*
					String viewDefinition = (String)viewDefinitions.get(viewNameString);
					if (null != viewDefinition) {
						return view(viewDefinition);
					}
					*/
                                }
                        }
                        functionName = funcName.getLocalName().toUpperCase();
                        functionName = functionName.replace('-', '_');
                        boolean found = true;
                        java.lang.Class cl = null;
                        try {
                                found = true;
                                cl = Class.forName("org.xquark.xquery.parser.primitivefunctions.fnfunctions.Function" + functionName );
                        } catch (ClassNotFoundException cnfe) { found = false; }
                        if (!found)
                                try {
                                        found = true;
                                        cl = Class.forName("org.xquark.xquery.parser.primitivefunctions.myfunctions.Function" + functionName );
                                } catch (ClassNotFoundException cnfe) {found = false;}
                        if (!found)
                                try {
                                        found = true;
                                        cl = Class.forName("org.xquark.xquery.parser.primitivefunctions.xsfunctions.Function" + functionName );
                                } catch (ClassNotFoundException cnfe) {found = false;}
                        if (!found)
                                {if (true) throw new TypeException("Could not find primitive function " + funcName.getLocalName().toUpperCase(), currentToken.beginLine, currentToken.beginColumn);}
                        java.lang.Class[] paramTypes = { Class.forName("java.util.ArrayList"), Class.forName("org.xquark.xquery.parser.TypeVisitor")};
                        java.lang.reflect.Constructor constructor = cl.getConstructor(paramTypes);
                        Object[] params = { arguments, typevisitor };
                        FunctionCall fc = null;
                        fc = (FunctionCall) constructor.newInstance(params);
                        String localName = funcName.getLocalName();
                        if (!fc.getFuncName().getLocalName().equals(localName)) {if (true) throw new ParseException("XQuery is a case-sensitive language. Primitive function " + localName + " is not a valid name.");}
                        // change lars 18/06/2003
                        if (fc instanceof FunctionINTEGER || fc instanceof FunctionDOUBLE || fc instanceof FunctionDECIMAL || fc instanceof FunctionFLOAT)
                        {
                                if (fc.getArgument(0) instanceof Value)
                                        {if (true) return (XQueryExpression)fc.getArguments().get(0);}
                        }
                        {if (true) return fc;}
                }
                catch (ClassNotFoundException cnfe) {
                        {if (true) throw new TypeException("Could not find primitive function " + funcName.getLocalName().toUpperCase(), currentToken.beginLine, currentToken.beginColumn);}
                }
                catch (java.lang.reflect.InvocationTargetException ite) {
                        {if (true) throw new TypeException(ite.getTargetException().getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                }
                catch (TypeException e) {
                        {if (true) throw e;}
                }
                catch (Exception e) // { /* this is done on purpose you fool! */ }
                {
                        {if (true) throw new TypeException(e.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                }
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[59]	Param ::=							SequenceType? VAR
		W3C WD 16 August 2002 ->			SequenceType? "$" VarName
***************************************************************************************/
  final public XQueryExpression Param(boolean isNew) throws ParseException, ParseException, Exception {
        XQueryExpression var = null;
        boolean hasSequenceType = false;
        SequenceTypeExpression sequenceType = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case AND:
    case ASCENDING:
    case ATTRIBUTE:
    case BY:
    case CASE:
    case DEFAULT_:
    case DESCENDING:
    case DIVISION:
    case ELEMENT:
    case ELSE:
    case EVERY:
    case EXCEPT:
    case FOR:
    case IN:
    case INTEGER_DIVISION:
    case INTERSECT:
    case IS:
    case ISNOT:
    case LET:
    case MODULO:
    case OR:
    case RETURN:
    case SATISFIES:
    case SOME:
    case SORT:
    case SORTBY:
    case STABLE:
    case TO:
    case UNION:
    case UNORDERED:
    case VALIDATE:
    case VALUE_EQUALS:
    case VALUE_GREATER_THAN:
    case VALUE_GREATER_THAN_EQUALS:
    case VALUE_LESS_THAN:
    case VALUE_LESS_THAN_EQUALS:
    case VALUE_NOT_EQUALS:
    case WHERE:
    case NCName:
    case START_TAG_NCName:
    case END_TAG_NCName:
    case ATOMIC_VALUE:
    case ATTRIBUTE_TYPE:
    case COMMENT:
    case DOCUMENT:
    case ELEMENT_TYPE:
    case EMPTY:
    case ITEM:
    case NODE:
    case PROCESSING_INSTRUC:
    case TEXT:
    case UNTYPED:
      sequenceType = SequenceType();
                                hasSequenceType = true;
      break;
    default:
      jj_la1[77] = jj_gen;
      ;
    }
    var = VAR(isNew, false);
                        if (hasSequenceType)
                        {
                                var.setTypeDeclaration(sequenceType);
                        }
                {if (true) return var;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[60]	SchemaContext ::=					"in" ( "type" )? QName ( "/" SchemaContextStep )*
		Inclusion of [61] in [60]
		W3C WD 16 August 2002 -> 			"in" SchemaGlobalContext ( "/" SchemaContextStep )*
***************************************************************************************/
  final public ItemType SchemaContext() throws ParseException, ParseException, Exception {
        int kind = -1;
        boolean separator = false;
        ArrayList steps = new ArrayList();
        Step step = null;
        XQueryExpression expression = null;
        QName qName = null;
    currentToken = jj_consume_token(IN_TYPE);
                        //previousToken = currentToken;
                        // if (debug) System.out.println("SchemaContext - Read <IN_TYPE> " + currentToken.image);
                        kind = Constants.IT_IN;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case TYPE_TYPE:
      currentToken = jj_consume_token(TYPE_TYPE);
                                //previousToken = currentToken;
                                // if (debug) System.out.println("SchemaContext - Read <TYPE_TYPE> " + currentToken.image);
                                kind = Constants.IT_IN_TYPE;
      break;
    default:
      jj_la1[78] = jj_gen;
      ;
    }
    expression = QName(true);
                        try
                        {
                                step = factory.createStep(separator, Axis.NONE, expression, null, typevisitor);
                        }
                        catch (TypeException te)
                        {
                                {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                        }
                        steps.add(step);
    label_19:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SLASH:
        ;
        break;
      default:
        jj_la1[79] = jj_gen;
        break label_19;
      }
      currentToken = jj_consume_token(SLASH);
                                //previousToken = currentToken;
                                // if (debug) System.out.println("SchemaContext - Read <SLASH> " + currentToken.image);
                                separator = true;
      qName = SchemaContextStep();
                                try
                                {
                                        step = factory.createStep(separator, Axis.CHILD, qName, null, typevisitor);
                                }
                                catch (TypeException te)
                                {
                                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                                }
                                steps.add(step);
    }
                if (steps.size() > 1)
                {
                        try {
                                if (LocatedExpressionReducer.simplifySteps(steps, inPredicate, typevisitor) == 0)
                                        {if (true) throw new TypeException("steps of LocatedExpression are not valid", currentToken.beginLine, currentToken.beginColumn);}
                        }
                        catch (NormalizeException ne) {
                                {if (true) throw new TypeException(ne.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                        }
                        try
                        {
                                expression = factory.createLocatedExpression(steps, inPredicate, typevisitor);
                        }
                        catch (TypeException te)
                        {
                                {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                        }
                }
                try
                {
                        {if (true) return factory.createItemType(null, kind, expression, typevisitor);}
                }
                catch (TypeException te)
                {
                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                }
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[61]	SchemaGlobalContext ::=				QName | <"type" QName>
		Rule included in [60]
***************************************************************************************/

/***************************************************************************************
[62]	SchemaContextStep ::=				QName
***************************************************************************************/
  final public QName SchemaContextStep() throws ParseException, ParseException, Exception {
        QName qName = null;
    qName = QName(true);
                {if (true) return qName;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[63]	TypeDeclaration ::=					SequenceType
***************************************************************************************/
  final public SequenceTypeExpression TypeDeclaration() throws ParseException, ParseException, Exception {
        SequenceTypeExpression sequenceType = null;
    sequenceType = SequenceType();
                {if (true) return sequenceType;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[64]	SequenceType ::=					( ( ( ( "element" | "attribute" ) ElemOrAttrType? ) | "node" | "processing-instruction" | "comment" | "text" | "document" | "item" | AtomicType | "untyped" | <"atomic" "value"> ) OccurrenceIndicator ) | "empty"
		Inclusion of [65] in [64]
		W3C WD 16 August 2002 -> 			( ( "element" | "attribute" ) ElemOrAttrType? ) | "node" | "processing-instruction" | "comment" | "text" | "document" | "item" | AtomicType | "untyped" | <"atomic" "value">
***************************************************************************************/
  final public SequenceTypeExpression SequenceType() throws ParseException, ParseException, Exception {
        int kind = -1;
        ItemType itemType = null;
        QName atomicType = null;
        int occurrenceIndicator = -1;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case AND:
    case ASCENDING:
    case ATTRIBUTE:
    case BY:
    case CASE:
    case DEFAULT_:
    case DESCENDING:
    case DIVISION:
    case ELEMENT:
    case ELSE:
    case EVERY:
    case EXCEPT:
    case FOR:
    case IN:
    case INTEGER_DIVISION:
    case INTERSECT:
    case IS:
    case ISNOT:
    case LET:
    case MODULO:
    case OR:
    case RETURN:
    case SATISFIES:
    case SOME:
    case SORT:
    case SORTBY:
    case STABLE:
    case TO:
    case UNION:
    case UNORDERED:
    case VALIDATE:
    case VALUE_EQUALS:
    case VALUE_GREATER_THAN:
    case VALUE_GREATER_THAN_EQUALS:
    case VALUE_LESS_THAN:
    case VALUE_LESS_THAN_EQUALS:
    case VALUE_NOT_EQUALS:
    case WHERE:
    case NCName:
    case START_TAG_NCName:
    case END_TAG_NCName:
    case ATOMIC_VALUE:
    case ATTRIBUTE_TYPE:
    case COMMENT:
    case DOCUMENT:
    case ELEMENT_TYPE:
    case ITEM:
    case NODE:
    case PROCESSING_INSTRUC:
    case TEXT:
    case UNTYPED:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ATTRIBUTE_TYPE:
      case ELEMENT_TYPE:
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ELEMENT_TYPE:
          currentToken = jj_consume_token(ELEMENT_TYPE);
                                                        //previousToken = currentToken;
                                                        // if (debug) System.out.println("ItemType - Read <ELEMENT_TYPE> " + currentToken.image);
                                                        kind = Constants.ST_ELEMENT;
          break;
        case ATTRIBUTE_TYPE:
          currentToken = jj_consume_token(ATTRIBUTE_TYPE);
                                                        //previousToken = currentToken;
                                                        // if (debug) System.out.println("ItemType - Read <ATTRIBUTE_TYPE> " + currentToken.image);
                                                        kind = Constants.ST_ATTRIBUTE;
          break;
        default:
          jj_la1[80] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
                                                if (restriction) {if (true) throw new ParseException("Encountered \"" + currentToken.image + "\" at line " + currentToken.beginLine + ", column " + currentToken.beginColumn + ". SequenceType is not supported yet.");}
                                                switchState(DEFAULT);
        if (jj_2_11(2)) {
          itemType = ElemOrAttrType();
        } else {
          ;
        }
        break;
      case NODE:
        currentToken = jj_consume_token(NODE);
                                        //previousToken = currentToken;
                                        // if (debug) System.out.println("ItemType - Read <NODE> " + currentToken.image);
                                        kind = Constants.ST_NODE;
                                        switchState(DEFAULT);
        break;
      case PROCESSING_INSTRUC:
        currentToken = jj_consume_token(PROCESSING_INSTRUC);
                                        //previousToken = currentToken;
                                        // if (debug) System.out.println("ItemType - Read <PROCESSING_INSTRUC> " + currentToken.image);
                                        kind = Constants.ST_PROCESSING_INSTRUCTION;
                                        switchState(DEFAULT);
        break;
      case COMMENT:
        currentToken = jj_consume_token(COMMENT);
                                        //previousToken = currentToken;
                                        // if (debug) System.out.println("ItemType - Read <COMMENT> " + currentToken.image);
                                        kind = Constants.ST_COMMENT;
                                        switchState(DEFAULT);
        break;
      case TEXT:
        currentToken = jj_consume_token(TEXT);
                                        //previousToken = currentToken;
                                        // if (debug) System.out.println("ItemType - Read <TEXT> " + currentToken.image);
                                        kind = Constants.ST_TEXT;
                                        switchState(DEFAULT);
        break;
      case DOCUMENT:
        currentToken = jj_consume_token(DOCUMENT);
                                        //previousToken = currentToken;
                                        // if (debug) System.out.println("ItemType - Read <DOCUMENT> " + currentToken.image);
                                        kind = Constants.ST_DOCUMENT;
                                        switchState(DEFAULT);
        break;
      case ITEM:
        currentToken = jj_consume_token(ITEM);
                                        //previousToken = currentToken;
                                        // if (debug) System.out.println("ItemType - Read <ITEM> " + currentToken.image);
                                        kind = Constants.ST_ITEM;
                                        switchState(DEFAULT);
        break;
      case AND:
      case ASCENDING:
      case ATTRIBUTE:
      case BY:
      case CASE:
      case DEFAULT_:
      case DESCENDING:
      case DIVISION:
      case ELEMENT:
      case ELSE:
      case EVERY:
      case EXCEPT:
      case FOR:
      case IN:
      case INTEGER_DIVISION:
      case INTERSECT:
      case IS:
      case ISNOT:
      case LET:
      case MODULO:
      case OR:
      case RETURN:
      case SATISFIES:
      case SOME:
      case SORT:
      case SORTBY:
      case STABLE:
      case TO:
      case UNION:
      case UNORDERED:
      case VALIDATE:
      case VALUE_EQUALS:
      case VALUE_GREATER_THAN:
      case VALUE_GREATER_THAN_EQUALS:
      case VALUE_LESS_THAN:
      case VALUE_LESS_THAN_EQUALS:
      case VALUE_NOT_EQUALS:
      case WHERE:
      case NCName:
      case START_TAG_NCName:
      case END_TAG_NCName:
        atomicType = AtomicType();
                                        try
                                        {
                                                itemType = factory.createItemType(atomicType, -1, null, typevisitor);
                                        }
                                        catch (TypeException te)
                                        {
                                                {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                                        }
                                        switchState(DEFAULT);
        break;
      case UNTYPED:
        currentToken = jj_consume_token(UNTYPED);
                                        //previousToken = currentToken;
                                        // if (debug) System.out.println("ItemType - Read <UNTYPED> " + currentToken.image);
                                        kind = Constants.ST_UNTYPED;
                                        switchState(DEFAULT);
        break;
      case ATOMIC_VALUE:
        currentToken = jj_consume_token(ATOMIC_VALUE);
                                        //previousToken = currentToken;
                                        // if (debug) System.out.println("ItemType - Read <ATOMIC_VALUE> " + currentToken.image);
                                        kind = Constants.ST_ATOMIC_VALUE;
                                        switchState(DEFAULT);
        break;
      default:
        jj_la1[81] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
                                if (restriction) {if (true) throw new ParseException("Encountered \"" + currentToken.image + "\" at line " + currentToken.beginLine + ", column " + currentToken.beginColumn + ". SequenceType is not supported yet.");}
      occurrenceIndicator = OccurrenceIndicator();
      break;
    case EMPTY:
      currentToken = jj_consume_token(EMPTY);
                        //previousToken = currentToken;
                        // if (debug) System.out.println("SequenceType - Read <EMPTY> " + currentToken.image);
                        if (restriction) {if (true) throw new ParseException("Encountered \"" + currentToken.image + "\" at line " + currentToken.beginLine + ", column " + currentToken.beginColumn + ". SequenceType is not supported yet.");}
                        kind = Constants.ST_EMPTY;
      break;
    default:
      jj_la1[82] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                try
                {
                        {if (true) return factory.createSequenceTypeExpression(kind, itemType, occurrenceIndicator, typevisitor);}
                }
                catch (TypeException te)
                {
                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                }
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[65]	ItemType ::=						( ( "element" | "attribute" ) ElemOrAttrType? ) | "node" | "processing-instruction" | "comment" | "text" | "document" | "item" | AtomicType | "untyped" | <"atomic" "value">
		Rule included in [64]
***************************************************************************************/

/***************************************************************************************
[66]	ElemOrAttrType ::=					( QName ( ( <"of" "type"> QName ) | SchemaContext? ) ) | ( <"of" "type"> QName )
		Inclusion of [67] in [66]
		W3C WD 16 August 2002 -> 			( QName ( SchemaType | SchemaContext? ) ) | SchemaType
***************************************************************************************/
  final public ItemType ElemOrAttrType() throws ParseException, ParseException, Exception {
        QName qName = null;
        QName qNameDependancy = null;
        int kind = -1;
        boolean hasSchemaContext = false;
        boolean hasQNameDependancy = false;
        ItemType itemType = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case AND:
    case ASCENDING:
    case ATTRIBUTE:
    case BY:
    case CASE:
    case DEFAULT_:
    case DESCENDING:
    case DIVISION:
    case ELEMENT:
    case ELSE:
    case EVERY:
    case EXCEPT:
    case FOR:
    case IN:
    case INTEGER_DIVISION:
    case INTERSECT:
    case IS:
    case ISNOT:
    case LET:
    case MODULO:
    case OR:
    case RETURN:
    case SATISFIES:
    case SOME:
    case SORT:
    case SORTBY:
    case STABLE:
    case TO:
    case UNION:
    case UNORDERED:
    case VALIDATE:
    case VALUE_EQUALS:
    case VALUE_GREATER_THAN:
    case VALUE_GREATER_THAN_EQUALS:
    case VALUE_LESS_THAN:
    case VALUE_LESS_THAN_EQUALS:
    case VALUE_NOT_EQUALS:
    case WHERE:
    case NCName:
    case START_TAG_NCName:
    case END_TAG_NCName:
      qName = QName(true);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case OF_TYPE:
        currentToken = jj_consume_token(OF_TYPE);
                                                //previousToken = currentToken;
                                                // if (debug) System.out.println("SchemaType - Read <OF_TYPE> " + currentToken.image);
                                                kind = Constants.IT_OF_TYPE;
        qNameDependancy = QName(true);
                                                hasQNameDependancy = true;
        break;
      default:
        jj_la1[84] = jj_gen;
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case IN_TYPE:
          itemType = SchemaContext();
                                                hasSchemaContext = true;
          break;
        default:
          jj_la1[83] = jj_gen;
          ;
        }
      }
                                if (hasQNameDependancy)
                                {
                                        try
                                        {
                                                itemType = factory.createItemType(qName, kind, qNameDependancy, typevisitor);
                                        }
                                        catch (TypeException te)
                                        {
                                                {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                                        }
                                }
                                if (hasSchemaContext)
                                {
                                        itemType.setTypeName(qName);
                                }
      break;
    case OF_TYPE:
      currentToken = jj_consume_token(OF_TYPE);
                                //previousToken = currentToken;
                                // if (debug) System.out.println("SchemaType - Read <OF_TYPE> " + currentToken.image);
                                kind = Constants.IT_OF_TYPE;
      qName = QName(true);
                                try
                                {
                                        itemType = factory.createItemType(null, kind, qName, typevisitor);
                                }
                                catch (TypeException te)
                                {
                                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                                }
      break;
    default:
      jj_la1[85] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                {if (true) return itemType;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[67]	SchemaType ::=						<"of" "type"> QName
		Rule included in [66]
***************************************************************************************/

/***************************************************************************************
[68]	AtomicType ::=						QName
***************************************************************************************/
  final public QName AtomicType() throws ParseException, ParseException, Exception {
        QName qName = null;
    qName = QName(true);
                if (restriction) {if (true) throw new ParseException("Encountered \"" + qName + "\" at line " + currentToken.beginLine + ", column " + (currentToken.beginColumn - qName.toString().length()) + ". AtomicType is not supported yet.");}
                {if (true) return qName;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[69]	OccurrenceIndicator ::=				( "*" | "+" | "?" )?
***************************************************************************************/
  final public int OccurrenceIndicator() throws ParseException, ParseException, Exception {
        int kind = -1;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case OCCURRENCE_PLUS:
    case OCCURRENCE_QUESTION_MARK:
    case OCCURRENCE_STAR:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case OCCURRENCE_STAR:
        currentToken = jj_consume_token(OCCURRENCE_STAR);
                                //previousToken = currentToken;
                                // if (debug) System.out.println("OccurrenceIndicator - Read <OCCURRENCE_STAR> " + currentToken.image);
                                kind = Constants.OCCURRENCE_STAR;
        break;
      case OCCURRENCE_PLUS:
        currentToken = jj_consume_token(OCCURRENCE_PLUS);
                                //previousToken = currentToken;
                                // if (debug) System.out.println("OccurrenceIndicator - Read <OCCURRENCE_PLUS> " + currentToken.image);
                                kind = Constants.OCCURRENCE_PLUS;
        break;
      case OCCURRENCE_QUESTION_MARK:
        currentToken = jj_consume_token(OCCURRENCE_QUESTION_MARK);
                                //previousToken = currentToken;
                                // if (debug) System.out.println("OccurrenceIndicator - Read <OCCURRENCE_QUESTION_MARK> " + currentToken.image);
                                kind = Constants.OCCURRENCE_QUESTION_MARK;
        break;
      default:
        jj_la1[86] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      break;
    default:
      jj_la1[87] = jj_gen;
      ;
    }
                {if (true) return kind;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[70]	ElementConstructor ::=				"<" QName AttributeList ( "/>" | ( ">" ElementContent* "</" QName S? ">" ) )
***************************************************************************************/
  final public Element ElementConstructor() throws ParseException, ParseException, Exception {
        QName startTag = null;
        ArrayList attributeList = null;
        ArrayList vectExpressions = null;
        XQueryExpression expression = null;
        QName endTag = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LESS_THAN:
      currentToken = jj_consume_token(LESS_THAN);

      break;
    case ELT_LESS_THAN:
      currentToken = jj_consume_token(ELT_LESS_THAN);

      break;
    default:
      jj_la1[88] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                        // if (debug) System.out.println("*************************** START_TAG");
                        pushState(START_TAG);
                        hashDeclList.pushContext();
    startTag = QName(false);
    attributeList = AttributeList();
                        if (startTag.getPrefixName() == null)
                        {
                                startTag.setNameSpace(defaultNameSpace);
                        }
                        else
                        {
                                String tmpStr = getNameSpace(startTag.getPrefixName());
                                if (tmpStr == null)
                                        {if (true) throw new TypeException("Could not match prefix [ " + startTag.getPrefixName() + " ]" , currentToken.beginLine, currentToken.beginColumn);}
                                startTag.setNameSpace(tmpStr);
                        }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case START_TAG_SLASH_GREATER_THAN:
      currentToken = jj_consume_token(START_TAG_SLASH_GREATER_THAN);
                                //previousToken = currentToken;
                                // if (debug) System.out.println("ElementConstructor - Read <START_TAG_SLASH_GREATER_THAN> " + currentToken.image);				
                                popState();
      break;
    case START_TAG_GREATER_THAN:
      currentToken = jj_consume_token(START_TAG_GREATER_THAN);
                                        //previousToken = currentToken;
                                        // if (debug) System.out.println("ElementConstructor - Read <START_TAG_GREATER_THAN> " + currentToken.image);
                                        // if (debug) System.out.println("*************************** ELEMENT_CONTENT");
                                        switchState(ELEMENT_CONTENT);
      label_20:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case CDATA_START:
        case LESS_THAN:
        case L_BRACE:
        case XMLCOMMENT_START:
        case XMLPROCESSING_START:
        case ELT_L_BRACE:
        case PredefinedEntityRef:
        case CharRef:
        case Char:
        case ELT_LESS_THAN:
        case ELT_XMLCOMMENT_START:
        case ELT_XMLPROCESSING_START:
        case ELT_CDATA_START:
        case ESCAPE_L_BRACE:
        case ESCAPE_R_BRACE:
          ;
          break;
        default:
          jj_la1[89] = jj_gen;
          break label_20;
        }
        expression = ElementContent();
                                                if (expression != null)
                                                {
                                                        if (vectExpressions == null)
                                                        {
                                                                vectExpressions = new ArrayList();
                                                        }
                                                        if (expression instanceof XQueryExpressionSequence && ((XQueryExpressionSequence)expression).getSubExpressions().size() > 1)
                                                        {
                                                                ArrayList subExpressions = ((XQueryExpressionSequence)expression).getSubExpressions();
                                                                XQueryExpression expri = null;
                                                                ArrayList sequence = null;
                                                                for (int i = 0; i < subExpressions.size(); i++)
                                                                {
                                                                        expri = (XQueryExpression)subExpressions.get(i);
/*									if (expri instanceof AttributeValuePair)
									{
										if (attributeList == null) attributeList = new ArrayList(1);
										attributeList.add(expri);
										subExpressions.remove(i);
										i--;
										continue;
									}
*/                                                                      sequence = new ArrayList(1);
                                                                        sequence.add(expri);
                                                                        try
                                                                        {
                                                                                expri = factory.createXQueryExpressionSequence(sequence, typevisitor);
                                                                        }
                                                                        catch (TypeException te)
                                                                        {
                                                                                {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                                                                        }
                                                                        expri.setBrace(true);
                                                                        vectExpressions.add(expri);
                                                                }
                                                                if (subExpressions.isEmpty()) vectExpressions = null;
                                                        }
                                                        else
                                                        {
                                                                vectExpressions.add(expression);
                                                        }
                                                }
      }
      currentToken = jj_consume_token(ELT_LESS_THAN_SLASH);
                                        //previousToken = currentToken;
                                        // if (debug) System.out.println("ElementConstructor - Read <ELT_LESS_THAN_SLASH> " + currentToken.image);
                                        // if (debug) System.out.println("*************************** END_TAG");
                                        switchState(END_TAG);
      endTag = QName(true);
                                        if (!endTag.getName().equals(startTag.getName()))
                                        {
                                                {if (true) throw new ParseException("Error : tag '" + startTag.getName() + "' is ended with '" + endTag.getName() + "'!");}
                                        }
      currentToken = jj_consume_token(END_TAG_GREATER_THAN);
                                        //previousToken = currentToken;
                                        // if (debug) System.out.println("ElementConstructor - Read <END_TAG_GREATER_THAN> " + currentToken.image);
                                        popState();
      break;
    default:
      jj_la1[90] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                try
                {
                        List list = hashDeclList.getDeclaredPrefixes();
                        HashMap localPrefixes = null;
                        for (int i = 0; i < list.size(); i++)
                        {
                                if (i == 0) localPrefixes = new HashMap();
                                String prefix = (String)list.get(i);
                                localPrefixes.put(prefix, hashDeclList.getNamespaceURI(prefix));
                        }
                        hashDeclList.popContext();
                        {if (true) return factory.createElement(startTag, localPrefixes, attributeList, vectExpressions, typevisitor);}
                }
                catch (TypeException te)
                {
                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                }
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[71]	ComputedDocumentConstructor ::=		<"document" "{"> ExprSequence "}"
***************************************************************************************/
  final public XQueryExpression ComputedDocumentConstructor() throws ParseException, ParseException, Exception {
        XQueryExpression expression = null;
    currentToken = jj_consume_token(DOCUMENT_L_BRACE);
                        //previousToken = currentToken;
                        // if (debug) System.out.println("ComputedDocumentConstructor - Read <DOCUMENT_L_BRACE> " + currentToken.image);
                        if (restriction) {if (true) throw new ParseException("Encountered \"" + currentToken.image + "\" at line " + currentToken.beginLine + ", column " + currentToken.beginColumn + ". ComputedDocumentConstructor is not supported yet.");}
    expression = ExprSequence(false);
    currentToken = jj_consume_token(R_BRACE);

                try
                {
                        {if (true) return factory.createDocument(expression, typevisitor);}
                }
                catch (TypeException te)
                {
                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                }
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[72]	ComputedElementConstructor ::=		( <"element" QName "{"> | ( <"element" "{"> Expr "}" "{" ) ) ExprSequence? "}"
***************************************************************************************/
  final public XQueryExpression ComputedElementConstructor() throws ParseException, ParseException, Exception {
        XQueryExpression expression = null;
        XQueryExpression sequence = null;
        ArrayList attributeList = null;
        ArrayList vectExpressions = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ELEMENT:
      currentToken = jj_consume_token(ELEMENT);

      expression = QName(true);
      currentToken = jj_consume_token(L_BRACE);

      break;
    case ELEMENT_L_BRACE:
      currentToken = jj_consume_token(ELEMENT_L_BRACE);

      expression = Expr();
      currentToken = jj_consume_token(R_BRACE);

      currentToken = jj_consume_token(L_BRACE);

      break;
    default:
      jj_la1[91] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                        hashDeclList.pushContext();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case AND:
    case ASCENDING:
    case AT:
    case ATTRIBUTE:
    case ATTRIBUTE_DCOLON:
    case ATTRIBUTE_L_BRACE:
    case BY:
    case CASE:
    case CAST_AS:
    case CDATA_START:
    case CHILD_DCOLON:
    case COMMENT_L_PAREN_R_PAREN:
    case DEFAULT_:
    case DESCENDANT_DCOLON:
    case DESCENDANT_SELF_DCOLON:
    case DESCENDING:
    case DIVISION:
    case DOCUMENT_L_BRACE:
    case DOT:
    case DOTDOT:
    case DecimalLiteral:
    case DoubleLiteral:
    case ELEMENT:
    case ELEMENT_L_BRACE:
    case ELSE:
    case EVERY:
    case EXCEPT:
    case FOR:
    case IF_L_PAREN:
    case IN:
    case INTEGER_DIVISION:
    case INTERSECT:
    case IS:
    case ISNOT:
    case IntegerLiteral:
    case LESS_THAN:
    case LET:
    case L_PAREN:
    case MINUS:
    case MODULO:
    case NODE_L_PAREN_R_PAREN:
    case OR:
    case PARENT_DCOLON:
    case PLUS:
    case PROCESSING_INSTRUCTION_L_PAREN:
    case RETURN:
    case SATISFIES:
    case SELF_DCOLON:
    case SLASH:
    case SLASHSLASH:
    case SOME:
    case SORT:
    case SORTBY:
    case STABLE:
    case STAR:
    case StringLiteral:
    case TEXT_L_PAREN_R_PAREN:
    case TO:
    case TREAT_AS:
    case TYPESWITCH_L_PAREN:
    case UNION:
    case UNORDERED:
    case VALIDATE:
    case VALUE_EQUALS:
    case VALUE_GREATER_THAN:
    case VALUE_GREATER_THAN_EQUALS:
    case VALUE_LESS_THAN:
    case VALUE_LESS_THAN_EQUALS:
    case VALUE_NOT_EQUALS:
    case VARName:
    case WHERE:
    case XMLCOMMENT_START:
    case XMLPROCESSING_START:
    case NCName:
    case START_TAG_NCName:
    case END_TAG_NCName:
    case ELT_LESS_THAN:
    case ELT_XMLCOMMENT_START:
    case ELT_XMLPROCESSING_START:
    case ELT_CDATA_START:
      sequence = ExprSequence(false);
      break;
    default:
      jj_la1[92] = jj_gen;
      ;
    }
    currentToken = jj_consume_token(R_BRACE);

                if (sequence != null)
                {
                        if (sequence instanceof AttributeValuePair)
                        {
                                attributeList = new ArrayList(1);
                                attributeList.add(sequence);
                        }
                        else if (sequence instanceof XQueryExpressionSequence)
                        {
                                vectExpressions = ((XQueryExpressionSequence)sequence).getSubExpressions();
                                XQueryExpression expri = null;
                                for (int i = 0; i < vectExpressions.size(); i++)
                                {
                                        expri = (XQueryExpression)vectExpressions.get(i);
                                        if (expri instanceof AttributeValuePair)
                                        {
                                                if (attributeList == null) attributeList = new ArrayList(1);
                                                attributeList.add(expri);
                                                vectExpressions.remove(i);
                                                i--;
                                        }
                                }
                                if (vectExpressions.isEmpty()) vectExpressions = null;
                        }
                        else
                        {
                                vectExpressions = new ArrayList(1);
                                vectExpressions.add(sequence);
                        }
                }
                try
                {
                        List list = hashDeclList.getDeclaredPrefixes();
                        HashMap localPrefixes = null;
                        for (int i = 0; i < list.size(); i++)
                        {
                                if (i == 0) localPrefixes = new HashMap();
                                String prefix = (String)list.get(i);
                                localPrefixes.put(prefix, hashDeclList.getNamespaceURI(prefix));
                        }
                        hashDeclList.popContext();
                        Element element = factory.createElement(expression, localPrefixes, attributeList, vectExpressions, typevisitor);
                        element.setIsComputed(true);
                        {if (true) return element;}
                }
                catch (TypeException te)
                {
                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                }
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[73]	ComputedAttributeConstructor ::=	( <"attribute" QName "{"> | ( <"attribute" "{"> Expr "}" "{" ) ) ExprSequence? "}"
***************************************************************************************/
  final public XQueryExpression ComputedAttributeConstructor() throws ParseException, ParseException, Exception {
        XQueryExpression attributeName = null;
        XQueryExpression attributeValue = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ATTRIBUTE:
      currentToken = jj_consume_token(ATTRIBUTE);

      attributeName = QName(true);
                                        String prefix = ((QName)attributeName).getPrefixName();
                                        if ((prefix != null && prefix.equals("xmlns")) || (prefix == null && ((QName)attributeName).getLocalName().equals("xmlns")))
                                        {
                                                {if (true) throw new ParseException("An attribute generated by an attribute constructor may not be a namespace declaration attribute.");}
                                        }
      currentToken = jj_consume_token(L_BRACE);

      break;
    case ATTRIBUTE_L_BRACE:
      currentToken = jj_consume_token(ATTRIBUTE_L_BRACE);

      attributeName = Expr();
      currentToken = jj_consume_token(R_BRACE);

      currentToken = jj_consume_token(L_BRACE);

      break;
    default:
      jj_la1[93] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case AND:
    case ASCENDING:
    case AT:
    case ATTRIBUTE:
    case ATTRIBUTE_DCOLON:
    case ATTRIBUTE_L_BRACE:
    case BY:
    case CASE:
    case CAST_AS:
    case CDATA_START:
    case CHILD_DCOLON:
    case COMMENT_L_PAREN_R_PAREN:
    case DEFAULT_:
    case DESCENDANT_DCOLON:
    case DESCENDANT_SELF_DCOLON:
    case DESCENDING:
    case DIVISION:
    case DOCUMENT_L_BRACE:
    case DOT:
    case DOTDOT:
    case DecimalLiteral:
    case DoubleLiteral:
    case ELEMENT:
    case ELEMENT_L_BRACE:
    case ELSE:
    case EVERY:
    case EXCEPT:
    case FOR:
    case IF_L_PAREN:
    case IN:
    case INTEGER_DIVISION:
    case INTERSECT:
    case IS:
    case ISNOT:
    case IntegerLiteral:
    case LESS_THAN:
    case LET:
    case L_PAREN:
    case MINUS:
    case MODULO:
    case NODE_L_PAREN_R_PAREN:
    case OR:
    case PARENT_DCOLON:
    case PLUS:
    case PROCESSING_INSTRUCTION_L_PAREN:
    case RETURN:
    case SATISFIES:
    case SELF_DCOLON:
    case SLASH:
    case SLASHSLASH:
    case SOME:
    case SORT:
    case SORTBY:
    case STABLE:
    case STAR:
    case StringLiteral:
    case TEXT_L_PAREN_R_PAREN:
    case TO:
    case TREAT_AS:
    case TYPESWITCH_L_PAREN:
    case UNION:
    case UNORDERED:
    case VALIDATE:
    case VALUE_EQUALS:
    case VALUE_GREATER_THAN:
    case VALUE_GREATER_THAN_EQUALS:
    case VALUE_LESS_THAN:
    case VALUE_LESS_THAN_EQUALS:
    case VALUE_NOT_EQUALS:
    case VARName:
    case WHERE:
    case XMLCOMMENT_START:
    case XMLPROCESSING_START:
    case NCName:
    case START_TAG_NCName:
    case END_TAG_NCName:
    case ELT_LESS_THAN:
    case ELT_XMLCOMMENT_START:
    case ELT_XMLPROCESSING_START:
    case ELT_CDATA_START:
      attributeValue = ExprSequence(false);
      break;
    default:
      jj_la1[94] = jj_gen;
      ;
    }
    currentToken = jj_consume_token(R_BRACE);

                if (attributeValue == null)
                {
                        try
                        {
                                attributeValue = factory.createValueString("", typevisitor);
                        }
                        catch (TypeException te)
                        {
                                {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                        }
                }
                try
                {
                        AttributeValuePair attributeValuePair = factory.createAttributeValuePair(attributeName, attributeValue, typevisitor);
                        attributeValuePair.setIsComputed(true);
                        {if (true) return attributeValuePair;}
                }
                catch (TypeException te)
                {
                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                }
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[74]	CdataSection ::=					"<![CDATA[" Char* "]]>"
***************************************************************************************/
  final public CData CdataSection() throws ParseException, ParseException, Exception {
        StringBuffer buf = new StringBuffer();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case CDATA_START:
      currentToken = jj_consume_token(CDATA_START);
                                //previousToken = currentToken;
                                // if (debug) System.out.println("CdataSection - Read <CDATA_START> " + currentToken.image);
                                // if (debug) System.out.println("*************************** C_DATA_SECTION");
                                pushState(C_DATA_SECTION);
      break;
    case ELT_CDATA_START:
      currentToken = jj_consume_token(ELT_CDATA_START);
                                //previousToken = currentToken;
                                // if (debug) System.out.println("CdataSection - Read <ELT_CDATA_START> " + currentToken.image);
                                // if (debug) System.out.println("*************************** C_DATA_SECTION");
                                pushState(C_DATA_SECTION);
      break;
    default:
      jj_la1[95] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    label_21:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case CDataChar:
        ;
        break;
      default:
        jj_la1[96] = jj_gen;
        break label_21;
      }
      currentToken = jj_consume_token(CDataChar);
                                //previousToken = currentToken;
                                // if (debug) System.out.println("CdataSection - Read <CDataChar> " + currentToken.image);
                                buf.append(currentToken.image);
    }
    currentToken = jj_consume_token(CDATA_STOP);
                        //previousToken = currentToken;
                        // if (debug) System.out.println("CdataSection - Read <CDATA_STOP> " + currentToken.image);
                        popState();
                try
                {
                        {if (true) return factory.createCData(buf.toString(), typevisitor);}
                }
                catch (TypeException te)
                {
                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                }
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[75]	XmlProcessingInstruction ::=		"<?" PITarget Char* "?>"
***************************************************************************************/
  final public XMLProcessingInstruction XmlProcessingInstruction() throws ParseException, ParseException, Exception {
        StringBuffer buf = new StringBuffer();
        String PITarget = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case XMLPROCESSING_START:
      currentToken = jj_consume_token(XMLPROCESSING_START);
                                //previousToken = currentToken;
                                // if (debug) System.out.println("XmlProcessingInstruction - Read <XMLPROCESSING_START> " + currentToken.image);
                                // if (debug) System.out.println("*************************** PROCESSING_INSTRUCTION");
                                pushState(PROCESSING_INSTRUCTION);
      break;
    case ELT_XMLPROCESSING_START:
      currentToken = jj_consume_token(ELT_XMLPROCESSING_START);
                                //previousToken = currentToken;
                                // if (debug) System.out.println("XmlProcessingInstruction - Read <ELT_XMLPROCESSING_START> " + currentToken.image);
                                // if (debug) System.out.println("*************************** PROCESSING_INSTRUCTION");
                                pushState(PROCESSING_INSTRUCTION);
      break;
    default:
      jj_la1[97] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    PITarget = NCName();
    label_22:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ProcessingChar:
        ;
        break;
      default:
        jj_la1[98] = jj_gen;
        break label_22;
      }
      currentToken = jj_consume_token(ProcessingChar);
                                //previousToken = currentToken;
                                // if (debug) System.out.println("XmlProcessingInstruction - Read <ProcessingChar> " + currentToken.image);
                                buf.append(currentToken.image);
    }
    currentToken = jj_consume_token(XMLPROCESSING_STOP);
                        //previousToken = currentToken;
                        // if (debug) System.out.println("XmlProcessingInstruction - Read <XMLPROCESSING_STOP> " + currentToken.image);
                        popState();
                try
                {
                        {if (true) return factory.createXMLProcessingInstruction(PITarget, buf.toString(), typevisitor);}
                }
                catch (TypeException te)
                {
                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                }
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[76]	XmlComment ::=						"<!--" Char* "-->"
***************************************************************************************/
  final public XMLComment XmlComment() throws ParseException, ParseException, Exception {
        StringBuffer buf = new StringBuffer();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case XMLCOMMENT_START:
      currentToken = jj_consume_token(XMLCOMMENT_START);
                                //previousToken = currentToken;
                                // if (debug) System.out.println("XmlComment - Read <XMLCOMMENT_START> " + currentToken.image);
                                // if (debug) System.out.println("*************************** XML_COMMENT");
                                pushState(XML_COMMENT);
      break;
    case ELT_XMLCOMMENT_START:
      currentToken = jj_consume_token(ELT_XMLCOMMENT_START);
                                //previousToken = currentToken;
                                // if (debug) System.out.println("XmlComment - Read <ELT_XMLCOMMENT_START> " + currentToken.image);
                                // if (debug) System.out.println("*************************** XML_COMMENT");
                                pushState(XML_COMMENT);
      break;
    default:
      jj_la1[99] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    label_23:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case XMLCommentChar:
        ;
        break;
      default:
        jj_la1[100] = jj_gen;
        break label_23;
      }
      currentToken = jj_consume_token(XMLCommentChar);
                                //previousToken = currentToken;
                                // if (debug) System.out.println("XmlComment - Read <XMLCommentChar> " + currentToken.image);
                                buf.append(currentToken.image);
    }
    currentToken = jj_consume_token(ELT_XMLCOMMENT_STOP);
                        //previousToken = currentToken;
                        // if (debug) System.out.println("XmlComment - Read <ELT_XMLCOMMENT_STOP> " + currentToken.image);
                        popState();
                try
                {
                        {if (true) return factory.createXMLComment(buf.toString(), typevisitor);}
                }
                catch (TypeException te)
                {
                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                }
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[77]	ElementContent ::=					( Char | "{{" | "}}" | CharRef | PredefinedEntityRef )+ | ElementConstructor | EnclosedExpr | CdataSection | XmlComment | XmlProcessingInstruction
		W3C WD 16 August 2002 ->			Char | "{{" | "}}" | ElementConstructor | EnclosedExpr | CdataSection | CharRef | PredefinedEntityRef | XmlComment | XmlProcessingInstruction
***************************************************************************************/
  final public XQueryExpression ElementContent() throws ParseException, ParseException, Exception {
        StringBuffer buf = new StringBuffer();
        String str = null;
        XQueryExpression expression = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case PredefinedEntityRef:
    case CharRef:
    case Char:
    case ESCAPE_L_BRACE:
    case ESCAPE_R_BRACE:
      label_24:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case Char:
          currentToken = jj_consume_token(Char);
                                        //previousToken = currentToken;
                                        // if (debug) System.out.println("ElementContent - Read <Char> " + currentToken.image);
                                        if (currentToken.image.charAt(0) != '\r') buf.append(currentToken.image);
          break;
        case ESCAPE_L_BRACE:
          currentToken = jj_consume_token(ESCAPE_L_BRACE);
                                        //previousToken = currentToken;
                                        // if (debug) System.out.println("ElementContent - Read <ESCAPE_L_BRACE> " + currentToken.image);
                                        buf.append("{");
          break;
        case ESCAPE_R_BRACE:
          currentToken = jj_consume_token(ESCAPE_R_BRACE);
                                        //previousToken = currentToken;
                                        // if (debug) System.out.println("ElementContent - Read <ESCAPE_R_BRACE> " + currentToken.image);
                                        buf.append("}");
          break;
        case CharRef:
          currentToken = jj_consume_token(CharRef);
                                        //previousToken = currentToken;
                                        // if (debug) System.out.println("ElementContent - Read <CharRef> " + currentToken.image);
                                        buf.append(parseCharRef(currentToken.image));
          break;
        case PredefinedEntityRef:
          currentToken = jj_consume_token(PredefinedEntityRef);
                                        //previousToken = currentToken;
                                        // if (debug) System.out.println("ElementContent - Read <PredefinedEntityRef> " + currentToken.image);
                                        buf.append(parsePredefinedEntityRef(currentToken.image));
          break;
        default:
          jj_la1[101] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
        if (jj_2_12(2)) {
          ;
        } else {
          break label_24;
        }
      }
                        try
                        {
                                if (xmlspace) str = buf.toString().trim();
                                else str = buf.toString();
                                if (str.length() == 0) expression = null;
                                else expression = factory.createValueText(str, typevisitor);
                        }
                        catch (TypeException te)
                        {
                                {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                        }
      break;
    case LESS_THAN:
    case ELT_LESS_THAN:
      expression = ElementConstructor();
      break;
    case L_BRACE:
    case ELT_L_BRACE:
      expression = EnclosedExpr(false);
      break;
    case CDATA_START:
    case ELT_CDATA_START:
      expression = CdataSection();
      break;
    case XMLCOMMENT_START:
    case ELT_XMLCOMMENT_START:
      expression = XmlComment();
      break;
    case XMLPROCESSING_START:
    case ELT_XMLPROCESSING_START:
      expression = XmlProcessingInstruction();
      break;
    default:
      jj_la1[102] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                {if (true) return expression;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[78]	AttributeList ::=					( S ( QName S? "=" S? AttributeValue )? )*
***************************************************************************************/
  final public ArrayList AttributeList() throws ParseException, ParseException, Exception {
        QName attributeName = null;
        AttributeValuePair attributeValuePair = null;
        XQueryExpression attributeValue = null;
        ArrayList attributeList = null;
    label_25:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case AND:
      case ASCENDING:
      case ATTRIBUTE:
      case BY:
      case CASE:
      case DEFAULT_:
      case DESCENDING:
      case DIVISION:
      case ELEMENT:
      case ELSE:
      case EVERY:
      case EXCEPT:
      case FOR:
      case IN:
      case INTEGER_DIVISION:
      case INTERSECT:
      case IS:
      case ISNOT:
      case LET:
      case MODULO:
      case OR:
      case RETURN:
      case SATISFIES:
      case SOME:
      case SORT:
      case SORTBY:
      case STABLE:
      case TO:
      case UNION:
      case UNORDERED:
      case VALIDATE:
      case VALUE_EQUALS:
      case VALUE_GREATER_THAN:
      case VALUE_GREATER_THAN_EQUALS:
      case VALUE_LESS_THAN:
      case VALUE_LESS_THAN_EQUALS:
      case VALUE_NOT_EQUALS:
      case WHERE:
      case NCName:
      case START_TAG_NCName:
      case END_TAG_NCName:
        ;
        break;
      default:
        jj_la1[103] = jj_gen;
        break label_25;
      }
      attributeName = QName(true);
      currentToken = jj_consume_token(START_TAG_EQUALS);

      attributeValue = AttributeValue();
                        try
                        {
                                if (attributeName.getNameSpace() == null && attributeName.getPrefixName() != null && attributeName.getPrefixName().equals("xmlns"))
                                {
                                        hashDeclList.declarePrefix(attributeName.getLocalName(), ((ValueString)attributeValue).getStringValue());
                                }
                                else if (attributeName.getNameSpace() == null && attributeName.getPrefixName() == null && attributeName.getLocalName() != null && attributeName.getLocalName().equals("xmlns"))
                                {
                                        hashDeclList.declarePrefix("", ((ValueString)attributeValue).getStringValue());
                                }
                                else
                                {
                                        attributeValuePair = factory.createAttributeValuePair(attributeName, attributeValue, typevisitor);
                                        if (attributeList == null)
                                        {
                                                attributeList = new ArrayList(1);
                                        }
                                        attributeList.add(attributeValuePair);
                                }
                        }
                        catch (TypeException te)
                        {
                                {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                        }
    }
                {if (true) return attributeList;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[79]	AttributeValue ::=					( '"' ( AttributeValueContent )* '"' ) | ( "'" ( AttributeValueContent )* "'" )
		EscapeQuot/EscapeApos is include in AttributeValueContent
		W3C WD 16 August 2002 ->			( '"' ( EscapeQuot | AttributeValueContent )* '"' ) | ( "'" ( EscapeApos | AttributeValueContent )* "'" )
***************************************************************************************/
  final public XQueryExpression AttributeValue() throws ParseException, ParseException, Exception {
        XQueryExpression expression = null;
        ArrayList valueList = new ArrayList(1);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case START_TAG_ATTRIBUTE_QUOT:
      currentToken = jj_consume_token(START_TAG_ATTRIBUTE_QUOT);
                                //previousToken = currentToken;
                                // if (debug) System.out.println("AttributeValue - Read <START_ATTRIBUTE_QUOT> " + currentToken.image);
                                // if (debug) System.out.println("*************************** QUOT_ATTRIBUTE_CONTENT");
                                switchState(QUOT_ATTRIBUTE_CONTENT);
      label_26:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case L_BRACE_APOS:
        case ESCAPE_L_BRACE_APOS:
        case ESCAPE_R_BRACE_APOS:
        case Char_APOS:
        case EntityRef_APOS:
        case CharRef_APOS:
        case ESCAPE_APOS:
        case L_BRACE_QUOT:
        case ESCAPE_L_BRACE_QUOT:
        case ESCAPE_R_BRACE_QUOT:
        case Char_QUOT:
        case EntityRef_QUOT:
        case CharRef_QUOT:
        case ESCAPE_QUOT:
          ;
          break;
        default:
          jj_la1[104] = jj_gen;
          break label_26;
        }
        expression = AttributeValueContent();
                                        valueList.add(expression);
      }
      currentToken = jj_consume_token(STOP_ATTRIBUTE_QUOT);
                                //previousToken = currentToken;
                                // if (debug) System.out.println("AttributeValue - Read <STOP_ATTRIBUTE_QUOT> " + currentToken.image);
                                // if (debug) System.out.println("*************************** START_TAG");
                                switchState(START_TAG);
      break;
    case START_TAG_ATTRIBUTE_APOS:
      currentToken = jj_consume_token(START_TAG_ATTRIBUTE_APOS);
                                //previousToken = currentToken;
                                // if (debug) System.out.println("AttributeValue - Read <START_ATTRIBUTE_APOS> " + currentToken.image);
                                // if (debug) System.out.println("*************************** APOS_ATTRIBUTE_CONTENT");
                                switchState(APOS_ATTRIBUTE_CONTENT);
      label_27:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case L_BRACE_APOS:
        case ESCAPE_L_BRACE_APOS:
        case ESCAPE_R_BRACE_APOS:
        case Char_APOS:
        case EntityRef_APOS:
        case CharRef_APOS:
        case ESCAPE_APOS:
        case L_BRACE_QUOT:
        case ESCAPE_L_BRACE_QUOT:
        case ESCAPE_R_BRACE_QUOT:
        case Char_QUOT:
        case EntityRef_QUOT:
        case CharRef_QUOT:
        case ESCAPE_QUOT:
          ;
          break;
        default:
          jj_la1[105] = jj_gen;
          break label_27;
        }
        expression = AttributeValueContent();
                                        valueList.add(expression);
      }
      currentToken = jj_consume_token(STOP_ATTRIBUTE_APOS);
                                //previousToken = currentToken;
                                // if (debug) System.out.println("AttributeValue - Read <STOP_ATTRIBUTE_APOS> " + currentToken.image);
                                // if (debug) System.out.println("*************************** START_TAG");
                                switchState(START_TAG);
      break;
    default:
      jj_la1[106] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                if (valueList.isEmpty())
                {
                        try
                        {
                                {if (true) return factory.createValueString("", typevisitor);}
                        }
                        catch (TypeException te)
                        {
                                {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                        }
                }
                else if (valueList.size() == 1)
                {
                        {if (true) return expression;}
                }
                else
                {
                        try
                        {
                                {if (true) return new FunctionCONCAT(valueList, typevisitor);}
                        }
                        catch (TypeException te)
                        {
                                {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                        }
                }
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[80]	AttributeValueContent ::=			( EscapeChar | Char | CharRef | "{{" | "}}" | PredefinedEntityRef )+ | EnclosedExpr
		EscapeChar is EscapeQuot or EscapeApos depend on the State
		W3C WD 16 August 2002 ->			Char | CharRef | "{{" | "}}" | EnclosedExpr | PredefinedEntityRef
***************************************************************************************/
  final public XQueryExpression AttributeValueContent() throws ParseException, ParseException, Exception {
        StringBuffer buf = new StringBuffer();
        XQueryExpression expression = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ESCAPE_L_BRACE_APOS:
    case ESCAPE_R_BRACE_APOS:
    case Char_APOS:
    case EntityRef_APOS:
    case CharRef_APOS:
    case ESCAPE_APOS:
      label_28:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ESCAPE_APOS:
          currentToken = jj_consume_token(ESCAPE_APOS);
                                        //previousToken = currentToken;
                                        // if (debug) System.out.println("AttributeValueContent - Read <ESCAPE_APOS> " + currentToken.image);
                                        buf.append("'");
          break;
        case Char_APOS:
          currentToken = jj_consume_token(Char_APOS);
                                        //previousToken = currentToken;
                                        // if (debug) System.out.println("AttributeValueContent - Read <Char_APOS> " + currentToken.image);
                                        buf.append(currentToken.image);
          break;
        case CharRef_APOS:
          currentToken = jj_consume_token(CharRef_APOS);
                                        //previousToken = currentToken;
                                        // if (debug) System.out.println("AttributeValueContent - Read <CharRef_APOS> " + currentToken.image);
                                        buf.append(parseCharRef(currentToken.image));
          break;
        case ESCAPE_L_BRACE_APOS:
          currentToken = jj_consume_token(ESCAPE_L_BRACE_APOS);
                                        //previousToken = currentToken;
                                        // if (debug) System.out.println("AttributeValueContent - Read <ESCAPE_L_BRACE_APOS> " + currentToken.image);
                                        buf.append("{");
          break;
        case ESCAPE_R_BRACE_APOS:
          currentToken = jj_consume_token(ESCAPE_R_BRACE_APOS);
                                        //previousToken = currentToken;
                                        // if (debug) System.out.println("AttributeValueContent - Read <ESCAPE_R_BRACE_APOS> " + currentToken.image);
                                        buf.append("}");
          break;
        case EntityRef_APOS:
          currentToken = jj_consume_token(EntityRef_APOS);
                                        //previousToken = currentToken;
                                        // if (debug) System.out.println("AttributeValueContent - Read <EntityRef_APOS> " + currentToken.image);
                                        buf.append(parsePredefinedEntityRef(currentToken.image));
          break;
        default:
          jj_la1[107] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
        if (jj_2_13(2)) {
          ;
        } else {
          break label_28;
        }
      }
                        // if (debug) System.out.println("*************************** APOS_ATTRIBUTE_CONTENT");
                        try
                        {
                                expression = factory.createValueString(buf.toString(), typevisitor);
                        }
                        catch (TypeException te)
                        {
                                {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                        }
      break;
    case L_BRACE_APOS:
      currentToken = jj_consume_token(L_BRACE_APOS);
                                //previousToken = currentToken;
                                // if (debug) System.out.println("AttributeValueContent - Read <L_BRACE_APOS> " + currentToken.image);
                                // if (debug) System.out.println("*************************** DEFAULT");
                                pushState(DEFAULT);
      expression = ExprSequence(true);
                                expression.setBrace(true);
      currentToken = jj_consume_token(R_BRACE);
                                //previousToken = currentToken;
                                // if (debug) System.out.println("AttributeValueContent - Read <R_BRACE> " + currentToken.image);
                                // if (debug) System.out.println("*************************** APOS_ATTRIBUTE_CONTENT");
                                popState();
      break;
    case ESCAPE_L_BRACE_QUOT:
    case ESCAPE_R_BRACE_QUOT:
    case Char_QUOT:
    case EntityRef_QUOT:
    case CharRef_QUOT:
    case ESCAPE_QUOT:
      label_29:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ESCAPE_QUOT:
          currentToken = jj_consume_token(ESCAPE_QUOT);
                                        //previousToken = currentToken;
                                        // if (debug) System.out.println("AttributeValueContent - Read <ESCAPE_QUOT> " + currentToken.image);
                                        buf.append("\"");
          break;
        case Char_QUOT:
          currentToken = jj_consume_token(Char_QUOT);
                                        //previousToken = currentToken;
                                        // if (debug) System.out.println("AttributeValueContent - Read <Char_QUOT> " + currentToken.image);
                                        buf.append(currentToken.image);
          break;
        case CharRef_QUOT:
          currentToken = jj_consume_token(CharRef_QUOT);
                                        //previousToken = currentToken;
                                        // if (debug) System.out.println("AttributeValueContent - Read <CharRef_QUOT> " + currentToken.image);
                                        buf.append(parseCharRef(currentToken.image));
          break;
        case ESCAPE_L_BRACE_QUOT:
          currentToken = jj_consume_token(ESCAPE_L_BRACE_QUOT);
                                        //previousToken = currentToken;
                                        // if (debug) System.out.println("AttributeValueContent - Read <ESCAPE_L_BRACE_QUOT> " + currentToken.image);
                                        buf.append("{");
          break;
        case ESCAPE_R_BRACE_QUOT:
          currentToken = jj_consume_token(ESCAPE_R_BRACE_QUOT);
                                        //previousToken = currentToken;
                                        // if (debug) System.out.println("AttributeValueContent - Read <ESCAPE_R_BRACE_QUOT> " + currentToken.image);
                                        buf.append("}");
          break;
        case EntityRef_QUOT:
          currentToken = jj_consume_token(EntityRef_QUOT);
                                        //previousToken = currentToken;
                                        // if (debug) System.out.println("AttributeValueContent - Read <EntityRef_QUOT> " + currentToken.image);
                                        buf.append(parsePredefinedEntityRef(currentToken.image));
          break;
        default:
          jj_la1[108] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
        if (jj_2_14(2)) {
          ;
        } else {
          break label_29;
        }
      }
                        // if (debug) System.out.println("*************************** QUOT_ATTRIBUTE_CONTENT");
                        try
                        {
                                expression = factory.createValueString(buf.toString(), typevisitor);
                        }
                        catch (TypeException te)
                        {
                                {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                        }
      break;
    case L_BRACE_QUOT:
      currentToken = jj_consume_token(L_BRACE_QUOT);
                                //previousToken = currentToken;
                                // if (debug) System.out.println("AttributeValueContent - Read <L_BRACE_QUOT> " + currentToken.image);
                                // if (debug) System.out.println("*************************** DEFAULT");
                                pushState(DEFAULT);
      expression = ExprSequence(true);
                                expression.setBrace(true);
      currentToken = jj_consume_token(R_BRACE);
                                //previousToken = currentToken;
                                // if (debug) System.out.println("AttributeValueContent - Read <R_BRACE> " + currentToken.image);
                                // if (debug) System.out.println("*************************** QUOT_ATTRIBUTE_CONTENT");
                                popState();
      break;
    default:
      jj_la1[109] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                {if (true) return expression;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[81]	EnclosedExpr ::=					"{" ExprSequence "}"
***************************************************************************************/
//XQueryExpressionSequence EnclosedExpr() throws ParseException, Exception :
// change LARS 10/08/2003
  final public XQueryExpression EnclosedExpr(boolean forceSequence) throws ParseException, ParseException, Exception {
        XQueryExpression expression = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case L_BRACE:
      currentToken = jj_consume_token(L_BRACE);

      break;
    case ELT_L_BRACE:
      currentToken = jj_consume_token(ELT_L_BRACE);

      break;
    default:
      jj_la1[110] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                        pushState(DEFAULT);
    expression = ExprSequence(false);
    currentToken = jj_consume_token(R_BRACE);
                        //previousToken = currentToken;
                        // if (debug) System.out.println("EnclosedExpr - Read <R_BRACE> " + currentToken.image);
                        popState();
                if (forceSequence && !(expression instanceof XQueryExpressionSequence))
                {
                        ArrayList sequence = new ArrayList(1);
                        sequence.add(expression);
                        try
                        {
                                expression = factory.createXQueryExpressionSequence(sequence, typevisitor);
                        }
                        catch (TypeException te)
                        {
                                {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                        }
                        expression.setBrace(true);
                }
                {if (true) return expression;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[82]	XMLSpaceDecl ::=					<"declare" "xmlspace"> "=" ( "preserve" | "strip" )
***************************************************************************************/
  final public void XMLSpaceDecl() throws ParseException, ParseException, Exception {
    currentToken = jj_consume_token(DECLARE_XMLSPACE_EQUALS);
                        //previousToken = currentToken;
                        // if (debug) System.out.println("XMLSpaceDecl - Read <DECLARE_XMLSPACE_EQUALS> " + currentToken.image);
                        // if (debug) System.out.println("*************************** XMLSPACE_DECL");
                        switchState(XMLSPACE_DECL);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case PRESERVE:
      currentToken = jj_consume_token(PRESERVE);
                                //previousToken = currentToken;
                                // if (debug) System.out.println("XMLSpaceDecl - Read <PRESERVE> " + currentToken.image);
                                xmlspace = false;
      break;
    case STRIP:
      currentToken = jj_consume_token(STRIP);

      break;
    default:
      jj_la1[111] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                        // if (debug) System.out.println("*************************** DEFAULT");
                        switchState(DEFAULT);
  }

/***************************************************************************************
[83]	DefaultCollationDecl ::=			<"default" "collation" "="> URLLiteral
***************************************************************************************/
  final public void DefaultCollationDecl() throws ParseException, ParseException, Exception {
    currentToken = jj_consume_token(DEFAULT_COLLATION_EQUALS);
                        //previousToken = currentToken;
                        // if (debug) System.out.println("DefaultCollationDecl - Read <DEFAULT_COLLATION_EQUALS> " + currentToken.image);
                        // if (debug) System.out.println("*************************** NAMESPACEDECL");
                        if (restriction) {if (true) throw new ParseException("Encountered \"" + currentToken.image + "\" at line " + currentToken.beginLine + ", column " + currentToken.beginColumn + ". DefaultCollationDecl is not supported yet.");}
                        switchState(NAMESPACEDECL);
    currentToken = jj_consume_token(URLLiteral);
                        //previousToken = currentToken;
                        // if (debug) System.out.println("DefaultCollationDecl - Read <URLLiteral> " + currentToken.image);
                        defaultCollation = currentToken.image;
                        // if (debug) System.out.println("*************************** DEFAULT");
                        switchState(DEFAULT);
  }

/***************************************************************************************
[84]	NamespaceDecl ::=					<"declare" "namespace"> NCNameForPrefix "=" URLLiteral
***************************************************************************************/
  final public void NamespaceDecl() throws ParseException, ParseException, Exception {
        String prefix = null;
        String uri = null;
    currentToken = jj_consume_token(DECLARE_NAMESPACE);
                        //previousToken = currentToken;
                        // if (debug) System.out.println("NamespaceDecl - Read <DECLARE_NAMESPACE> " + currentToken.image);
                        // if (debug) System.out.println("*************************** NAMESPACEDECL");
                        switchState(NAMESPACEDECL);
    currentToken = jj_consume_token(NCNameForPrefix);
                        //previousToken = currentToken;
                        // if (debug) System.out.println("NamespaceDecl - Read <NCNameForPrefix> " + currentToken.image);
                        prefix = currentToken.image;
                        // if (debug) System.out.println("*************************** DEFAULT");
                        token_source.SwitchTo(DEFAULT);
    currentToken = jj_consume_token(EQUALS);
                        //previousToken = currentToken;
                        // if (debug) System.out.println("NamespaceDecl - Read <EQUALS> " + currentToken.image);
                        // if (debug) System.out.println("*************************** NAMESPACEDECL");
                        token_source.SwitchTo(NAMESPACEDECL);
    currentToken = jj_consume_token(URLLiteral);
                        //previousToken = currentToken;
                        // if (debug) System.out.println("NamespaceDecl - Read <URLLiteral> " + currentToken.image);
                        uri = unquote(currentToken.image);
                        // if (debug) System.out.println("*************************** DEFAULT");
                        switchState(DEFAULT);
                hashDeclList.declarePrefix(prefix, uri);
  }

/***************************************************************************************
[85]	SubNamespaceDecl ::=				"namespace" NCNameForPrefix "=" URLLiteral
***************************************************************************************/
  final public String SubNamespaceDecl() throws ParseException, ParseException, Exception {
        String prefix = null;
        String uri = null;
    currentToken = jj_consume_token(NAMESPACE_DT);
                        //previousToken = currentToken;
                        // if (debug) System.out.println("SubNamespaceDecl - Read <NAMESPACE_DT> " + currentToken.image);
                        // if (debug) System.out.println("*************************** NAMESPACEDECL");
                        switchState(NAMESPACEDECL);
    currentToken = jj_consume_token(NCNameForPrefix);
                        //previousToken = currentToken;
                        // if (debug) System.out.println("SubNamespaceDecl - Read <NCNameForPrefix> " + currentToken.image);
                        prefix = currentToken.image;
                        // if (debug) System.out.println("*************************** DEFAULT");
                        token_source.SwitchTo(DEFAULT);
    currentToken = jj_consume_token(EQUALS);
                        //previousToken = currentToken;
                        // if (debug) System.out.println("SubNamespaceDecl - Read <EQUALS> " + currentToken.image);
                        // if (debug) System.out.println("*************************** NAMESPACEDECL");
                        token_source.SwitchTo(NAMESPACEDECL);
    currentToken = jj_consume_token(URLLiteral);
                        //previousToken = currentToken;
                        // if (debug) System.out.println("SubNamespaceDecl - Read <URLLiteral> " + currentToken.image);
                        uri = unquote(currentToken.image);
                        // if (debug) System.out.println("*************************** DEFAULT");
                        switchState(DEFAULT);
                hashDeclList.declarePrefix(prefix, uri);
                {if (true) return uri;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[86]	DefaultNamespaceDecl ::=			( <"default" "element"> | <"default" "function"> ) "namespace" "=" URLLiteral
***************************************************************************************/
  final public String DefaultNamespaceDecl() throws ParseException, ParseException, Exception {
        String uri = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case DEFAULT_ELEMENT_NAMESPACE_EQUALS:
      currentToken = jj_consume_token(DEFAULT_ELEMENT_NAMESPACE_EQUALS);

      break;
    case DEFAULT_FUNCTION_NAMESPACE_EQUALS:
      currentToken = jj_consume_token(DEFAULT_FUNCTION_NAMESPACE_EQUALS);
                                //previousToken = currentToken;
                                // if (debug) System.out.println("DefaultNamespaceDecl - Read <DEFAULT_FUNCTION_NAMESPACE_EQUALS> " + currentToken.image);
                                if (restriction) {if (true) throw new ParseException("Encountered \"" + currentToken.image + "\" at line " + currentToken.beginLine + ", column " + currentToken.beginColumn + ". \"default function namespace\" is not supported yet.");}
      break;
    default:
      jj_la1[112] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                        // if (debug) System.out.println("*************************** NAMESPACEDECL");
                        switchState(NAMESPACEDECL);
    currentToken = jj_consume_token(URLLiteral);
                        //previousToken = currentToken;
                        // if (debug) System.out.println("DefaultNamespaceDecl - Read <URLLiteral> " + currentToken.image);
                        uri = unquote(currentToken.image);
                        // if (debug) System.out.println("*************************** DEFAULT");
                        switchState(DEFAULT);
                if (defaultNameSpace != null)
                {
                        {if (true) throw new TypeException("Default namespace defined more than once", currentToken.beginLine, currentToken.beginColumn);}
                }
                defaultNameSpace = uri;
                hashDeclList.declarePrefix("", uri);
                {if (true) return uri;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[87]	FunctionDefn ::=					<"define" "function"> QName "(" ParamList? ( ")" | ( <")" "returns"> SequenceType ) ) EnclosedExpr
		W3C WD 16 August 2002 ->			<"define" "function"> FuncName "(" ParamList? ( ")" | ( <")" "returns"> SequenceType ) ) EnclosedExpr
***************************************************************************************/
  final public FunctionDefinition FunctionDefn() throws ParseException, ParseException, Exception {
        QName funcName = null;
        ArrayList paramList = null;
        SequenceTypeExpression sequenceType = null;
        XQueryExpression enclosedExpr = null;
    currentToken = jj_consume_token(DEFINE_FUNCTION);
                        //previousToken = currentToken;
                        // if (debug) System.out.println("FunctionDefn - Read <DEFINE_FUNCTION> " + currentToken.image);
                        if (restriction) {if (true) throw new ParseException("Encountered \"" + currentToken.image + "\" at line " + currentToken.beginLine + ", column " + currentToken.beginColumn + ". FunctionDefn is not supported yet.");}
    funcName = QName(true);
    currentToken = jj_consume_token(L_PAREN);

    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case AND:
    case ASCENDING:
    case ATTRIBUTE:
    case BY:
    case CASE:
    case DEFAULT_:
    case DESCENDING:
    case DIVISION:
    case ELEMENT:
    case ELSE:
    case EVERY:
    case EXCEPT:
    case FOR:
    case IN:
    case INTEGER_DIVISION:
    case INTERSECT:
    case IS:
    case ISNOT:
    case LET:
    case MODULO:
    case OR:
    case RETURN:
    case SATISFIES:
    case SOME:
    case SORT:
    case SORTBY:
    case STABLE:
    case TO:
    case UNION:
    case UNORDERED:
    case VALIDATE:
    case VALUE_EQUALS:
    case VALUE_GREATER_THAN:
    case VALUE_GREATER_THAN_EQUALS:
    case VALUE_LESS_THAN:
    case VALUE_LESS_THAN_EQUALS:
    case VALUE_NOT_EQUALS:
    case VARName:
    case WHERE:
    case NCName:
    case START_TAG_NCName:
    case END_TAG_NCName:
    case ATOMIC_VALUE:
    case ATTRIBUTE_TYPE:
    case COMMENT:
    case DOCUMENT:
    case ELEMENT_TYPE:
    case EMPTY:
    case ITEM:
    case NODE:
    case PROCESSING_INSTRUC:
    case TEXT:
    case UNTYPED:
      paramList = ParamList();
      break;
    default:
      jj_la1[113] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case R_PAREN:
      currentToken = jj_consume_token(R_PAREN);

      break;
    case R_PAREN_RETURNS:
      currentToken = jj_consume_token(R_PAREN_RETURNS);

      sequenceType = SequenceType();
      break;
    default:
      jj_la1[114] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    enclosedExpr = EnclosedExpr(true);
                FunctionDefinition functionDefinition = null;
                try
                {
                        functionDefinition = factory.createFunctionDefinition(funcName, paramList, sequenceType, ((XQueryExpressionSequence)enclosedExpr).getSubExpressions(), typevisitor);
                }
                catch (TypeException te)
                {
                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                }
                funDefNames.put(funcName.print(), functionDefinition);
                {if (true) return functionDefinition;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[88]	ParamList ::=						Param ( ", " Param )*
***************************************************************************************/
  final public ArrayList ParamList() throws ParseException, ParseException, Exception {
        ArrayList params = new ArrayList();
        XQueryExpression expression = null;
    expression = Param(false);
                        params.add(expression);
    label_30:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        jj_la1[115] = jj_gen;
        break label_30;
      }
      currentToken = jj_consume_token(COMMA);

      expression = Param(false);
                                params.add(expression);
    }
                {if (true) return params;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[89]	SchemaImport ::=					<"import" "schema"> ( StringLiteral | SubNamespaceDecl | DefaultNamespaceDecl ) <"at" StringLiteral>?
***************************************************************************************/
  final public void SchemaImport() throws ParseException, ParseException, Exception {
        String ncname = null;
        String value = null;
    currentToken = jj_consume_token(IMPORT_SCHEMA);

    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case StringLiteral:
      currentToken = jj_consume_token(StringLiteral);
                                //previousToken = currentToken;
                                // if (debug) System.out.println("SchemaImport - Read <StringLiteral> " + currentToken.image);
                                ncname = unquote(currentToken.image);
      break;
    case NAMESPACE_DT:
      ncname = SubNamespaceDecl();
      break;
    case DEFAULT_ELEMENT_NAMESPACE_EQUALS:
    case DEFAULT_FUNCTION_NAMESPACE_EQUALS:
      ncname = DefaultNamespaceDecl();
      break;
    default:
      jj_la1[116] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    currentToken = jj_consume_token(ATLOC);

    currentToken = jj_consume_token(StringLiteral);
                        //previousToken = currentToken;
                        // if (debug) System.out.println("SchemaImport - Read <StringLiteral> " + currentToken.image);
                        value = unquote(currentToken.image);
                //value = unquote(value);
                if (typevisitor != null)
                {
                        if (baseURI != null)
                                value = (new URL(new URL(baseURI),value)).toString();
                        if (ncname.length() == 0)
                                ncname = null;
                        typevisitor.getSchemaManager().addSchemaLocation(ncname, value);
                        org.xquark.schema.Schema sch = typevisitor.getSchemaManager().loadSchema(typevisitor.getSchemaLocator(), ncname);
                }
  }

/***************************************************************************************
[90]	OrderExpr ::=						<"order by"> Expr ("ascending" | "descending")? ( ", " Expr ("ascending" | "descending")? )*
		cf rule 10
***************************************************************************************/
  final public ArrayList OrderExpr() throws ParseException, ParseException, Exception {
        ArrayList orderbys = new ArrayList(1);
        XQueryExpression orderexpr = null;
        int order = -1;
    currentToken = jj_consume_token(ORDER);

    currentToken = jj_consume_token(BY);

    orderexpr = Expr();
                        orderbys.add(orderexpr);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ASCENDING:
    case DESCENDING:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ASCENDING:
        currentToken = jj_consume_token(ASCENDING);
                                //previousToken = currentToken;
                                // if (debug) System.out.println("OrderExpr - Read <ASCENDING> " + currentToken.image);
                                order = Constants.ASCENDING_ORDER;
                                orderexpr.setOrder(order);
        break;
      case DESCENDING:
        currentToken = jj_consume_token(DESCENDING);
                                //previousToken = currentToken;
                                // if (debug) System.out.println("OrderExpr - Read <DESCENDING> " + currentToken.image);
                                order = Constants.DESCENDING_ORDER;
                                orderexpr.setOrder(order);
        break;
      default:
        jj_la1[117] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      break;
    default:
      jj_la1[118] = jj_gen;
      ;
    }
    label_31:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        jj_la1[119] = jj_gen;
        break label_31;
      }
      currentToken = jj_consume_token(COMMA);

      orderexpr = Expr();
                                orderbys.add(orderexpr);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ASCENDING:
      case DESCENDING:
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ASCENDING:
          currentToken = jj_consume_token(ASCENDING);
                                //previousToken = currentToken;
                                // if (debug) System.out.println("OrderExpr - Read <ASCENDING> " + currentToken.image);
                                order = Constants.ASCENDING_ORDER;
                                orderexpr.setOrder(order);
          break;
        case DESCENDING:
          currentToken = jj_consume_token(DESCENDING);
                                //previousToken = currentToken;
                                // if (debug) System.out.println("OrderExpr - Read <DESCENDING> " + currentToken.image);
                                order = Constants.DESCENDING_ORDER;
                                orderexpr.setOrder(order);
          break;
        default:
          jj_la1[120] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
        break;
      default:
        jj_la1[121] = jj_gen;
        ;
      }
    }
                {if (true) return orderbys;}
    throw new Error("Missing return statement in function");
  }

/**************************************************************************************
[91]	VAR ::=								<VARName>
**************************************************************************************/
  final public XQueryExpression VAR(boolean isnew, boolean isparam) throws ParseException, ParseException, Exception {
        String varname = null;
        XQueryExpression var = null;
    currentToken = jj_consume_token(VARName);
                        //previousToken = currentToken;
                        // if (debug) System.out.println("VAR - Read <VARName> " + currentToken.image);
                        varname = chop(currentToken.image);
                if (isnew)
                {
                        if (!isparam)
                        {
                                if (realVarNames.containsValue("$" + varname))
                                {
                                        {if (true) throw new ParseException("Error : Variable $" + varname + " already defined!");}
                                }
                                String var_name = VAR_NAME;
                                if (renameVars)
                                {
                                        varIndex++;
                                        if (varIndex < 10) var_name += "00";
                                        else if (varIndex < 100) var_name += "0";
                                        else if (varIndex >= 1000) {if (true) throw new TypeException("Var index count overflow", currentToken.beginLine, currentToken.beginColumn);}
                                        var_name += varIndex;
                                }
                                else
                                {
                                        var_name = varname;
                                }
                                if (varDefNames.containsKey("$" + var_name))
                                {
                                        {if (true) throw new ParseException("Error : Variable $" + varname + " already defined!");}
                                }
                                try
                                {
                                        var = factory.createVariable(factory.createQName(null, null, var_name, typevisitor), typevisitor);
                                        linkMap.put("$" + varname, "$" + var_name);
                                        realVarNames.put("$" + var_name, "$" + varname);
                                }
                                catch (TypeException te)
                                {
                                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                                }
                        }
                        else
                        {
                                if (hashParamList.containsKey("$" + varname))
                                {
                                        {if (true) throw new ParseException("Error : Parameter $" + varname + " already defined!");}
                                }
                                try
                                {
                                        var = factory.createValueParameter("$" + varname, null, typevisitor);
                                        hashParamList.put("$" + varname, var);
                                }
                                catch (TypeException te)
                                {
                                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                                }
                        }
                }
                else
                {
                        if (varDefNames.containsKey(linkMap.get("$" + varname)))
                        {
                                var = (Variable)varDefNames.get(linkMap.get("$" + varname));
                        }
                        else if (hashParamList.containsKey("$" + varname))
                        {
                                var = (ValueParameter)hashParamList.get("$" + varname);
                        }
                        else
                        {
                                {if (true) throw new TypeException("Error : Variable $" + varname + " not defined!", currentToken.beginLine, currentToken.beginColumn);}
                        }
                }
                {if (true) return var;}
    throw new Error("Missing return statement in function");
  }

/**************************************************************************************
[92]	QName ::=							( <NCName> ":" )? <NCName>
**************************************************************************************/
  final public QName QName(boolean check) throws ParseException, ParseException, Exception {
        String namespace = null;
        String prefixname = null;
        String typeName = null;
    if (jj_2_15(2)) {
      prefixname = NCName();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COLON:
        currentToken = jj_consume_token(COLON);

        break;
      case START_TAG_COLON:
        currentToken = jj_consume_token(START_TAG_COLON);

        break;
      case END_TAG_COLON:
        currentToken = jj_consume_token(END_TAG_COLON);

        break;
      default:
        jj_la1[122] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    } else {
      ;
    }
    typeName = NCName();
                try
                {
                        String tmpStr = null;
                        if (prefixname == null)
                        {
                                namespace = defaultNameSpace;
                        }
                        else
                        {
                                if (!prefixname.equals("xmlns") && check)
                                {
                                        tmpStr = getNameSpace(prefixname);
                                        if (tmpStr == null)
                                                {if (true) throw new TypeException("Could not match prefix [ " + prefixname + " ]" , currentToken.beginLine, currentToken.beginColumn);}
                                        namespace = tmpStr;
                                }
                        }
                        {if (true) return factory.createQName(namespace, prefixname, typeName, typevisitor);}
                }
                catch (TypeException te)
                {
                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                }
    throw new Error("Missing return statement in function");
  }

/**************************************************************************************
[93]	NCName ::=							<NCName> | "attribute"
**************************************************************************************/
  final public String NCName() throws ParseException, ParseException, Exception {
        StringBuffer buf = new StringBuffer();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case NCName:
      currentToken = jj_consume_token(NCName);
                        //previousToken = currentToken;
                        // if (debug) System.out.println("NCName - Read <NCName> " + currentToken.image);
                        buf.append(currentToken.image);
      break;
    case START_TAG_NCName:
      currentToken = jj_consume_token(START_TAG_NCName);
                        //previousToken = currentToken;
                        // if (debug) System.out.println("NCName - Read <START_TAG_NCName> " + currentToken.image);
                        buf.append(currentToken.image);
      break;
    case END_TAG_NCName:
      currentToken = jj_consume_token(END_TAG_NCName);
                        //previousToken = currentToken;
                        // if (debug) System.out.println("NCName - Read <END_TAG_NCName> " + currentToken.image);
                        buf.append(currentToken.image);
      break;
    case AND:
      currentToken = jj_consume_token(AND);
                        // if (debug) System.out.println("NCName - Read <AND> " + currentToken.image);
                        buf.append(currentToken.image);
      break;
    case ASCENDING:
      currentToken = jj_consume_token(ASCENDING);
                        // if (debug) System.out.println("NCName - Read <ASCENDING> " + currentToken.image);
                        buf.append(currentToken.image);
      break;
    case ATTRIBUTE:
      currentToken = jj_consume_token(ATTRIBUTE);
                        // if (debug) System.out.println("NCName - Read <ATTRIBUTE> " + currentToken.image);
                        buf.append(currentToken.image);
      break;
    case CASE:
      currentToken = jj_consume_token(CASE);
                        // if (debug) System.out.println("NCName - Read <CASE> " + currentToken.image);
                        buf.append(currentToken.image);
      break;
    case DEFAULT_:
      currentToken = jj_consume_token(DEFAULT_);
                        // if (debug) System.out.println("NCName - Read <DEFAULT_> " + currentToken.image);
                        buf.append(currentToken.image);
      break;
    case DESCENDING:
      currentToken = jj_consume_token(DESCENDING);
                        // if (debug) System.out.println("NCName - Read <DESCENDING> " + currentToken.image);
                        buf.append(currentToken.image);
      break;
    case DIVISION:
      currentToken = jj_consume_token(DIVISION);
                        // if (debug) System.out.println("NCName - Read <DIVISION> " + currentToken.image);
                        buf.append(currentToken.image);
      break;
    case ELEMENT:
      currentToken = jj_consume_token(ELEMENT);
                        // if (debug) System.out.println("NCName - Read <ELEMENT> " + currentToken.image);
                        buf.append(currentToken.image);
      break;
    case ELSE:
      currentToken = jj_consume_token(ELSE);
                        // if (debug) System.out.println("NCName - Read <ELSE> " + currentToken.image);
                        buf.append(currentToken.image);
      break;
    case EVERY:
      currentToken = jj_consume_token(EVERY);
                        // if (debug) System.out.println("NCName - Read <EVERY> " + currentToken.image);
                        buf.append(currentToken.image);
      break;
    case EXCEPT:
      currentToken = jj_consume_token(EXCEPT);
                        // if (debug) System.out.println("NCName - Read <EXCEPT> " + currentToken.image);
                        buf.append(currentToken.image);
      break;
    case FOR:
      currentToken = jj_consume_token(FOR);
                        // if (debug) System.out.println("NCName - Read <FOR> " + currentToken.image);
                        buf.append(currentToken.image);
      break;
    case IN:
      currentToken = jj_consume_token(IN);
                        // if (debug) System.out.println("NCName - Read <IN> " + currentToken.image);
                        buf.append(currentToken.image);
      break;
    case INTEGER_DIVISION:
      currentToken = jj_consume_token(INTEGER_DIVISION);
                        // if (debug) System.out.println("NCName - Read <INTEGER_DIVISION> " + currentToken.image);
                        buf.append(currentToken.image);
      break;
    case INTERSECT:
      currentToken = jj_consume_token(INTERSECT);
                        // if (debug) System.out.println("NCName - Read <INTERSECT> " + currentToken.image);
                        buf.append(currentToken.image);
      break;
    case IS:
      currentToken = jj_consume_token(IS);
                        // if (debug) System.out.println("NCName - Read <IS> " + currentToken.image);
                        buf.append(currentToken.image);
      break;
    case ISNOT:
      currentToken = jj_consume_token(ISNOT);
                        // if (debug) System.out.println("NCName - Read <ISNOT> " + currentToken.image);
                        buf.append(currentToken.image);
      break;
    case LET:
      currentToken = jj_consume_token(LET);
                        // if (debug) System.out.println("NCName - Read <LET> " + currentToken.image);
                        buf.append(currentToken.image);
      break;
    case MODULO:
      currentToken = jj_consume_token(MODULO);
                        // if (debug) System.out.println("NCName - Read <MODULO> " + currentToken.image);
                        buf.append(currentToken.image);
      break;
    case OR:
      currentToken = jj_consume_token(OR);
                        // if (debug) System.out.println("NCName - Read <OR> " + currentToken.image);
                        buf.append(currentToken.image);
      break;
    case RETURN:
      currentToken = jj_consume_token(RETURN);
                        // if (debug) System.out.println("NCName - Read <RETURN> " + currentToken.image);
                        buf.append(currentToken.image);
      break;
    case SATISFIES:
      currentToken = jj_consume_token(SATISFIES);
                        // if (debug) System.out.println("NCName - Read <SATISFIES> " + currentToken.image);
                        buf.append(currentToken.image);
      break;
    case SOME:
      currentToken = jj_consume_token(SOME);
                        // if (debug) System.out.println("NCName - Read <SOME> " + currentToken.image);
                        buf.append(currentToken.image);
      break;
    case SORT:
      currentToken = jj_consume_token(SORT);
                        // if (debug) System.out.println("NCName - Read <SORT> " + currentToken.image);
                        buf.append(currentToken.image);
      break;
    case SORTBY:
      currentToken = jj_consume_token(SORTBY);
                        // if (debug) System.out.println("NCName - Read <SORTBY> " + currentToken.image);
                        buf.append(currentToken.image);
      break;
    case BY:
      currentToken = jj_consume_token(BY);
                        // if (debug) System.out.println("NCName - Read <BY> " + currentToken.image);
                        buf.append(currentToken.image);
      break;
    case STABLE:
      currentToken = jj_consume_token(STABLE);
                        // if (debug) System.out.println("NCName - Read <STABLE> " + currentToken.image);
                        buf.append(currentToken.image);
      break;
    case TO:
      currentToken = jj_consume_token(TO);
                        // if (debug) System.out.println("NCName - Read <TO> " + currentToken.image);
                        buf.append(currentToken.image);
      break;
    case UNION:
      currentToken = jj_consume_token(UNION);
                        // if (debug) System.out.println("NCName - Read <UNION> " + currentToken.image);
                        buf.append(currentToken.image);
      break;
    case UNORDERED:
      currentToken = jj_consume_token(UNORDERED);
                        // if (debug) System.out.println("NCName - Read <UNORDERED> " + currentToken.image);
                        buf.append(currentToken.image);
      break;
    case VALIDATE:
      currentToken = jj_consume_token(VALIDATE);
                        // if (debug) System.out.println("NCName - Read <VALIDATE> " + currentToken.image);
                        buf.append(currentToken.image);
      break;
    case VALUE_EQUALS:
      currentToken = jj_consume_token(VALUE_EQUALS);
                        // if (debug) System.out.println("NCName - Read <VALUE_EQUALS> " + currentToken.image);
                        buf.append(currentToken.image);
      break;
    case VALUE_GREATER_THAN:
      currentToken = jj_consume_token(VALUE_GREATER_THAN);
                        // if (debug) System.out.println("NCName - Read <VALUE_GREATER_THAN> " + currentToken.image);
                        buf.append(currentToken.image);
      break;
    case VALUE_GREATER_THAN_EQUALS:
      currentToken = jj_consume_token(VALUE_GREATER_THAN_EQUALS);
                        // if (debug) System.out.println("NCName - Read <VALUE_GREATER_THAN_EQUALS> " + currentToken.image);
                        buf.append(currentToken.image);
      break;
    case VALUE_LESS_THAN:
      currentToken = jj_consume_token(VALUE_LESS_THAN);
                        // if (debug) System.out.println("NCName - Read <VALUE_LESS_THAN> " + currentToken.image);
                        buf.append(currentToken.image);
      break;
    case VALUE_LESS_THAN_EQUALS:
      currentToken = jj_consume_token(VALUE_LESS_THAN_EQUALS);
                        // if (debug) System.out.println("NCName - Read <VALUE_LESS_THAN_EQUALS> " + currentToken.image);
                        buf.append(currentToken.image);
      break;
    case VALUE_NOT_EQUALS:
      currentToken = jj_consume_token(VALUE_NOT_EQUALS);
                        // if (debug) System.out.println("NCName - Read <VALUE_NOT_EQUALS> " + currentToken.image);
                        buf.append(currentToken.image);
      break;
    case WHERE:
      currentToken = jj_consume_token(WHERE);
                        // if (debug) System.out.println("NCName - Read <WHERE> " + currentToken.image);
                        buf.append(currentToken.image);
      break;
    default:
      jj_la1[123] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                {if (true) return buf.toString();}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[94]	OldDeclaration ::=					( ( "namespace" NCNameForPrefix ) | ( "default" "namespace" ) ) "=" URLLiteral
***************************************************************************************/
  final public void OldDeclaration() throws ParseException, ParseException, Exception {
        String prefix = null;
        String uri = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case NAMESPACE_DT:
      currentToken = jj_consume_token(NAMESPACE_DT);
                                        //previousToken = currentToken;
                                        // if (debug) System.out.println("OldDeclaration - Read <NAMESPACE_DT> " + currentToken.image);
                                        // if (debug) System.out.println("*************************** NAMESPACEDECL");
                                        switchState(NAMESPACEDECL);
      currentToken = jj_consume_token(NCNameForPrefix);
                                        //previousToken = currentToken;
                                        // if (debug) System.out.println("OldDeclaration - Read <NCNameForPrefix> " + currentToken.image);
                                        prefix = currentToken.image;
                                        // if (debug) System.out.println("*************************** DEFAULT");
                                        switchState(DEFAULT);
      break;
    case DEFAULT_NAMESPACE:
      currentToken = jj_consume_token(DEFAULT_NAMESPACE);

      break;
    default:
      jj_la1[124] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    currentToken = jj_consume_token(EQUALS);
                        //previousToken = currentToken;
                        // if (debug) System.out.println("OldDeclaration - Read <EQUALS> " + currentToken.image);
                        // if (debug) System.out.println("*************************** NAMESPCADECL");
                        switchState(NAMESPACEDECL);
    currentToken = jj_consume_token(URLLiteral);
                        //previousToken = currentToken;
                        // if (debug) System.out.println("OldDeclaration - Read <URLLiteral> " + currentToken.image);
                        uri = unquote(currentToken.image);
                        // if (debug) System.out.println("*************************** DEFAULT");
                        switchState(DEFAULT);
                if (prefix == null)
                {
                        if (defaultNameSpace != null)
                        {
                                {if (true) throw new TypeException("Default namespace defined more than once", currentToken.beginLine, currentToken.beginColumn);}
                        }
                        prefix = "";
                        defaultNameSpace = uri;
                }
                hashDeclList.declarePrefix(prefix, uri);
  }

/***************************************************************************************
[95]	HintClause ::=						<"hint ("> NodeClause ")"
***************************************************************************************/
  final public HintTree HintClause() throws ParseException, ParseException, Exception {
        HintTree hintTree = null;
        int outertype = HintTree.NO_TYPE;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case HINT_OUTER_MERGE:
    case HINT_OUTER_NESTED:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case HINT_OUTER_MERGE:
        currentToken = jj_consume_token(HINT_OUTER_MERGE);
                                outertype = HintTree.MERGE_TYPE;
        break;
      case HINT_OUTER_NESTED:
        currentToken = jj_consume_token(HINT_OUTER_NESTED);
                                outertype = HintTree.NESTED_TYPE;
        break;
      default:
        jj_la1[125] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      break;
    default:
      jj_la1[126] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case CARTESIAN_PRODUCT:
    case JOIN:
    case MERGE:
    case NESTED_LOOP:
      hintTree = NodeClause();
      break;
    default:
      jj_la1[127] = jj_gen;
      ;
    }
    currentToken = jj_consume_token(END_PRAGMA);
                if (hintTree == null && outertype != HintTree.NO_TYPE) {
                        hintTree = factory.createHintTree(HintTree.NO_TYPE, HintTree.NO_SIDE, null, null);
                }
                if (hintTree != null) {
                        hintTree.setOuterType(outertype);
                }
                {if (true) return hintTree;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[96]	NodeClause ::=						( "merge" | "cartesian-product" | "join" | "nested-loop" ) "(" LeafClause "," LeafClause ")"
***************************************************************************************/
  final public HintTree NodeClause() throws ParseException, ParseException, Exception {
        Object left = null;
        Object right = null;
        int type = -1;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case MERGE:
      currentToken = jj_consume_token(MERGE);
                                type = HintTree.MERGE_TYPE;
      break;
    case CARTESIAN_PRODUCT:
      currentToken = jj_consume_token(CARTESIAN_PRODUCT);
                                type = HintTree.CARTESIAN_PRODUCT_TYPE;
      break;
    case JOIN:
      currentToken = jj_consume_token(JOIN);
                                type = HintTree.JOIN_TYPE;
      break;
    case NESTED_LOOP:
      currentToken = jj_consume_token(NESTED_LOOP);
                                type = HintTree.NESTED_LOOP_TYPE;
      break;
    default:
      jj_la1[128] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    currentToken = jj_consume_token(L_PAREN);
    left = LeafClause();
    currentToken = jj_consume_token(COMMA);
    right = LeafClause();
    currentToken = jj_consume_token(R_PAREN);
                {if (true) return factory.createHintTree(type, HintTree.NO_SIDE, left, right);}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[97]	LeafClause ::=						NodeClause | VAR
***************************************************************************************/
  final public Object LeafClause() throws ParseException, ParseException, Exception {
        Object leaf = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case CARTESIAN_PRODUCT:
    case JOIN:
    case MERGE:
    case NESTED_LOOP:
      leaf = NodeClause();
      break;
    case VARName:
      leaf = VAR(false, false);
      break;
    default:
      jj_la1[129] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                {if (true) return leaf;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[98]	DeclareParameter ::=				< "declare" "parameter" > VAR "as" AtomicType
***************************************************************************************/
  final public void DeclareParameter() throws ParseException, ParseException, Exception {
        XQueryExpression valueParameter = null;
        QName atomicType = null;
        boolean oldRestriction = false;
    currentToken = jj_consume_token(DECLARE_PARAMETER);
    valueParameter = VAR(true, true);
    currentToken = jj_consume_token(AS);
                        oldRestriction = restriction;
                        restriction = false;
    atomicType = AtomicType();
                        restriction = oldRestriction;
                valueParameter.setTypeName(atomicType);
                valueParameter.accept(typevisitor);
  }

  final private boolean jj_2_1(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_1();
    jj_save(0, xla);
    return retval;
  }

  final private boolean jj_2_2(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_2();
    jj_save(1, xla);
    return retval;
  }

  final private boolean jj_2_3(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_3();
    jj_save(2, xla);
    return retval;
  }

  final private boolean jj_2_4(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_4();
    jj_save(3, xla);
    return retval;
  }

  final private boolean jj_2_5(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_5();
    jj_save(4, xla);
    return retval;
  }

  final private boolean jj_2_6(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_6();
    jj_save(5, xla);
    return retval;
  }

  final private boolean jj_2_7(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_7();
    jj_save(6, xla);
    return retval;
  }

  final private boolean jj_2_8(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_8();
    jj_save(7, xla);
    return retval;
  }

  final private boolean jj_2_9(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_9();
    jj_save(8, xla);
    return retval;
  }

  final private boolean jj_2_10(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_10();
    jj_save(9, xla);
    return retval;
  }

  final private boolean jj_2_11(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_11();
    jj_save(10, xla);
    return retval;
  }

  final private boolean jj_2_12(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_12();
    jj_save(11, xla);
    return retval;
  }

  final private boolean jj_2_13(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_13();
    jj_save(12, xla);
    return retval;
  }

  final private boolean jj_2_14(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_14();
    jj_save(13, xla);
    return retval;
  }

  final private boolean jj_2_15(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_15();
    jj_save(14, xla);
    return retval;
  }

  final private boolean jj_3R_185() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_196()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_80() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_144()) {
    jj_scanpos = xsp;
    if (jj_3R_145()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_211() {
    if (jj_3R_223()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_167() {
    if (jj_scan_token(ATTRIBUTE_L_BRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_36()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_214() {
    if (jj_3R_200()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_68() {
    if (jj_3R_131()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_67() {
    if (jj_3R_130()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_202() {
    if (jj_scan_token(PARENT_DCOLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_195() {
    if (jj_3R_42()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_66() {
    if (jj_3R_129()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_213() {
    if (jj_scan_token(AT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_224()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_39() {
    if (jj_3R_79()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_80()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_32() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_66()) {
    jj_scanpos = xsp;
    if (jj_3R_67()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_246() {
    if (jj_3R_247()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_219() {
    if (jj_scan_token(DESCENDANT_SELF_DCOLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_166() {
    if (jj_scan_token(ATTRIBUTE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_42()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_35() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_68()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_69()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_218() {
    if (jj_scan_token(SELF_DCOLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_217() {
    if (jj_scan_token(ATTRIBUTE_DCOLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_212() {
    if (jj_scan_token(DOT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_128() {
    if (jj_scan_token(WHERE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_2() {
    Token xsp;
    if (jj_3R_32()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_32()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_78() {
    if (jj_3R_140()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_140() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_166()) {
    jj_scanpos = xsp;
    if (jj_3R_167()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_77() {
    if (jj_3R_139()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_87() {
    if (jj_scan_token(OF_TYPE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_42()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_174() {
    if (jj_3R_133()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_216() {
    if (jj_scan_token(DESCENDANT_DCOLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_76() {
    if (jj_3R_138()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_127() {
    if (jj_scan_token(VALUE_NOT_EQUALS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_75() {
    if (jj_3R_137()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_198() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_212()) {
    jj_scanpos = xsp;
    if (jj_3R_213()) {
    jj_scanpos = xsp;
    if (jj_3R_214()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_74() {
    if (jj_3R_136()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_197() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_2()) {
    jj_scanpos = xsp;
    if (jj_3R_211()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_73() {
    if (jj_3R_135()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_126() {
    if (jj_scan_token(VALUE_LESS_THAN_EQUALS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_215() {
    if (jj_scan_token(CHILD_DCOLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_72() {
    if (jj_3R_134()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_150() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_174()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_263() {
    if (jj_3R_39()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_125() {
    if (jj_scan_token(VALUE_LESS_THAN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_199() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_215()) {
    jj_scanpos = xsp;
    if (jj_3R_216()) {
    jj_scanpos = xsp;
    if (jj_3R_217()) {
    jj_scanpos = xsp;
    if (jj_3R_218()) {
    jj_scanpos = xsp;
    if (jj_3R_219()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_38() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_72()) {
    jj_scanpos = xsp;
    if (jj_3R_73()) {
    jj_scanpos = xsp;
    if (jj_3R_74()) {
    jj_scanpos = xsp;
    if (jj_3R_75()) {
    jj_scanpos = xsp;
    if (jj_3R_76()) {
    jj_scanpos = xsp;
    if (jj_3R_77()) {
    jj_scanpos = xsp;
    if (jj_3R_78()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_245() {
    if (jj_3R_246()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_124() {
    if (jj_scan_token(VALUE_GREATER_THAN_EQUALS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_149() {
    if (jj_scan_token(OF_TYPE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_69() {
    if (jj_scan_token(VARName)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_123() {
    if (jj_scan_token(VALUE_GREATER_THAN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_1() {
    if (jj_scan_token(UNORDERED)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_190() {
    if (jj_3R_202()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_200()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_189() {
    if (jj_3R_201()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_122() {
    if (jj_scan_token(VALUE_EQUALS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_262() {
    if (jj_scan_token(SLASHSLASH)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_186() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_1()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_197()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_121() {
    if (jj_scan_token(VALIDATE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_8() {
    if (jj_3R_41()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_169() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_189()) {
    jj_scanpos = xsp;
    if (jj_3R_190()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_83() {
    if (jj_3R_69()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_86() {
    if (jj_3R_42()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_149()) {
    jj_scanpos = xsp;
    if (jj_3R_150()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_6() {
    if (jj_3R_39()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_82() {
    if (jj_3R_147()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_120() {
    if (jj_scan_token(UNORDERED)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_81() {
    if (jj_3R_146()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_119() {
    if (jj_scan_token(UNION)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_44() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_86()) {
    jj_scanpos = xsp;
    if (jj_3R_87()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_40() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_81()) {
    jj_scanpos = xsp;
    if (jj_3R_82()) {
    jj_scanpos = xsp;
    if (jj_3R_83()) {
    jj_scanpos = xsp;
    if (jj_3_8()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_118() {
    if (jj_scan_token(TO)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_260() {
    if (jj_scan_token(TREAT_AS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_117() {
    if (jj_scan_token(STABLE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_244() {
    if (jj_3R_245()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_259() {
    if (jj_scan_token(CAST_AS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_188() {
    if (jj_3R_199()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_200()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_261() {
    if (jj_scan_token(SLASH)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_187() {
    if (jj_3R_198()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_116() {
    if (jj_scan_token(BY)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_153() {
    if (jj_3R_186()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_115() {
    if (jj_scan_token(SORTBY)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_258() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_261()) {
    jj_scanpos = xsp;
    if (jj_3R_262()) {
    jj_scanpos = xsp;
    if (jj_3R_263()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_168() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_187()) {
    jj_scanpos = xsp;
    if (jj_3R_188()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_165() {
    if (jj_scan_token(ELEMENT_L_BRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_36()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_49() {
    if (jj_scan_token(PredefinedEntityRef)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_173() {
    if (jj_3R_192()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_114() {
    if (jj_scan_token(SORT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_184() {
    if (jj_scan_token(ATOMIC_VALUE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_257() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_259()) {
    jj_scanpos = xsp;
    if (jj_3R_260()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_152() {
    if (jj_scan_token(EMPTY)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_48() {
    if (jj_scan_token(CharRef)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_113() {
    if (jj_scan_token(SOME)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_256() {
    if (jj_3R_258()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_85() {
    if (jj_3R_36()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_183() {
    if (jj_scan_token(UNTYPED)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_164() {
    if (jj_scan_token(ELEMENT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_42()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_5() {
    if (jj_3R_38()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_255() {
    if (jj_3R_257()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_47() {
    if (jj_scan_token(ESCAPE_R_BRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_112() {
    if (jj_scan_token(SATISFIES)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_4() {
    if (jj_3R_37()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_111() {
    if (jj_scan_token(RETURN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_46() {
    if (jj_scan_token(ESCAPE_L_BRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_182() {
    if (jj_3R_195()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_43() {
    if (jj_scan_token(L_PAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_85()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(R_PAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_71() {
    if (jj_3R_133()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_252() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_4()) {
    jj_scanpos = xsp;
    if (jj_3R_255()) {
    jj_scanpos = xsp;
    if (jj_3_5()) {
    jj_scanpos = xsp;
    if (jj_3R_256()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_110() {
    if (jj_scan_token(OR)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_243() {
    if (jj_3R_244()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_236() {
    if (jj_scan_token(NODE_L_PAREN_R_PAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_45() {
    if (jj_scan_token(Char)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_139() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_164()) {
    jj_scanpos = xsp;
    if (jj_3R_165()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_181() {
    if (jj_scan_token(ITEM)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_132() {
    if (jj_3R_153()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_10() {
    if (jj_3R_42()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_43()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_241() {
    if (jj_3R_243()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_12() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_45()) {
    jj_scanpos = xsp;
    if (jj_3R_46()) {
    jj_scanpos = xsp;
    if (jj_3R_47()) {
    jj_scanpos = xsp;
    if (jj_3R_48()) {
    jj_scanpos = xsp;
    if (jj_3R_49()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_180() {
    if (jj_scan_token(DOCUMENT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_109() {
    if (jj_scan_token(MODULO)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_254() {
    if (jj_scan_token(PLUS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_147() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_10()) {
    jj_scanpos = xsp;
    if (jj_3R_173()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_108() {
    if (jj_scan_token(LET)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_179() {
    if (jj_scan_token(TEXT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_37() {
    if (jj_scan_token(VALIDATE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_71()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(L_BRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_253() {
    if (jj_scan_token(MINUS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_251() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_253()) {
    jj_scanpos = xsp;
    if (jj_3R_254()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_107() {
    if (jj_scan_token(ISNOT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_235() {
    if (jj_scan_token(TEXT_L_PAREN_R_PAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_178() {
    if (jj_scan_token(COMMENT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_106() {
    if (jj_scan_token(IS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_11() {
    if (jj_3R_44()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_84() {
    if (jj_3R_148()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_177() {
    if (jj_scan_token(PROCESSING_INSTRUC)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_105() {
    if (jj_scan_token(INTERSECT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_138() {
    if (jj_scan_token(DOCUMENT_L_BRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_148()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_250() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_251()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_252()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_240() {
    if (jj_scan_token(IF_L_PAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_104() {
    if (jj_scan_token(INTEGER_DIVISION)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_176() {
    if (jj_scan_token(NODE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_194() {
    if (jj_scan_token(ATTRIBUTE_TYPE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_103() {
    if (jj_scan_token(IN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_61() {
    if (jj_scan_token(EntityRef_QUOT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_158() {
    if (jj_scan_token(XMLCommentChar)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_239() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_240()) {
    jj_scanpos = xsp;
    if (jj_3R_241()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_234() {
    if (jj_scan_token(COMMENT_L_PAREN_R_PAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_193() {
    if (jj_scan_token(ELEMENT_TYPE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_102() {
    if (jj_scan_token(FOR)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_60() {
    if (jj_scan_token(ESCAPE_R_BRACE_QUOT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_41() {
    if (jj_scan_token(L_PAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_84()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(R_PAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_157() {
    if (jj_scan_token(ELT_XMLCOMMENT_START)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_238() {
    if (jj_3R_239()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_101() {
    if (jj_scan_token(EXCEPT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_59() {
    if (jj_scan_token(ESCAPE_L_BRACE_QUOT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_156() {
    if (jj_scan_token(XMLCOMMENT_START)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_100() {
    if (jj_scan_token(EVERY)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_242() {
    if (jj_scan_token(StringLiteral)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_58() {
    if (jj_scan_token(CharRef_QUOT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_175() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_193()) {
    jj_scanpos = xsp;
    if (jj_3R_194()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    xsp = jj_scanpos;
    if (jj_3_11()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_99() {
    if (jj_scan_token(ELSE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_57() {
    if (jj_scan_token(Char_QUOT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_98() {
    if (jj_scan_token(ELEMENT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_172() {
    if (jj_scan_token(StringLiteral)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_171() {
    if (jj_3R_191()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_56() {
    if (jj_scan_token(ESCAPE_QUOT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_135() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_156()) {
    jj_scanpos = xsp;
    if (jj_3R_157()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_158()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    if (jj_scan_token(ELT_XMLCOMMENT_STOP)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_97() {
    if (jj_scan_token(DIVISION)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_151() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_175()) {
    jj_scanpos = xsp;
    if (jj_3R_176()) {
    jj_scanpos = xsp;
    if (jj_3R_177()) {
    jj_scanpos = xsp;
    if (jj_3R_178()) {
    jj_scanpos = xsp;
    if (jj_3R_179()) {
    jj_scanpos = xsp;
    if (jj_3R_180()) {
    jj_scanpos = xsp;
    if (jj_3R_181()) {
    jj_scanpos = xsp;
    if (jj_3R_182()) {
    jj_scanpos = xsp;
    if (jj_3R_183()) {
    jj_scanpos = xsp;
    if (jj_3R_184()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_185()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_70() {
    if (jj_3R_132()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_96() {
    if (jj_scan_token(DESCENDING)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_233() {
    if (jj_scan_token(PROCESSING_INSTRUCTION_L_PAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_242()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(R_PAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_146() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_171()) {
    jj_scanpos = xsp;
    if (jj_3R_172()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_14() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_56()) {
    jj_scanpos = xsp;
    if (jj_3R_57()) {
    jj_scanpos = xsp;
    if (jj_3R_58()) {
    jj_scanpos = xsp;
    if (jj_3R_59()) {
    jj_scanpos = xsp;
    if (jj_3R_60()) {
    jj_scanpos = xsp;
    if (jj_3R_61()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_95() {
    if (jj_scan_token(DEFAULT_)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_231() {
    if (jj_3R_236()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_131() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_151()) {
    jj_scanpos = xsp;
    if (jj_3R_152()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_249() {
    if (jj_3R_250()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_230() {
    if (jj_3R_235()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_229() {
    if (jj_3R_234()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_130() {
    if (jj_scan_token(LET)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_35()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(SET_EQUAL_TO)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_36()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_94() {
    if (jj_scan_token(CASE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_228() {
    if (jj_3R_233()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_93() {
    if (jj_scan_token(ATTRIBUTE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_237() {
    if (jj_scan_token(TYPESWITCH_L_PAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_36() {
    if (jj_3R_70()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_160() {
    if (jj_scan_token(ELT_XMLPROCESSING_START)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_225() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_228()) {
    jj_scanpos = xsp;
    if (jj_3R_229()) {
    jj_scanpos = xsp;
    if (jj_3R_230()) {
    jj_scanpos = xsp;
    if (jj_3R_231()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_92() {
    if (jj_scan_token(ASCENDING)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_205() {
    if (jj_scan_token(DoubleLiteral)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_232() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_237()) {
    jj_scanpos = xsp;
    if (jj_3R_238()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_159() {
    if (jj_scan_token(XMLPROCESSING_START)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_91() {
    if (jj_scan_token(AND)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_55() {
    if (jj_scan_token(EntityRef_APOS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_90() {
    if (jj_scan_token(END_TAG_NCName)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_204() {
    if (jj_scan_token(DecimalLiteral)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_226() {
    if (jj_3R_232()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_54() {
    if (jj_scan_token(ESCAPE_R_BRACE_APOS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_89() {
    if (jj_scan_token(START_TAG_NCName)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_136() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_159()) {
    jj_scanpos = xsp;
    if (jj_3R_160()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_62()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_53() {
    if (jj_scan_token(ESCAPE_L_BRACE_APOS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_88() {
    if (jj_scan_token(NCName)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_203() {
    if (jj_scan_token(IntegerLiteral)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_191() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_203()) {
    jj_scanpos = xsp;
    if (jj_3R_204()) {
    jj_scanpos = xsp;
    if (jj_3R_205()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_248() {
    if (jj_3R_249()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_52() {
    if (jj_scan_token(CharRef_APOS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_62() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_88()) {
    jj_scanpos = xsp;
    if (jj_3R_89()) {
    jj_scanpos = xsp;
    if (jj_3R_90()) {
    jj_scanpos = xsp;
    if (jj_3R_91()) {
    jj_scanpos = xsp;
    if (jj_3R_92()) {
    jj_scanpos = xsp;
    if (jj_3R_93()) {
    jj_scanpos = xsp;
    if (jj_3R_94()) {
    jj_scanpos = xsp;
    if (jj_3R_95()) {
    jj_scanpos = xsp;
    if (jj_3R_96()) {
    jj_scanpos = xsp;
    if (jj_3R_97()) {
    jj_scanpos = xsp;
    if (jj_3R_98()) {
    jj_scanpos = xsp;
    if (jj_3R_99()) {
    jj_scanpos = xsp;
    if (jj_3R_100()) {
    jj_scanpos = xsp;
    if (jj_3R_101()) {
    jj_scanpos = xsp;
    if (jj_3R_102()) {
    jj_scanpos = xsp;
    if (jj_3R_103()) {
    jj_scanpos = xsp;
    if (jj_3R_104()) {
    jj_scanpos = xsp;
    if (jj_3R_105()) {
    jj_scanpos = xsp;
    if (jj_3R_106()) {
    jj_scanpos = xsp;
    if (jj_3R_107()) {
    jj_scanpos = xsp;
    if (jj_3R_108()) {
    jj_scanpos = xsp;
    if (jj_3R_109()) {
    jj_scanpos = xsp;
    if (jj_3R_110()) {
    jj_scanpos = xsp;
    if (jj_3R_111()) {
    jj_scanpos = xsp;
    if (jj_3R_112()) {
    jj_scanpos = xsp;
    if (jj_3R_113()) {
    jj_scanpos = xsp;
    if (jj_3R_114()) {
    jj_scanpos = xsp;
    if (jj_3R_115()) {
    jj_scanpos = xsp;
    if (jj_3R_116()) {
    jj_scanpos = xsp;
    if (jj_3R_117()) {
    jj_scanpos = xsp;
    if (jj_3R_118()) {
    jj_scanpos = xsp;
    if (jj_3R_119()) {
    jj_scanpos = xsp;
    if (jj_3R_120()) {
    jj_scanpos = xsp;
    if (jj_3R_121()) {
    jj_scanpos = xsp;
    if (jj_3R_122()) {
    jj_scanpos = xsp;
    if (jj_3R_123()) {
    jj_scanpos = xsp;
    if (jj_3R_124()) {
    jj_scanpos = xsp;
    if (jj_3R_125()) {
    jj_scanpos = xsp;
    if (jj_3R_126()) {
    jj_scanpos = xsp;
    if (jj_3R_127()) {
    jj_scanpos = xsp;
    if (jj_3R_128()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_222() {
    if (jj_scan_token(COLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_51() {
    if (jj_scan_token(Char_APOS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_163() {
    if (jj_scan_token(CDataChar)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_148() {
    if (jj_3R_36()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_207() {
    if (jj_3R_62()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(COLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_50() {
    if (jj_scan_token(ESCAPE_APOS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_155() {
    if (jj_scan_token(ELT_LESS_THAN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_162() {
    if (jj_scan_token(ELT_CDATA_START)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_129() {
    if (jj_scan_token(FOR)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_35()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(IN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_36()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_154() {
    if (jj_scan_token(LESS_THAN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_65() {
    if (jj_scan_token(END_TAG_COLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_13() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_50()) {
    jj_scanpos = xsp;
    if (jj_3R_51()) {
    jj_scanpos = xsp;
    if (jj_3R_52()) {
    jj_scanpos = xsp;
    if (jj_3R_53()) {
    jj_scanpos = xsp;
    if (jj_3R_54()) {
    jj_scanpos = xsp;
    if (jj_3R_55()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_161() {
    if (jj_scan_token(CDATA_START)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_170() {
    if (jj_scan_token(L_BRACKET)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_206() {
    if (jj_scan_token(STAR)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_222()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_64() {
    if (jj_scan_token(START_TAG_COLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_142() {
    if (jj_3R_169()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_141() {
    if (jj_3R_168()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_7() {
    if (jj_3R_40()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_63() {
    if (jj_scan_token(COLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_34() {
    if (jj_scan_token(EVERY)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_143() {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_170()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_192() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_206()) {
    jj_scanpos = xsp;
    if (jj_3R_207()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_134() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_154()) {
    jj_scanpos = xsp;
    if (jj_3R_155()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_42()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_33() {
    if (jj_scan_token(SOME)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_137() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_161()) {
    jj_scanpos = xsp;
    if (jj_3R_162()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_163()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    if (jj_scan_token(CDATA_STOP)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_15() {
    if (jj_3R_62()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_63()) {
    jj_scanpos = xsp;
    if (jj_3R_64()) {
    jj_scanpos = xsp;
    if (jj_3R_65()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_227() {
    if (jj_3R_192()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_210() {
    if (jj_scan_token(OCCURRENCE_QUESTION_MARK)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_9() {
    if (jj_3R_42()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_79() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_7()) {
    jj_scanpos = xsp;
    if (jj_3R_141()) {
    jj_scanpos = xsp;
    if (jj_3R_142()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_143()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_209() {
    if (jj_scan_token(OCCURRENCE_PLUS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_224() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_9()) {
    jj_scanpos = xsp;
    if (jj_3R_227()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_247() {
    if (jj_3R_248()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_3() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_33()) {
    jj_scanpos = xsp;
    if (jj_3R_34()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_35()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(IN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_36()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_42() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_15()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_62()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_208() {
    if (jj_scan_token(OCCURRENCE_STAR)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_196() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_208()) {
    jj_scanpos = xsp;
    if (jj_3R_209()) {
    jj_scanpos = xsp;
    if (jj_3R_210()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_221() {
    if (jj_3R_224()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_145() {
    if (jj_scan_token(SLASHSLASH)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_220() {
    if (jj_3R_225()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_223() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_3()) {
    jj_scanpos = xsp;
    if (jj_3R_226()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_144() {
    if (jj_scan_token(SLASH)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_201() {
    if (jj_scan_token(DOTDOT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_200() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_220()) {
    jj_scanpos = xsp;
    if (jj_3R_221()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_133() {
    if (jj_scan_token(IN_TYPE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  public xqueryParserTokenManager token_source;
  JavaCharStream jj_input_stream;
  public Token token, jj_nt;
  private int jj_ntk;
  private Token jj_scanpos, jj_lastpos;
  private int jj_la;
  public boolean lookingAhead = false;
  private boolean jj_semLA;
  private int jj_gen;
  final private int[] jj_la1 = new int[130];
  final private int[] jj_la1_0 = {0xe0000000,0xe0000000,0x0,0x13d76800,0x8000000,0x0,0x0,0x0,0x0,0x800,0x0,0x0,0x200000,0x0,0x0,0x13d76800,0x0,0x8000000,0x13d76800,0x400000,0x0,0x13d76800,0x13d76800,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x80000,0x80000,0x0,0x0,0x0,0x0,0x800000,0x12536800,0x12536800,0x0,0x0,0x12536800,0x8000000,0x8000000,0x0,0x800000,0x1050000,0x0,0x0,0x0,0x0,0x8000000,0x2000,0x2000,0x0,0x0,0x0,0x512800,0x2020000,0x10512800,0x512800,0x4000000,0x512800,0x10000000,0x0,0x12536800,0x0,0x10516800,0x0,0x0,0x0,0x13d76800,0x8000000,0x13d76800,0x0,0x512800,0x512800,0x0,0x0,0x0,0x512800,0x512800,0x0,0x0,0x512800,0x0,0x0,0x0,0x1000000,0x0,0x0,0x13d76800,0x50000,0x13d76800,0x1000000,0x0,0x0,0x0,0x0,0x0,0x0,0x1000000,0x512800,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x512800,0x0,0x8000000,0x0,0x2000,0x2000,0x8000000,0x2000,0x2000,0x4000000,0x512800,0x0,0x0,0x0,0x200000,0x200000,0x200000,};
  final private int[] jj_la1_1 = {0xf,0xf,0x20,0x8387f7d0,0x0,0x0,0x0,0x0,0x0,0x0,0x2000000,0x2000000,0x60200000,0x0,0x0,0x8387f7d0,0x800000,0x0,0x8387f7d0,0x0,0x0,0x8387f7d0,0x8387f7d0,0x0,0x1c400000,0x1c400000,0x0,0x0,0x0,0x200,0x200,0x0,0x0,0x1000000,0x1000000,0x0,0x0,0x0,0x385f3d0,0x385f3d0,0x0,0x0,0x38533d0,0x0,0x0,0x0,0x0,0x30400,0x18400000,0x0,0x0,0x4000000,0x0,0x100,0x100,0x180000,0x180000,0x0,0x385c310,0xc0,0x3850310,0x3850310,0x0,0x3850310,0x0,0x0,0x38513d0,0x2000,0x3851310,0x0,0xc000,0xc000,0x8387f7d0,0x0,0x8387f7d0,0x0,0x3850310,0x3850310,0x0,0x0,0x0,0x3850310,0x3850310,0x0,0x0,0x3850310,0x0,0x0,0x0,0x0,0x0,0x30000,0x8387f7d0,0x0,0x8387f7d0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x3850310,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x3,0x3850310,0x0,0x0,0x3,0x100,0x100,0x0,0x100,0x100,0x0,0x3850310,0x8,0x60000000,0x60000000,0x0,0x0,0x0,};
  final private int[] jj_la1_2 = {0x40001,0x40001,0x0,0xf534a7e,0x0,0x0,0x0,0x0,0x400000,0x0,0x800,0x800,0x88080,0x0,0x800000,0xf534a7e,0x0,0x0,0xf534a7e,0x0,0x0,0xf534a7e,0xf534a7e,0x0,0x200730,0x200730,0x0,0x2010000,0x2010000,0x20004,0x20004,0x0,0x0,0x8,0x8,0x2010000,0x2010000,0x0,0xd52487e,0xd52487e,0x0,0x0,0xd52083e,0x0,0x0,0x0,0x0,0x200,0x200600,0x0,0x30,0x100,0x0,0x0,0x0,0x0,0x0,0x0,0x842087e,0x0,0xc52083e,0x842083e,0x0,0x842083e,0x4100000,0x0,0xc52083e,0x1000000,0xc52083e,0x2000,0x40,0x40,0xf534a7e,0x0,0xf534a7e,0x4000,0x842083e,0x842083e,0x0,0x0,0x0,0x842083e,0x842083e,0x0,0x0,0x842083e,0x0,0x0,0x200,0x1200,0x0,0x0,0xf534a7e,0x0,0xf534a7e,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x1200,0x842083e,0x0,0x0,0x0,0x0,0x0,0x0,0x1000,0x0,0x0,0x842083e,0x40000000,0x0,0x40000,0x0,0x0,0x0,0x0,0x0,0x0,0x842083e,0x40000,0x0,0x0,0x88080,0x88080,0x88080,};
  final private int[] jj_la1_3 = {0x0,0x0,0x0,0x1ffffff6,0x0,0x380,0x200,0x180,0x0,0x0,0x0,0x0,0x0,0x4000000,0x0,0x1ffffff6,0x40,0x0,0x1ffffff6,0x0,0x2000000,0x1ffffff6,0x1fff7ff6,0x0,0x1f80000,0x1f80000,0x2000,0x0,0x0,0x400,0x400,0x10000,0x10000,0x0,0x0,0x0,0x0,0x4000,0x7ff3ff6,0x7ff3ff6,0x30,0x30,0x5ff37c6,0x0,0x0,0x0,0x4000,0x18000000,0x0,0x1f80000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x2000000,0x7ff2fc2,0x4,0x5ff37c2,0x5ff27c2,0x0,0x5ff27c2,0x1000,0x800,0x5ff37c6,0x0,0x5ff37c2,0x0,0x0,0x800,0x1ffffff6,0x0,0x1ffffff6,0x0,0x5ff27c2,0x5ff23c2,0x0,0x10,0x0,0x5ff23c2,0x5ff23c2,0x0,0x0,0x5ff23c2,0x0,0x0,0x0,0x18000000,0x0,0x0,0x1ffffff6,0x0,0x1ffffff6,0x0,0x0,0x10000000,0x0,0x8000000,0x0,0x0,0x18000000,0x5ff23c2,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x7ff23c2,0x1,0x0,0x800,0x0,0x0,0x0,0x0,0x0,0x0,0x5ff23c2,0x0,0x0,0x0,0x0,0x0,0x2000000,};
  final private int[] jj_la1_4 = {0x0,0x0,0x0,0x200810,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x200810,0x0,0x0,0x200810,0x0,0x0,0x200810,0x200810,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x200810,0x200810,0x0,0x0,0x200810,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x200810,0x0,0x200810,0x200810,0x0,0x200810,0x0,0x0,0x200810,0x0,0x200810,0x0,0x0,0x0,0x200810,0x0,0x200810,0x0,0x200810,0xe0200810,0x0,0x0,0x40000000,0xe0200810,0xe0200810,0x0,0x0,0x200810,0x0,0x0,0x0,0x0,0x120,0x0,0x200810,0x0,0x200810,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x200810,0x0,0x0,0x600,0x0,0x0,0x0,0x0,0x0,0x0,0xe0200810,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x100040,0x200810,0x0,0x0,0x0,0x0,0x0,0x0,};
  final private int[] jj_la1_5 = {0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x8,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x10,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x70c7,0x20,0x0,0x2,0x70c3,0x70c7,0x10,0x800,0x800,0x700,0x700,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x18000,0x0,0x70c7,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,};
  final private int[] jj_la1_6 = {0x0,0x0,0x0,0x3a0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x3a0,0x0,0x0,0x3a0,0x0,0x0,0x3a0,0x3a0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x3a0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x3a0,0x0,0x3a0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x20,0xfbd,0x0,0x0,0x3a0,0x0,0x3a0,0x200,0x0,0x100,0x0,0x80,0x0,0xc1c,0xfbd,0x0,0xdfde0000,0xdfde0000,0x0,0x1dc0000,0xdc000000,0xdfde0000,0x1,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,};
  final private int[] jj_la1_7 = {0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x40,0x0,0x10,0x0,0x4,0x0,0x0,0x0,0x1,0x1,0x0,0x0,0x1,0x1,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,};
  final private JJCalls[] jj_2_rtns = new JJCalls[15];
  private boolean jj_rescan = false;
  private int jj_gc = 0;

  public xqueryParser(java.io.InputStream stream) {
    jj_input_stream = new JavaCharStream(stream, 1, 1);
    token_source = new xqueryParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 130; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public void ReInit(java.io.InputStream stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 130; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public xqueryParser(java.io.Reader stream) {
    jj_input_stream = new JavaCharStream(stream, 1, 1);
    token_source = new xqueryParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 130; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public void ReInit(java.io.Reader stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 130; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public xqueryParser(xqueryParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 130; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public void ReInit(xqueryParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 130; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  final private Token jj_consume_token(int kind) throws ParseException {
    Token oldToken;
    if ((oldToken = token).next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    if (token.kind == kind) {
      jj_gen++;
      if (++jj_gc > 100) {
        jj_gc = 0;
        for (int i = 0; i < jj_2_rtns.length; i++) {
          JJCalls c = jj_2_rtns[i];
          while (c != null) {
            if (c.gen < jj_gen) c.first = null;
            c = c.next;
          }
        }
      }
      return token;
    }
    token = oldToken;
    jj_kind = kind;
    throw generateParseException();
  }

  final private boolean jj_scan_token(int kind) {
    if (jj_scanpos == jj_lastpos) {
      jj_la--;
      if (jj_scanpos.next == null) {
        jj_lastpos = jj_scanpos = jj_scanpos.next = token_source.getNextToken();
      } else {
        jj_lastpos = jj_scanpos = jj_scanpos.next;
      }
    } else {
      jj_scanpos = jj_scanpos.next;
    }
    if (jj_rescan) {
      int i = 0; Token tok = token;
      while (tok != null && tok != jj_scanpos) { i++; tok = tok.next; }
      if (tok != null) jj_add_error_token(kind, i);
    }
    return (jj_scanpos.kind != kind);
  }

  final public Token getNextToken() {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    jj_gen++;
    return token;
  }

  final public Token getToken(int index) {
    Token t = lookingAhead ? jj_scanpos : token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  final private int jj_ntk() {
    if ((jj_nt=token.next) == null)
      return (jj_ntk = (token.next=token_source.getNextToken()).kind);
    else
      return (jj_ntk = jj_nt.kind);
  }

  private java.util.Vector jj_expentries = new java.util.Vector();
  private int[] jj_expentry;
  private int jj_kind = -1;
  private int[] jj_lasttokens = new int[100];
  private int jj_endpos;

  private void jj_add_error_token(int kind, int pos) {
    if (pos >= 100) return;
    if (pos == jj_endpos + 1) {
      jj_lasttokens[jj_endpos++] = kind;
    } else if (jj_endpos != 0) {
      jj_expentry = new int[jj_endpos];
      for (int i = 0; i < jj_endpos; i++) {
        jj_expentry[i] = jj_lasttokens[i];
      }
      boolean exists = false;
      for (java.util.Enumeration enum = jj_expentries.elements(); enum.hasMoreElements();) {
        int[] oldentry = (int[])(enum.nextElement());
        if (oldentry.length == jj_expentry.length) {
          exists = true;
          for (int i = 0; i < jj_expentry.length; i++) {
            if (oldentry[i] != jj_expentry[i]) {
              exists = false;
              break;
            }
          }
          if (exists) break;
        }
      }
      if (!exists) jj_expentries.addElement(jj_expentry);
      if (pos != 0) jj_lasttokens[(jj_endpos = pos) - 1] = kind;
    }
  }

  final public ParseException generateParseException() {
    jj_expentries.removeAllElements();
    boolean[] la1tokens = new boolean[232];
    for (int i = 0; i < 232; i++) {
      la1tokens[i] = false;
    }
    if (jj_kind >= 0) {
      la1tokens[jj_kind] = true;
      jj_kind = -1;
    }
    for (int i = 0; i < 130; i++) {
      if (jj_la1[i] == jj_gen) {
        for (int j = 0; j < 32; j++) {
          if ((jj_la1_0[i] & (1<<j)) != 0) {
            la1tokens[j] = true;
          }
          if ((jj_la1_1[i] & (1<<j)) != 0) {
            la1tokens[32+j] = true;
          }
          if ((jj_la1_2[i] & (1<<j)) != 0) {
            la1tokens[64+j] = true;
          }
          if ((jj_la1_3[i] & (1<<j)) != 0) {
            la1tokens[96+j] = true;
          }
          if ((jj_la1_4[i] & (1<<j)) != 0) {
            la1tokens[128+j] = true;
          }
          if ((jj_la1_5[i] & (1<<j)) != 0) {
            la1tokens[160+j] = true;
          }
          if ((jj_la1_6[i] & (1<<j)) != 0) {
            la1tokens[192+j] = true;
          }
          if ((jj_la1_7[i] & (1<<j)) != 0) {
            la1tokens[224+j] = true;
          }
        }
      }
    }
    for (int i = 0; i < 232; i++) {
      if (la1tokens[i]) {
        jj_expentry = new int[1];
        jj_expentry[0] = i;
        jj_expentries.addElement(jj_expentry);
      }
    }
    jj_endpos = 0;
    jj_rescan_token();
    jj_add_error_token(0, 0);
    int[][] exptokseq = new int[jj_expentries.size()][];
    for (int i = 0; i < jj_expentries.size(); i++) {
      exptokseq[i] = (int[])jj_expentries.elementAt(i);
    }
    return new ParseException(token, exptokseq, tokenImage);
  }

  final public void enable_tracing() {
  }

  final public void disable_tracing() {
  }

  final private void jj_rescan_token() {
    jj_rescan = true;
    for (int i = 0; i < 15; i++) {
      JJCalls p = jj_2_rtns[i];
      do {
        if (p.gen > jj_gen) {
          jj_la = p.arg; jj_lastpos = jj_scanpos = p.first;
          switch (i) {
            case 0: jj_3_1(); break;
            case 1: jj_3_2(); break;
            case 2: jj_3_3(); break;
            case 3: jj_3_4(); break;
            case 4: jj_3_5(); break;
            case 5: jj_3_6(); break;
            case 6: jj_3_7(); break;
            case 7: jj_3_8(); break;
            case 8: jj_3_9(); break;
            case 9: jj_3_10(); break;
            case 10: jj_3_11(); break;
            case 11: jj_3_12(); break;
            case 12: jj_3_13(); break;
            case 13: jj_3_14(); break;
            case 14: jj_3_15(); break;
          }
        }
        p = p.next;
      } while (p != null);
    }
    jj_rescan = false;
  }

  final private void jj_save(int index, int xla) {
    JJCalls p = jj_2_rtns[index];
    while (p.gen > jj_gen) {
      if (p.next == null) { p = p.next = new JJCalls(); break; }
      p = p.next;
    }
    p.gen = jj_gen + xla - jj_la; p.first = token; p.arg = xla;
  }

  static final class JJCalls {
    int gen;
    Token first;
    int arg;
    JJCalls next;
  }

}
